<?php
$section = 'lay_woocommerce_cart';


$wp_customize->add_section( $section,
   array(
      'title' => 'Cart',
      'priority' => 15,
      'capability' => 'edit_theme_options',
      'panel' => 'woocommerce',
   )
);

$wp_customize->add_setting( 'lay_woocommerce_proceed_to_checkout_button_text',
   array(
      'default' => 'Proceed to checkout',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_proceed_to_checkout_button_text',
        array(
            'label'          => 'Button Text',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_proceed_to_checkout_button_text',
            'type'           => 'text',
            'priority'       => 0
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_normal_cart_product_list_bg_color',
   array(
      'default' => '#ffffff',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Color_Control(
   $wp_customize,
   'lay_woocommerce_normal_cart_product_list_bg_color',
   array(
      'label' => 'Product List Background Color',
      'section' => $section,
      'settings' => 'lay_woocommerce_normal_cart_product_list_bg_color',
      'priority'   => 42
   )
) );

$wp_customize->add_setting( 'lay_woocommerce_normal_cart_remove_item_color',
   array(
      'default' => '#aeaeae',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Color_Control(
   $wp_customize,
   'lay_woocommerce_normal_cart_remove_item_color',
   array(
      'label' => '"Remove" Color',
      'section' => $section,
      'settings' => 'lay_woocommerce_normal_cart_remove_item_color',
      'priority'   => 42
   )
) );

$wp_customize->add_setting( 'lay_woocommerce_cart_product_image_width',
   array(
      'default' => 120,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_product_image_width',
        array(
            'label'          => 'Product Image Width (px)',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_product_image_width',
            'input_attrs'    => array('step' => '1', 'min' => '0', 'max' => '100'),
            'type'           => 'number',
            'priority'       => 45
        )
    )
);

// lines

$wp_customize->add_setting( 'lay_woocommerce_cart_show_line',
   array(
      'default' => true,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_show_line',
        array(
            'label'          => 'Show Border',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_show_line',
            'type'           => 'checkbox',
            'priority'       => 50,
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_cart_line_color',
   array(
      'default' => '#000',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Color_Control(
   $wp_customize,
   'lay_woocommerce_cart_line_color',
   array(
      'label' => 'Border Color',
      'section' => $section,
      'settings' => 'lay_woocommerce_cart_line_color',
      'priority'   => 50
   )
) );

// products textformat
$wp_customize->add_setting( 'lay_woocommerce_cart_product_textformat',
   array(
      'default' => 'Shop_Cart',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_product_textformat',
        array(
            'label'          => 'Product List Text Format',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_product_textformat',
            'type'           => 'select',
            'priority'       => 60,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);

// totals textformat
$wp_customize->add_setting( 'lay_woocommerce_cart_collaterals_textformat',
   array(
      'default' => 'Shop_Big',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_collaterals_textformat',
        array(
            'label'          => 'Product Totals Format',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_collaterals_textformat',
            'type'           => 'select',
            'priority'       => 60,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);

