<?php
$section = 'lay_woocommerce_cart_icon_mobile';

$wp_customize->add_section( $section,
   array(
      'title' => 'Cart Icon Mobile',
      'priority' => 16,
      'capability' => 'edit_theme_options',
      'panel' => 'woocommerce',
      'description' => 'This is just a cart icon on the top right of your website.',
   )
);

$wp_customize->add_setting( 'lay_woocommerce_cart_icon_mobile_hide',
   array(
      'default' => false,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   ) 
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_icon_mobile_hide',
        array(
            'label'          => 'Always hide icon',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_icon_mobile_hide',
            'description'    => '(Cart menupoint <a target="_blank" href="https://laytheme.com/documentation/shop-setup.html#cart-menu-point">needs to be added to mobile menu</a>)',
            'type'           => 'checkbox',
            'priority'       => 0,
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_cart_icon_mobile_hide_empty',
   array(
      'default' => 0,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_icon_mobile_hide_empty',
        array(
            'label'          => 'Hide Icon/Text when empty',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_icon_mobile_hide_empty',
            'type'           => 'checkbox',
            'priority'       => 5,
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_cart_icon_mobile_use_text',
   array(
      'default' => 0,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_icon_mobile_use_text',
        array(
            'label'          => 'Use Text instead of Icon',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_icon_mobile_use_text',
            'type'           => 'checkbox',
            'priority'       => 15,
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_cart_icon_mobile_text',
   array(
      'default' => 'Cart',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   ) 
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_icon_mobile_text',
        array(
            'label'          => 'Text',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_icon_mobile_text',
            'type'           => 'text',
            'priority'       => 15,
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_cart_icon_mobile_text_spacetop',
   array(
      'default' => 10,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   ) 
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_icon_mobile_text_spacetop',
        array(
            'label'          => 'Text Space Top (px)',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_icon_mobile_text_spacetop',
            'type'           => 'number',
            'priority'       => 15,
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_cart_icon_mobile_textformat',
   array(
      'default' => 'Default',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_cart_icon_mobile_textformat',
        array(
            'label'          => 'Textformat',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_cart_icon_mobile_textformat',
            'type'           => 'select',
            'priority'       => 20,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);