<?php
$section = 'woocommerce_checkout';

// textformat
$wp_customize->add_setting( 'lay_woocommerce_checkout_product_textformat',
   array(
      'default' => 'Shop_Big',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_product_textformat',
        array(
            'label'          => 'Checkout Text Format',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_product_textformat',
            'type'           => 'select',
            'priority'       => 20,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);

$checkout_textformat = get_theme_mod('lay_woocommerce_checkout_product_textformat', 'Shop_Big');
$wp_customize->add_setting( 'lay_woocommerce_checkout_headlines_textformat',
   array(
      'default' => $checkout_textformat,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_headlines_textformat',
        array(
            'label'          => 'Checkout Headlines Text Format',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_headlines_textformat',
            'type'           => 'select',
            'priority'       => 20,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);

$checkout_textformat = get_theme_mod('lay_woocommerce_checkout_product_textformat', 'Shop_Big');
$wp_customize->add_setting( 'lay_woocommerce_checkout_ship_to_different_address_textformat',
   array(
      'default' => $checkout_textformat,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_ship_to_different_address_textformat',
        array(
            'label'          => '"Ship to a different address?" Text Format',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_ship_to_different_address_textformat',
            'type'           => 'select',
            'priority'       => 20,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_checkout_input_bg_color',
   array(
      'default' => '#ffffff',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Color_Control(
   $wp_customize,
   'lay_woocommerce_checkout_input_bg_color',
   array(
      'label' => 'Inputs Background Color',
      'section' => $section,
      'settings' => 'lay_woocommerce_checkout_input_bg_color',
      'priority'   => 20
   )
) );

$wp_customize->add_setting( 'lay_woocommerce_checkout_input_show_borders',
   array(
      'default' => true,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_input_show_borders',
        array(
            'label'          => 'Show Input Borders',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_input_show_borders',
            'type'           => 'checkbox',
            'priority'       => 20,
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_checkout_input_border_color',
   array(
      'default' => '#000000',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Color_Control(
   $wp_customize,
   'lay_woocommerce_checkout_input_border_color',
   array(
      'label' => 'Inputs Background Color',
      'section' => $section,
      'settings' => 'lay_woocommerce_checkout_input_border_color',
      'priority'   => 20
   )
) );

$wp_customize->add_setting( 'lay_woocommerce_checkout_input_placeholder_text_color',
   array(
      'default' => '#868686',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Color_Control(
   $wp_customize,
   'lay_woocommerce_checkout_input_placeholder_text_color',
   array(
      'label' => 'Input Placeholder Text Color',
      'section' => $section,
      'settings' => 'lay_woocommerce_checkout_input_placeholder_text_color',
      'priority'   => 20
   )
) );

$wp_customize->add_setting( 'lay_woocommerce_checkout_space_between_inputs',
   array(
      'default' => 30,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_space_between_inputs',
        array(
            'label'          => 'Space between Inputs (px)',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_space_between_inputs',
            'input_attrs'    => array('step' => '1', 'min' => '0', 'max' => '100'),
            'type'           => 'number',
            'priority'       => 20
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_checkout_additional_fields_gap',
   array(
      'default' => 30,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_additional_fields_gap',
        array(
            'label'          => 'Additional information Fields Gap (px)',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_additional_fields_gap',
            'input_attrs'    => array('step' => '1', 'min' => '0', 'max' => '100'),
            'type'           => 'number',
            'priority'       => 20,
            'description' => 'This gap may be needed if you have additional fields in your checkout form. If not, you can set it to 0.'
        )
    )
);

// .shipping_address
$wp_customize->add_setting( 'lay_woocommerce_checkout_space_under_shipping_address',
   array(
      'default' => 30,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_space_under_shipping_address',
        array(
            'label'          => 'Space between Shipping Address and Order Notes (px)',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_space_under_shipping_address',
            'input_attrs'    => array('step' => '1', 'min' => '0', 'max' => '100'),
            'type'           => 'number',
            'priority'       => 20,
            'description' => 'This space will be shown if "Ship to a different address?" is enabled.'
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_checkout_coupon_gap',
   array(
      'default' => 0,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_coupon_gap',
        array(
            'label'          => 'Gap between coupon input field and button (px)',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_coupon_gap',
            'input_attrs'    => array('step' => '1', 'min' => '0', 'max' => '100'),
            'type'           => 'number',
            'priority'       => 20,
        )
    )
);


$wp_customize->add_setting( 'lay_woocommerce_checkout_order_review',
   array(
      'default' => 'Shop_Big',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_order_review',
        array(
            'label'          => 'Checkout Totals Text Format',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_order_review',
            'type'           => 'select',
            'priority'       => 30,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);


$wp_customize->add_setting( 'lay_woocommerce_checkout_payment',
   array(
      'default' => 'Shop_Big',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_checkout_payment',
        array(
            'label'          => 'Checkout Payment Text Format',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_checkout_payment',
            'type'           => 'select',
            'priority'       => 40,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);