<?php

$section = 'productsgrid_filter';

$wp_customize->add_section( $section,
   array(
      'title' => 'Product Thumbnail Grid Category Filter',
      'priority' => 22,
      'capability' => 'edit_theme_options',
      'panel' => 'woocommerce',
      'description' => '<p>These are settings for the Category Filter of a Product Thumbnail Grid Element.</p><p>How to activate the Category Filter: Check "Show Category Filter" when adding a Product Thumbnail Grid via "+WooCommerce" &rarr; "+Product Thumbnail Grid" in the Gridder.</p>'
   )
);

$wp_customize->add_setting( 'pgf_transition',
   array(
      'default' => 'fade_out_fade_in_2',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_transition',
        array(
            'label'          => 'Transition',
            'section'        => $section,
            'settings'       => 'pgf_transition',
            'type'           => 'select',
            'priority'       => 0,
            'choices'        => array( 'fade_out_fade_in_2' => 'Fade out fade in 2', 'fade_out_fade_in' => 'Fade out fade in', 'none' => 'None' )
        )
    )
);

$wp_customize->add_setting( 'pgf_spacebetween_2',
   array(
      'default' => '10',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_spacebetween_2',
        array(
            'label'          => 'Space between (px)',
            'section'        => $section,
            'settings'       => 'pgf_spacebetween_2',
            'type'           => 'number',
            'priority'       => 2,
            'input_attrs'    => array('step' => '1', 'min' => 0),
        )
    )
);


$wp_customize->add_setting( 'pgf_spacebelow',
   array(
      'default' => '20',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_spacebelow',
        array(
            'label'          => 'Space below (px)',
            'section'        => $section,
            'settings'       => 'pgf_spacebelow',
            'type'           => 'number',
            'priority'       => 5,
            'input_attrs'    => array('step' => '1', 'min' => 0),
        )
    )
);


$wp_customize->add_setting( 'pgf_textformat',
   array(
      'default' => 'Default',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_textformat',
        array(
            'label'          => 'Text Format',
            'section'        => $section,
            'settings'       => 'pgf_textformat',
            'type'           => 'select',
            'priority'       => 10,
            'choices'        => Customizer::$textformatsSelect
        )
    )
);
$wp_customize->selective_refresh->add_partial( 'pgf_textformat', array(
    'selector' => '.lay-productsgrid-filter',
    'container_inclusive' => false,
    'render_callback' => function() {
        echo LayProductsgridFunctions::lay_get_productsgrid_category_filter_markup();
    },
) );

$wp_customize->add_setting( 'pgf_fontfamily',
   array(
      'default' => Customizer::$defaults['fontfamily'],
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
// http://codex.wordpress.org/Class_Reference/WP_Customize_Control
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_fontfamily',
        array(
            'label'          => 'Font Family',
            'section'        => $section,
            'settings'       => 'pgf_fontfamily',
            'type'           => 'select',
            'choices'        => Customizer::$fonts,
            'priority'       => 35
        )
    )
);

$wp_customize->add_setting( 'pgf_fontsize_mu',
   array(
      'default' => 'px',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_fontsize_mu',
        array(
            'label'          => 'Font Size in',
            'section'        => $section,
            'settings'       => 'pgf_fontsize_mu',
            'type'           => 'select',
            'priority'       => 38,
            'choices'        => array('px' => 'px', 'vw' => '%')
        )
    )
);

$wp_customize->add_setting( 'pgf_fontsize',
   array(
      'default' => Customizer::$defaults['fontsize'],
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
// http://codex.wordpress.org/Class_Reference/WP_Customize_Control
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_fontsize',
        array(
            'label'          => 'Font Size',
            'section'        => $section,
            'settings'       => 'pgf_fontsize',
            'type'           => 'number',
            'input_attrs'    => array('step' => '0.1'),
            'priority'       => 40
        )
    )
);

$wp_customize->add_setting( 'pgf_fontweight',
   array(
      'default' => Customizer::$defaults['fontweight'],
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_fontweight',
        array(
            'label'          => 'Font Weight',
            'section'        => $section,
            'settings'       => 'pgf_fontweight',
            'type'           => 'select',
            'choices'        => array_flip(FormatsManager::$fontWeights),
            'priority'       => 45
        )
    )
);

$wp_customize->add_setting( 'pgf_color',
   array(
      'default' => Customizer::$defaults['color'],
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
$wp_customize->add_control( new WP_Customize_Color_Control(
   $wp_customize,
   'pgf_color',
   array(
      'label' => 'Text Color',
      'section' => $section,
      'settings' => 'pgf_color',
      'priority'   => 50
   )
) );

$wp_customize->add_setting( 'pgf_letterspacing',
   array(
      'default' => Customizer::$defaults['letterspacing'],
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_letterspacing',
        array(
            'label'          => 'Letter Spacing (em)',
            'section'        => $section,
            'settings'       => 'pgf_letterspacing',
            'input_attrs'    => array('step' => '0.01'),
            'type'           => 'number',
            'priority'       => 55
        )
    )
);

$wp_customize->add_setting( 'pgf_align',
   array(
      'default' => 'left',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_align',
        array(
            'label'          => 'Alignment',
            'section'        => $section,
            'settings'       => 'pgf_align',
            'type'           => 'select',
            'priority' => 57,
            'choices'        => array('left' => 'left', 'center' => 'center', 'right' => 'right'),
        )
    )
);

$wp_customize->add_setting( 'pgf_opacity',
   array(
      'default' => 50,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Control(
   $wp_customize,
   'pgf_opacity',
   array(
      'label' => 'Opacity (%)',
      'section' => $section,
      'settings' => 'pgf_opacity',
      'type' => 'number',
      'input_attrs' => array('min' => '0', 'max' => '100'),
      'priority' => 60,
   )
) );

$wp_customize->add_setting( 'pgf_mouseover_opacity',
   array(
      'default' => 100,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Control(
   $wp_customize,
   'pgf_mouseover_opacity',
   array(
      'label' => 'Mouseover Opacity (%)',
      'section' => $section,
      'settings' => 'pgf_mouseover_opacity',
      'type' => 'number',
      'input_attrs' => array('min' => '0', 'max' => '100'),
      'priority' => 65,
   )
) );


$wp_customize->add_setting( 'pgf_active_color',
   array(
      'default' => get_theme_mod('pgf_active_color', Customizer::$defaults['color']),
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'postMessage',
   )
);
$wp_customize->add_control( new WP_Customize_Color_Control(
   $wp_customize,
   'pgf_active_color',
   array(
      'label' => 'Active Text Color',
      'section' => $section,
      'settings' => 'pgf_active_color',
      'priority'   => 70
   )
) );

$wp_customize->add_setting( 'pgf_active_opacity',
   array(
      'default' => 100,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Control(
   $wp_customize,
   'pgf_active_opacity',
   array(
      'label' => 'Active Opacity (%)',
      'section' => $section,
      'settings' => 'pgf_active_opacity',
      'type' => 'number',
      'input_attrs' => array('min' => '0', 'max' => '100'),
      'priority' => 70,
   )
) );

$wp_customize->add_setting( 'pgf_active_strokewidth',
   array(
      'default' => 0,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control( new WP_Customize_Control(
   $wp_customize,
   'pgf_active_strokewidth',
   array(
      'label' => 'Active Underline Strokewidth',
      'description' => 'Underline Offset settings are the ones used in "Customize" → "Links in Texts"',
      'section' => $section,
      'settings' => 'pgf_active_strokewidth',
      'type'           => 'number',
      'priority' => 75,
   )
) );

$wp_customize->add_setting( 'pgf_oneline',
   array(
      'default' => get_theme_mod('pgf_oneline', 1),
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_oneline',
        array(
            'label'          => 'For Mobile put tags in a scrollable line',
            'section'        => $section,
            'settings'       => 'pgf_oneline',
            'type'           => 'checkbox',
            'priority'       => 80,
        )
    )
);

$wp_customize->add_setting( 'pgf_spacebetween_mobile',
   array(
      'default' => '10',
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'pgf_spacebetween_mobile',
        array(
            'label'          => 'Mobile Space between (px)',
            'section'        => $section,
            'settings'       => 'pgf_spacebetween_mobile',
            'type'           => 'number',
            'priority'       => 90,
            'input_attrs'    => array('step' => '1', 'min' => 0),
        )
    )
);