<?php

$section = 'lay_woocommerce_single_product_order';
$descr = 'Change the order of Title, Price, Add to Cart button and more by changing the numbers below. To automatically preview a different product here, go to  "Products" → "Sorting" and move a product to the top.';

$wp_customize->add_section( $section,
   array(
      'title' => 'Single Product Order',
      'priority' => 6,
      'capability' => 'edit_theme_options',
      'panel' => 'woocommerce',
      'description'    => $descr
   )
);

$wp_customize->add_setting( 'lay_woocommerce_singleproduct_order_breadcrumbs',
   array(
      'default' => 0,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_singleproduct_order_breadcrumbs',
        array(
            'label'          => 'Breadcrumbs',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_singleproduct_order_breadcrumbs',
            'type'           => 'number',
            'priority'       => 0
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_singleproduct_order_title',
   array(
      'default' => 1,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_singleproduct_order_title',
        array(
            'label'          => 'Title',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_singleproduct_order_title',
            'type'           => 'number',
            'priority'       => 0
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_singleproduct_order_brands',
   array(
      'default' => 2,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_singleproduct_order_brands',
        array(
            'label'          => 'Brands',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_singleproduct_order_brands',
            'type'           => 'number',
            'priority'       => 0
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_singleproduct_order_short_description',
   array(
      'default' => 3,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_singleproduct_order_short_description',
        array(
            'label'          => 'Short Description',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_singleproduct_order_short_description',
            'type'           => 'number',
            'priority'       => 0
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_singleproduct_order_price',
   array(
      'default' => 4,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_singleproduct_order_price',
        array(
            'label'          => 'Price',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_singleproduct_order_price',
            'type'           => 'number',
            'priority'       => 0
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_singleproduct_order_form',
   array(
      'default' => 5,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_singleproduct_order_form',
        array(
            'label'          => 'Add to Cart, Variations, Quantity',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_singleproduct_order_form',
            'type'           => 'number',
            'priority'       => 0
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_singleproduct_order_tabs',
   array(
      'default' => 6,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_singleproduct_order_tabs',
        array(
            'label'          => 'Tabs or Description',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_singleproduct_order_tabs',
            'type'           => 'number',
            'priority'       => 0
        )
    )
);

$wp_customize->add_setting( 'lay_woocommerce_singleproduct_order_other',
   array(
      'default' => 7,
      'type' => 'theme_mod',
      'capability' => 'edit_theme_options',
      'transport' => 'refresh',
   )
);
$wp_customize->add_control(
    new WP_Customize_Control(
        $wp_customize,
        'lay_woocommerce_singleproduct_order_other',
        array(
            'label'          => 'Other things added by plugins like express checkout',
            'section'        => $section,
            'settings'       => 'lay_woocommerce_singleproduct_order_other',
            'type'           => 'number',
            'priority'       => 0
        )
    )
);