<div class="wrap">
<h2><?php _e('Webfonts', 'lay') ?></h2>
<form method="post" action="options.php">

    <?php if(isset( $_GET['settings-updated'])) { ?>
    <div class="updated">
        <p><?php _e('Webfonts updated.', 'lay') ?></p>
    </div>
    <?php } ?>
    <div class="lay-explanation add-webfont-explanation <?php echo get_option('expand-how_to_add_webfont', 'expanded'); ?>" data-expand-status-option-name="expand-how_to_add_webfont">
        <header>
            <h3 class="title"><?php _e('How to add a Webfont', 'lay') ?></h3>
            <button class="lay-explanation-handle"></button>
        </header>
        <div class="lay-explanation-inner">
            <h2 style="padding-top: 0;"><?php _e('Add by font file', 'lay') ?></h2>
            <h3 class="title"><?php _e('About font files', 'lay') ?></h3>
            <p>
                <?php _e('You can use .ttf, .woff2 or .woff files. The .woff font-format is the most widely supported Webfont format.', 'lay') ?>
                <br><?php _e('Make sure you are using a free webfont or have bought a webfont-license for this font!', 'lay') ?>
            </p>
            <p>
                <?php _e('Don\'t have a .ttf, .woff2 or .woff? You can convert your font file to a supported format on', 'lay') ?> <a target="_blank" href="https://everythingfonts.com/">everythingfonts.com</a> &rarr; "Font Conversion".
            </p>
            <h3 class="title"><?php _e('Upload your font file', 'lay') ?></h3>
            <p>
                <?php _e('Click on', 'lay') ?> <span class="lay-label label-info"><?php _e('+ Add Font', 'lay') ?></span> <?php _e('below and then on', 'lay') ?> <span class="lay-label label-info"><?php _e('Add by file', 'lay') ?></span> <?php _e('to upload your file.', 'lay') ?>
            </p>

            <h2 style="padding-top: 30px;"><?php _e('Add by "&lt;link&gt;" tag and CSS', 'lay') ?></h2>
            <p>
                <?php _e('Click on', 'lay') ?> <span class="lay-label label-info"><?php _e('+ Add Font', 'lay') ?></span> <?php _e('below and then on', 'lay') ?> <span class="lay-label label-info"><?php _e('Add by "&lt;link&gt;" tag and CSS', 'lay') ?></span>. <?php _e('Enter a font name, the "&lt;link&gt;" tag and your font-family CSS rule.', 'lay') ?>
            </p>

            <h2 style="padding-top: 30px;"><?php _e('Add by "&lt;script&gt;" tag and CSS', 'lay') ?></h2>
            <p>
                <?php _e('Click on', 'lay') ?> <span class="lay-label label-info"><?php _e('+ Add Font', 'lay') ?></span> <?php _e('below and then on', 'lay') ?> <span class="lay-label label-info"><?php _e('Add by "&lt;script&gt;" tag and CSS', 'lay') ?></span>. <?php _e('Enter a font name, the JavaScript code and your font-family CSS rule.', 'lay') ?><br>
                <?php _e('Please note that Webfonts added by "&lt;script&gt;" tag and CSS are not displayed correctly in the text editor. Also, here in the Webfonts Manager they will only be displayed correctly after you clicked', 'lay') ?> <span class="lay-label label-info"><?php _e('Save Changes', 'lay') ?></span>.
                <!-- Remember to click <span class="lay-label label-info">Save Changes</span> when you are done. -->
            </p>

            <h2 style="padding-top: 30px;" class="title"><?php _e('Usage', 'lay') ?></h2>
            <p>
                <?php _e('After you added your Webfont it is ready to use. It will appear in the "Font Family" dropdown menus in', 'lay') ?> <a href="<?php echo admin_url( 'admin.php?page=manage-textformats' ); ?>"><?php _e('Text Formats', 'lay') ?></a><?php _e(', in the Customizer and when you edit texts in "Projects" and "Pages".', 'lay') ?>
            </p>
        </div>
    </div>

    <div id="fontmanager">

    </div>

    <?php settings_fields( 'manage-webfonts' ); ?>
    <?php do_settings_sections( 'manage-webfonts' ); ?>

    <?php submit_button(); ?>
</form>
</div>
<?php
// on an older php version i saw that underscore js templates get interpreted as php
// when in reality its just html outside the php wrap. having it inside the php wrap and echoing it works
echo
'<script type="text/template" id="row-composite-view">
    <div class="panel panel-default fontmanager-panel">
      <div class="panel-heading">
        <h3 class="panel-title">'.__('Font Manager', 'lay').'</h3>
      </div>
      <table class="table font-table table-bordered">
        <thead>
          <tr>
            <th>'.__('Font Name', 'lay').'</th>
            <th>'.__('Test Sentence', 'lay').'</th>
            <th>'.__('Type', 'lay').'</th>
            <th></th>
          </tr>
        </thead>
        <tbody class="rows">
        </tbody>
      </table>
      <div class="panel-footer clearfix">
        <button type="button" class="btn btn-info js-add-font btn-sm pull-right"><span class="glyphicon glyphicon-plus"></span> '.__('Add Font', 'lay').'</button>
      </div>
    </div>

    <!-- modal -->
    <div id="add-webfont-input-modal" class="lay-input-modal">
        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title">'.__('Add Webfont', 'lay').'</h3>
                <h3 class="panel-title panel-title-editmode">'.__('Edit Webfont', 'lay').'</h3>
                <button type="button" class="close close-modal-btn"><span aria-hidden="true">&times;</span><span class="sr-only">'.__('Close', 'lay').'</span></button>
            </div>
            <div class="panel-body">

                <div class="alert alert-warning edit-mode-warning" role="alert"><strong>'.__('About Editing:', 'lay').'</strong> '.__('Is this font currently in use on your website? When you edit this font and save the changes, you will need to re-apply this font wherever you have been using it to see the changes. If you need to change the font of Texts, it\'s easier to add a new Webfont and use Textformats.', 'lay').'</div>

                <div class="webfont-type-choice-wrap">
                    <span class="woff-tooltip" data-toggle="tooltip" data-placement="top" title="'.__('Make sure your filename does not start with a number and does not contain spaces or special signs.', 'lay').'">
                        <button type="button" class="btn btn-info js-upload-woff-btn">'.__('Add by file', 'lay').' (.woff/.woff2/.ttf)</button>
                    </span>
                    <button type="button" class="btn btn-info js-link-css-btn">'.__('Add by "&lt;link&gt;" tag and CSS', 'lay').'</button>
                    <button type="button" class="btn btn-info js-js-css-btn">'.__('Add by "&lt;script&gt;" tag and CSS', 'lay').'</button>
                </div>

                <form class="js-css-modal lay-webfont-form">
                    <div class="alert alert-warning" role="alert">
                        '.__('Please note that Webfonts added by "&lt;script&gt;" tag and CSS are not displayed correctly in the text editor. Also, here in the Webfonts Manager they will only be displayed correctly after you clicked', 'lay').' <span class="lay-label label-info">'.__('Save Changes', 'lay').'</span>.
                    </div>
                    <p>'.__('Please insert your "Font name", "JavaScript Embed Code" and your "font-family" CSS below.', 'lay').' '.__('Don\'t insert any other CSS styles like "font-weight" or "font-style"!', 'lay').'</p>
                    <p>'.__('Font name:', 'lay').'</p>
                    <input type="text" class="form-control js-js-font-name-input" data-parsley-nonumberasfirstchar data-parsley-type="alphanum" data-parsley-errors-messages-disabled placeholder="FiraSans2">
                    <p>'.__('JavaScript Code:', 'lay').'</p>
                    <input type="text" class="form-control js-js-embed-code" data-parsley-scripttag data-parsley-errors-messages-disabled placeholder="&lt;script src=\'//use.typekit.net/xxxxxxx.js\'&gt;&lt;/script&gt;&lt;script&gt;try{Typekit.load();}catch(e){}&lt;/script&gt;">
                    <p>"font-family" CSS:</p>
                    <input type="text" class="form-control js-js-font-family-input" data-parsley-fontfamily data-parsley-errors-messages-disabled placeholder="font-family: \'fira-sans-2\',sans-serif;">
                </form>

                <form class="link-css-modal lay-webfont-form">
                    <p>'.__('Please insert your "Font name", "Link tag" and "font-family" CSS below.', 'lay').'<br>'.__('Don\'t insert any other CSS styles like "font-weight" or "font-style"!', 'lay').'</p>
                    <p>'.__('Font name', 'lay').':</p>
                    <input type="text" class="form-control js-link-font-name-input" data-parsley-nonumberasfirstchar data-parsley-type="alphanum" data-parsley-errors-messages-disabled placeholder="Montserrat">
                    <p>'.__('Link tag:', 'lay').'</p>
                    <input type="text" class="form-control js-link-tag-input" data-parsley-linktag data-parsley-errors-messages-disabled placeholder="<link href=\'http://fonts.googleapis.com/css?family=Montserrat:400,700\' rel=\'stylesheet\' type=\'text/css\'>">
                    <p>"font-family" CSS:</p>
                    <input type="text" class="form-control js-link-font-family-input" data-parsley-fontfamily data-parsley-errors-messages-disabled placeholder="font-family: \'Montserrat\', sans-serif;">
                </form>

            </div>
            <div class="panel-footer clearfix">
                <button type="button" class="btn btn-default btn-lg js-ok-button js-add-link-font-btn" disabled="disabled" style="display:none;">Ok</button>
                <button type="button" class="btn btn-default btn-lg js-ok-button js-add-js-font-btn" disabled="disabled" style="display:none;">Ok</button>
            </div>
        </div>
        <div class="background"></div>
    </div>
</script>

<script type="text/template" id="row-view">
    <td class="fontname" <%= showFontCSS() %>><%= showFontName() %></td>
    <td class="font-preview" <%= showFontCSS() %>><%= showText() %></td>
    <td class="font-type"><%= showTypeDetailed() %></td>
    <td><button data-type="<%= showType() %>" type="button" class="btn btn-default btn-sm js-edit-row btn-block"><span class="glyphicon glyphicon-pencil"></span> '.__('Edit', 'lay').'</button>
    <button type="button" class="btn btn-default btn-sm js-delete-row btn-block"><span class="glyphicon glyphicon-remove"></span> '.__('Remove', 'lay').'</button></td>
</script>';
