<?php

// todo: srcset needs h attribute too?

// todo: put this into a function in utility?:
/*

            $sizesToBeFilled = ['_265', '_512', '_768', '_1024', '_1280', '_1920', '_2560', '_3200', '_3840', '_4096'];

            foreach($sizes as $key => $value) {
                if( array_search($key, $sizesToBeFilled) !== false ){
                    $src = $value;
                    $src = LTUtility::getFullURL($src);
        
                    $srcset = $src.' '.substr($key, 1).'w, ' . $srcset;
                    $ix = array_search($key, $sizesToBeFilled);

                    if($ix !== false){
                        array_splice( $sizesToBeFilled, $ix, 1 );
                    }
                }
            }
            // fill rest of sizes with full image
            for($i=0; $i<count($sizesToBeFilled); $i++){
                $srcset .= $full_src.' '.substr($sizesToBeFilled[$i], 1).'w, ';
            }
            $srcet = substr($srcset, 0, -2);

*/

class LayElFunctions{

    public function __construct(){

    }

    public static function getUnmuteButtonMarkup( $model ){
        $unmuteButtonStyle = 1;
        if( array_key_exists('unmuteButtonStyle', $model) ){
            $unmuteButtonStyle = $model['unmuteButtonStyle'];
        }
        return
        '<div class="lay-mute-unmute-button lay-unmute-button-style-'.$unmuteButtonStyle.'">
            <svg class="lay-volume-off" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="-502 376 18 18" style="enable-background:new -502 376 18 18;" xml:space="preserve">
                <style type="text/css">
                    .st0{fill:#FFFFFF;}
                    .st1{fill:none;stroke:#FFFFFF;stroke-width:2;stroke-miterlimit:10;}
                </style>
                <g id="Layer_2">
                    <g id="Layer_1-2">
                        <g id="Volume_Off">
                            <path class="st0" d="M-502,382v6h4l5,5v-16l-5,5H-502z"/>
                            <path class="st1" d="M-484.7,381.7l-6.6,6.6 M-491.3,381.7l6.6,6.6"/>
                        </g>
                    </g>
                </g>
            </svg>
            <svg class="lay-volume-on" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="-502 376.2 18 18" style="enable-background:new -502 376.2 18 18;" xml:space="preserve">
                <style type="text/css">
                    .st0{fill:#FFFFFF;}
                </style>
                <g id="Layer_2">
                    <g id="Layer_1-2">
                        <g id="Volume_On">
                            <path class="st0" d="M-502,382.2v6h4l5,5v-16l-5,5H-502z M-488.5,385.2c0-1.7-1-3.2-2.5-4v8
                                C-489.5,388.5-488.5,386.9-488.5,385.2z M-491,376.5v2.1c3.7,1.1,5.8,5,4.7,8.7c-0.7,2.3-2.4,4-4.7,4.7v2.1
                                c4.8-1.1,7.9-5.9,6.7-10.8C-485,379.9-487.6,377.2-491,376.5z"/>
                        </g>
                    </g>
                </g>
            </svg>
        </div>';
    }

    // note to myself: html5 video in thumbnail.php is not generated by this
    public static function getHTML5VideoMarkup($videoConfig) {
        $model = $videoConfig['model'];

        $useExternalVideo = array_key_exists('useExternalVideo', $model) && $model['useExternalVideo'] == true ? true : false;
        $poster = '';
        $lazyload = !$videoConfig['noLazyLoad'];
        $lazyLoadClass = $lazyload == true ? 'video-lazyload' : 'no-lazyload';

        // using new lazyload library:
        // $lazyLoadClass = $lazyload == true ? 'lazyload' : 'no-lazyload';
        $playsinline = 'playsinline';

        $loadedClass = $lazyload ? '' : 'loaded';
    
        $markup = '';

        $pb = $useExternalVideo ? (int)$model['externalVideoH'] / (int)$model['externalVideoW'] * 100 : $model['ar'] * 100;
        $autoplay_class = $model['autoplay'] == true ? 'autoplay' : '';

        // cannot do "autoplay" because this would make 'preload="none"' not work.
        /*
        The autoplay attribute has precedence over preload. If autoplay is specified, the browser would obviously need to start downloading the video for playback.
        */
        // https://developer.mozilla.org/en-US/docs/Web/HTML/Element/video
        $autoplay_attr = $model['autoplay'] == true ? 'data-autoplay' : '';
        
        if( $lazyload == false && $model['autoplay'] == true ) {
            $autoplay_attr = 'autoplay';
        }

        // preload="none" is ignored when autoplay is on
        // when having a desktop and cpl layout, this will load all videos on an iphone but
        // i need to do this for now, because somehow, html5 videos didnt load at all anymore on iphones
        // if( LTUtility::$isTouchDevice ) {
        //     $autoplay_attr = $model['autoplay'] == true ? 'autoplay' : '';
        // }
        
        $mute = $model['mute'] == true ? 'muted' : '';
        // every autoplay video must be muted, otherwise safari will not autoplay it when scrolled to in "play_pause_autoplay_videos_on_scroll.js"
        if($model['autoplay'] == true){
            $mute = 'muted';
        }
    
        $loop = $model['loop'] == true ? 'loop' : '';
        $controls = $model['controls'] == true ? 'controls' : '';
        $playIcon = "";
        if( $model['playicon'] == true ){
            $src = get_template_directory_uri().'/frontend/assets/img/play.svg';
            if(LayFrontend_Options::$playicon != ""){
                $src = LayFrontend_Options::$playicon;
            }
            $playIcon = '<img class="html5video-customplayicon" src="'.$src.'">';
        }

        $playpauseonclick = array_key_exists('playpauseonclick', $model) ? $model['playpauseonclick'] : false;
        $playpauseonclick_class = 'playpauseonclick';
    
        if( $playpauseonclick ) {
            $playpauseonclick = true;
        }
    
        if( $playpauseonclick == false){
            $playpauseonclick_class = '';
        }
        
        $ar = $useExternalVideo ? (int)$model['externalVideoH'] / (int)$model['externalVideoW'] : $model['ar'];
        $sizingClass = $ar > $model['imgar'] ? 'h100' : 'w100';

        $placeholderImage = "";
        $html_class = '';
        if($videoConfig['showPlaceholderImage'] == true){
            // clone
            $newmodel = json_decode( json_encode($model), true);
            // changing keys to fit for "getLazyImg"
            // setting imgar to ar, otherwise the lazy sizes image's ar is just the video's ar
            if( array_key_exists('imgar', $model) ){
                $imgar = $model['imgar'];
                $newmodel['ar'] = $imgar;
            }
            if( array_key_exists('imgattid', $model) ){
                $imgattid = $model['imgattid'];
                $newmodel['attid'] = $imgattid;
            }

            $html_class .= 'has-placeholder-image';

            $placeholderImage = '<div class="html5-video-placeholder-image '.$sizingClass.' '.$playpauseonclick_class.'">'.LayElFunctions::getLazyImg($newmodel).'</div>';
        }

        if( is_array($model['sizes']) ) {
            $sizes = $model['sizes'];
            $full = '';
            if( array_key_exists('imgattid', $model) ){
                $imgattid = $model['imgattid'];
                $full = wp_get_attachment_image_src( $imgattid, 'full' );
                if(is_array($full)) {
                    $full = $full[0];
                }
            }else{
                $full = LTUtility::getFullURL($sizes['full']);
            }
    
            $poster = 'poster="'.$full.'"';
            if( array_key_exists('_512', $sizes) ) {
                $_512 = '';
                if( array_key_exists('imgattid', $model) ){
                    $_512 = wp_get_attachment_image_src( $imgattid, '_512' );
                    if( $_512 != false ) {
                        $_512 = $_512[0];
                    } else {
                        $_512 = $full;
                    }
                }else{
                    $_512 = LTUtility::getFullURL($sizes['_512']);
                }
                
                $poster = 'poster="'.$_512.'"';
            }
        }
        
        // don't need poster when I'm not on touch device
        // if ( LTUtility::$isTouchDevice == false ) {
        // 	$poster = '';
        // }
        // else if( LTUtility::$isTouchDevice && $model['autoplay'] == true ) {
        // if( LTUtility::$isTouchDevice && $model['autoplay'] == true ) {
            // if i'm on touchdevice, do not show "html5-video-placeholder-image" when autoplay is on
            // what do I need "html5-video-placeholder-image" for? Why not just use the "poster" attribute only?
            // probably for having a nice fade-in effect when the video loads and srcset
            // answer: for being able to load responsive sized images
            // $placeholderImage = "";
        // }
        // if( LTUtility::$supportsPlaysInlineOnTouchDevice && $model['autoplay'] == true ) {
            // no need for poster here
            // $poster = '';
        // }

        // when autoplay is on, use low-res poster attribute
        // when autoplay is off, use high-res placeholder image that fades in too
        if( $model['autoplay'] == true ) {
            $placeholderImage = "";
        } else {
            $poster = '';
        }

        $mp4 = '';
        if($useExternalVideo){
            $mp4 = $model['externalVideoUrl'];
        } else {
            $mp4 = $model['mp4'];
            if( array_key_exists('mp4attid', $model) ) {
                $mp4 = wp_get_attachment_url($model['mp4attid']);
            } else {
                $mp4 = LTUtility::getFullURL($mp4);
            }
        }

    
        $useWrap = true;
        if( array_key_exists('useWrap', $videoConfig) ){
            if( $videoConfig['useWrap'] == false ) {
                $useWrap = false;
            }
        }

        $useMuteUnmuteButton = false;
        if( array_key_exists('unmutebutton', $model) ){
            if( $model['unmutebutton'] == true ) {
                $useMuteUnmuteButton = true;
            }
        }

        $usePaddingPlaceholder = ( array_key_exists('usePaddingPlaceholder', $videoConfig) && $videoConfig['usePaddingPlaceholder'] ) ? true : false;
        
        $openingAnchor = '';
        $endingAnchor = '';
        $linkUrl = '';

        $imageLink = array_key_exists('imagelink', $model) ? $model['imagelink'] : false;
        if( $imageLink != false ){
            if( is_array($imageLink) ) {
                $linkUrl = LTUtility::getFullURL($imageLink['url']);
                // is this not a link to an internal page / category / post?
                if( $imageLink['type'] == '' ) {
                    // need to use the real URL and not change it through "LTUtility::getFullURL"
                    $linkUrl = $imageLink['url'];
                }
                $openingAnchor = '<a href="'.$linkUrl.'"';
                if($imageLink['newtab'] == true){
                    $openingAnchor .= ' target="_blank"';
                } else {
                    if( $imageLink['id'] != '' ) {
                        $openingAnchor .= ' data-id="'.$imageLink['id'].'"';
                    }
                    if( $imageLink['type'] != '' ) {
                        $openingAnchor .= ' data-type="'.$imageLink['type'].'"';
                    }
                    if( $imageLink['title'] != '' ) {
                        $openingAnchor .= ' data-title="'.__($imageLink['title']).'"';
                    }
                    if( array_key_exists('catid', $imageLink) && $imageLink['catid'] != '' ) {
                        $openingAnchor .= ' data-catid="'.LayElFunctions::stringifyCatIds($imageLink['catid']).'"';
                    }
                }
            } else {
                // for backwards compatibility
                $newtab = array_key_exists('newtab', $model) ? $model['newtbab'] : false;
                $linkUrl = LTUtility::getFullURL($imageLink);
                $openingAnchor = '<a href="'.$linkUrl.'"'; 
                if( $newtab == true ) {
                    $openingAnchor .= ' target="_blank"';
                }
            }
            $openingAnchor .= '>';
            $endingAnchor = '</a>';

            if($linkUrl == '' || $linkUrl == 'null' || $linkUrl == null){
                $linkUrl = '';
                $openingAnchor = '';
                $endingAnchor = '';
            }
        }



        /*
            useExternalVideo: false,
            externalVideoUrl: '',
            externalVideoW: '',
            externalVideoH: '',
        */
        $orientation = '';
        if($useExternalVideo){
            $orientation = $model['externalVideoW'] > $model['externalVideoH'] ? 'landscape' : 'portrait';
        } else {
            if( array_key_exists('w', $model) && array_key_exists('h', $model) ){
                $orientation = $model['w'] > $model['h'] ? 'landscape' : 'portrait';
            }
        }

        $markup = '';
        if( $useWrap ){
            $markup .= '<div class="html5video '.$orientation.' '.$autoplay_class.' '.$html_class.'">';
        }
        $markup .= $openingAnchor;
        if( $usePaddingPlaceholder ){
            $markup .= '<div class="ph" style="padding-bottom:'.Lay_LayoutFunctions::replaceCommaWithDot($pb).'%;">';
        }

        $w = '';
        $h = '';
        if($useExternalVideo){
            $w = 'data-w="'.$model['externalVideoW'].'"';
            $h = 'data-h="'.$model['externalVideoH'].'"';
        } else {
            $w = array_key_exists('w', $model) ? 'data-w="'.$model['w'].'"' : '';
            $h = array_key_exists('h', $model) ? 'data-h="'.$model['h'].'"' : '';
        }


        $style = '';
        if($useExternalVideo){
            $style = 'style="aspect-ratio:'.$model['externalVideoW'].'/'.$model['externalVideoH'].';"';
        } else {
            if(array_key_exists('w', $model) && array_key_exists('h', $model)) {
                $style = 'style="aspect-ratio:'.$model['w'].'/'.$model['h'].';"';
            }
        }

        $preload = 'preload="auto"';



        $ar = '';
        if($useExternalVideo){
            $ar = $model['externalVideoH'] / $model['externalVideoW'];
        } else {
            $ar = $model['ar'];
        }


        $markup .=
            $playIcon.$placeholderImage
            .'<video '.$preload.' '.$w.' '.$h.' '.$style.' data-ar="'.$ar.'" '.$poster.' '.$playsinline.' '.$autoplay_attr.' '.$mute.' '.$loop.' '.$controls.' class="'.$autoplay_class.' '.$lazyLoadClass.' '.$playpauseonclick_class.' '.$loadedClass.'">';
                if( $lazyload ) {
                    $markup .= '<source data-src="'.$mp4.'" type="video/mp4">';    
                } else {
                    $markup .= '<source src="'.$mp4.'" type="video/mp4">';    
                }
        $markup .=
            '</video>';
        if( $useMuteUnmuteButton ) {
            $markup .= LayElFunctions::getUnmuteButtonMarkup($model);
        }
        if( $usePaddingPlaceholder ){
            $markup .= '</div>';
        }
        $markup .= $endingAnchor;
        $markup .= $videoConfig['captionMarkup'];
        if( $useWrap ){
            $markup .= '</div>';
        }
        
        return $markup.$endingAnchor;
    }

    public static function getHTML5VideoMarkupSimple($model){
    /*
        $model['mute'] = true;
        $model['playpauseonclick'] = false;
        $model['autoplay'] = false;
        $model['controls'] = false;
        $model['playicon'] = false;
        $model['ar']
    */    

        $inside_thumbnailgrid_with_filter = false;
        $inside_thumbnailgrid_with_filter_class = '';

        if( array_key_exists('inside_thumbnailgrid_with_filter', $model) && $model['inside_thumbnailgrid_with_filter'] == true ){
            $inside_thumbnailgrid_with_filter = true;
            $inside_thumbnailgrid_with_filter_class = 'video-inside-thumbnailgrid-with-filter';
        }


        // $lazyload = !$videoConfig['noLazyLoad'];
        // $lazyload = Setup::$is_firefox ? false : true;

        $lazyload = true;
        if( Setup::$is_firefox == true && LayFrontend_Options::$enable_video_lazyloading_for_firefox == false ) {
            $lazyload = false;
        }
        if( Setup::$is_safari == true && LayFrontend_Options::$enable_video_lazyloading_for_safari == false ) {
            $lazyload = false;
        }
        if(LayFrontend_Options::$videos_lazyload == false) {
            $lazyload = false;
        }

        $lazyLoadClass = $lazyload == true ? 'video-lazyload' : 'no-lazyload';

        $preload = $lazyload ? 'preload="metadata"' : '';
        // $lazyLoadClass = 'video-lazyload';
        $autoplay_class = $model['autoplay'] == true ? 'autoplay' : '';
        // $autoplay_attr = $model['autoplay'] == true ? 'data-autoplay' : '';
        $autoplay_attr = $model['autoplay'] == true ? 'autoplay' : '';
        $mute = $model['mute'] == true ? 'muted' : '';
        $loop = $model['loop'] == true ? 'loop' : '';
        $playsinline = 'playsinline';
        $mp4 = $model['mp4'];
        $mp4 = LTUtility::getFullURL($mp4);

        $style = '';
        if(array_key_exists('w', $model) && array_key_exists('h', $model)) {
            $style = 'style="aspect-ratio:'.$model['w'].'/'.$model['h'].';"';
        }

        $markup = 
        '<video '.$style.' '.$preload.' '.$playsinline.' '.$autoplay_attr.' '.$mute.' '.$loop.' class="'.$autoplay_class.' '.$lazyLoadClass.' '.$inside_thumbnailgrid_with_filter_class.'">';
        if( $lazyload ) {
            $markup .= '<source data-src="'.$mp4.'" type="video/mp4">';  
        } else {
            $markup .= '<source src="'.$mp4.'" type="video/mp4">';  
        }
        $markup .= '</video>';
        return $markup;
    }

    public static function getLazyImg($el){
        if( $el['sizes']['full'] == null ){
            // image does not exist
            return;
        }
        // Todo: We set the data-id attribute of the img to $attid,
        // what happens in imagehover plugin if there is no id -> attid = false?
        $attid = false;
        $alt = MiscOptions::$image_alt_tag == '' ? get_bloginfo('name') : MiscOptions::$image_alt_tag;
        $_alt = '';
        $full = '';
        $full_src = '';
        $srcset = '';
        $smallest_src = '';

        $w_attr = '';
        $h_attr = '';
        $aspect_ratio_css = '';

        // attribute id exists
        if( array_key_exists('attid', $el) ) {
            $attid = $el['attid'];
            $_alt = LTUtility::getAltTag($attid);

            $full = wp_get_attachment_image_src( $attid, 'full' );
            if( $full !== false && is_array($full) ) {
                $full_src = $full[0];
                $w_attr = 'data-w="'.$full[1].'"';
                $h_attr = 'data-h="'.$full[2].'"';
                $aspect_ratio_css = 'aspect-ratio:'.$full[1].'/'.$full[2].';';

                // just not going to use wordpress' wp_get_attachment_image_srcset at all, because it doesnt include super large sizes like 4096
                // $srcset = wp_get_attachment_image_srcset( $attid );
    
                // todo: test if image smaller than 265 width works
                $smallest = wp_get_attachment_image_src( $attid, '_265' );
                $smallest_src = $full_src;
                if( $smallest != false ) {
                    $smallest_src = $smallest[0];
                }
            }
        }
        // there is another freak bug where wp_get_attachment_image_srcset would not use my custom image sizes, but only some 150 and 768 square sizes http://leitform.ch/moschti, so I check if srcset contains _265, and if not create the custom srcset ( strpos($srcset, '265w') === false )
        // there was some freak bug with some website (http://a184.uk/), where wp_get_attachment_image_srcset would always return '' and i could not figure out why, so i do this instead of just else{
        if( $srcset == '' || $srcset == false || !array_key_exists('attid', $el) || strpos($srcset, '265w') === false ) {
            // $srcset might be set already, because im doing strpos($srcset, '265w') === false, so reset it
            $srcset = '';
            if( !array_key_exists('attid', $el) && array_key_exists('alt', $el) ) {
                $_alt = $el['alt'];
            }
            $full_src = LTUtility::getFullURL($el['sizes']['full']);
            $sizesToBeFilled = ['_265', '_512', '_768', '_1024', '_1280', '_1920', '_2560', '_3200', '_3840', '_4096'];
            $sizes = $el['sizes'];

            foreach($sizes as $key => $value) {
                if( array_search($key, $sizesToBeFilled) !== false ){
                    $src = $value;
                    $src = LTUtility::getFullURL($src);
        
                    $srcset = $src.' '.substr($key, 1).'w, ' . $srcset;
                    $ix = array_search($key, $sizesToBeFilled);

                    if($ix !== false){
                        array_splice( $sizesToBeFilled, $ix, 1 );
                    }
                }
            }
            // fill rest of sizes with full image
            for($i=0; $i<count($sizesToBeFilled); $i++){
                $srcset .= $full_src.' '.substr($sizesToBeFilled[$i], 1).'w, ';
            }
            $srcset = substr( $srcset, 0, -2);
 
            $smallest = array_key_exists('_265', $sizes) ? $sizes['_265'] : false;
            if( $smallest == '' || $smallest == false ) {
                $smallest_src = $full_src;
            } else {
                $smallest_src = LTUtility::getFullURL($smallest);
            }
        }

        if( trim($_alt) != '' ) {
            $alt = $_alt;
        }
        $ar = $el['ar'];

        $isGif = false;
        $isGif = substr($full_src, -4) == '.gif' ? true : false;
        // used by imagehover addon
        $extra = array_key_exists('extra_attrs', $el) ? $el['extra_attrs'] : '';
        $extra_classes = array_key_exists('extra_classes', $el) ? $el['extra_classes'] : '';
        $small_src_before_lazyloading = 'data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==';
        if(LayFrontend_Options::$misc_options_image_loading_blur == 'on') {
            $small_src_before_lazyloading = $smallest_src;
        }

        switch( LayFrontend_Options::$image_loading ) {
            case 'instant_load':
                // note to myself: in "load_cpl_or_desktop_content_controller.js" the "instant_load" images are loaded
                if( $isGif ) {
                    return '<img class="lay-gif '.$extra_classes.'" src="'.$small_src_before_lazyloading.'" data-src="'.$full_src.'" data-ar="'.$ar.'" alt="'.$alt.'" '.$extra.' '.$w_attr.' '.$h_attr.' data-id="'.$attid.'" style="'.$aspect_ratio_css.'"/>';
                }
                if( LayFrontend_Options::$misc_options_showoriginalimages && !LTUtility::$isPhone || LayFrontend_Options::$misc_options_showoriginalimages_for_phone && LTUtility::$isPhone ){
                    return '<img class="lay-image-original '.$extra_classes.'" src="'.$small_src_before_lazyloading.'" data-src="'.$full_src.'" data-ar="'.$ar.'" alt="'.$alt.'" '.$extra.' '.$w_attr.' '.$h_attr.' data-id="'.$attid.'" style="'.$aspect_ratio_css.'"/>';
                }
                return '<img class="lay-image-responsive setsizes '.$extra_classes.'" src="'.$small_src_before_lazyloading.'" data-src="'.$smallest_src.'"  data-srcset="'.$srcset.'" sizes="" data-ar="'.$ar.'" alt="'.$alt.'" '.$extra.' '.$w_attr.' '.$h_attr.' data-id="'.$attid.'" style="'.$aspect_ratio_css.'"/>';
            break;
            case 'lazy_load':
                if( $isGif ) {
                    return '<img class="lay-gif lazyload '.$extra_classes.'" src="'.$small_src_before_lazyloading.'" data-src="'.$full_src.'" data-ar="'.$ar.'" alt="'.$alt.'" '.$extra.' '.$w_attr.' '.$h_attr.' data-id="'.$attid.'" style="'.$aspect_ratio_css.'"/>';
                }
                if( LayFrontend_Options::$misc_options_showoriginalimages && !LTUtility::$isPhone || LayFrontend_Options::$misc_options_showoriginalimages_for_phone && LTUtility::$isPhone ){
                    return '<img class="lay-image-original lazyload '.$extra_classes.'" src="'.$small_src_before_lazyloading.'" data-src="'.$full_src.'" data-ar="'.$ar.'" alt="'.$alt.'" '.$extra.' '.$w_attr.' '.$h_attr.' data-id="'.$attid.'" style="'.$aspect_ratio_css.'"/>';
                }
                return '<img class="lay-image-responsive lazyload '.$extra_classes.'" src="'.$small_src_before_lazyloading.'" data-src="'.$smallest_src.'"  data-srcset="'.$srcset.'" data-ar="'.$ar.'"  alt="'.$alt.'" '.$extra.' '.$w_attr.' '.$h_attr.' data-id="'.$attid.'" style="'.$aspect_ratio_css.'"/>';
            break;
        }
    }

    // this is basically the same function as above, getLazyImg, but it accepts an attid instead of a $el
    // todo: think about if i should create a function that outputs the <img markup. 
    // That function could be used by getLazyImgByImageId, getLazyImg and getMouseOverThumbImg
    public static function getLazyImgByImageId($attid, $size=''){
        if( $attid == '' || $attid == false ) {
            return '';
        }
        $alt = get_bloginfo('name');
        $_alt = '';
        $full = '';
        $full_src = '';
        $srcset = '';
        $smallest_src = '';
        $ar = '';

        $w_attr = '';
        $h_attr = '';

        // attribute id exists
        $_alt = LTUtility::getAltTag($attid);

        if( $_alt != '' ) {
            $alt = $_alt;
        }

        if( $size == '' ){
            $full = wp_get_attachment_image_src( $attid, 'full' );
            // todo: test if image smaller than 265 width works
            $smallest = wp_get_attachment_image_src( $attid, '_265' );
            $smallest_src = $full_src;
            if( $smallest != false ) {
                $smallest_src = $smallest[0];
            }
            if(is_array($full)) {
                $full_src = $full[0];
                // just not going to use wordpress' wp_get_attachment_image_srcset at all, because it doesnt include super large sizes like 4096
                // $srcset = wp_get_attachment_image_srcset( $attid );
                $w_attr = 'data-w="'.$full[1].'"';
                $h_attr = 'data-h="'.$full[2].'"';
                if($full[1] != 0) {
                    $ar = (int)$full[2] / (int)$full[1];
                }
            }
        }
        else{
            // custom size is used! for example 'woocommerce_thumbnail'
            $img_of_size = wp_get_attachment_image_src( $attid, $size );
                if(is_array($img_of_size)) {
                $smallest_src = $img_of_size[0];
                $full_src = $img_of_size[0];
                // todo: is just the url of an image even a valid srcset?
                $srcset = $img_of_size[0];
                $w_attr = 'data-w="'.$img_of_size[1].'"';
                $h_attr = 'data-h="'.$img_of_size[2].'"';
                if($img_of_size[1] != 0) {
                    $ar = (int)$img_of_size[2] / (int)$img_of_size[1];
                }
            }
        }

        // there is another freak bug where wp_get_attachment_image_srcset would not use my custom image sizes, but only some 150 and 768 square sizes http://leitform.ch/moschti, so I check if srcset contains _265, and if not create the custom srcset ( strpos($srcset, '265w') === false )
        // there was some freak bug with some website (http://a184.uk/), where wp_get_attachment_image_srcset would always return '' and i could not figure out why, so i do this instead of just else{
        if( $srcset == '' || $srcset == false || strpos($srcset, '265w') === false ) {
            // $srcset might be set already, because im doing strpos($srcset, '265w') === false, so reset it
            $srcset = '';
            $sizesToBeFilled = ['_265', '_512', '_768', '_1024', '_1280', '_1920', '_2560', '_3200', '_3840', '_4096'];

            foreach($sizesToBeFilled as $value) {
                $src = wp_get_attachment_image_url($attid, $value);
                if( $src === false ) {
                    $src = $full_src;
                }
                $srcset = $src.' '.substr($value, 1).'w, ' . $srcset;
            }
            $srcset = substr($srcset, 0, -2);
    
            $smallest_src = wp_get_attachment_image_url($attid, '_265');
            if( $smallest_src === false ) {
                $smallest_src = $full_src;
            }
        }

        $isGif = false;
        $isGif = substr($full_src, -4) == '.gif' ? true : false;

        switch( LayFrontend_Options::$image_loading ) {
            case 'instant_load':
                if( $isGif ) {
                    return '<img class="lay-gif" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-src="'.$full_src.'" data-ar="'.$ar.'" data-id="'.$attid.'" alt="'.$alt.'" '.$w_attr.' '.$h_attr.'/>';
                }
                if( LayFrontend_Options::$misc_options_showoriginalimages && !LTUtility::$isPhone || LayFrontend_Options::$misc_options_showoriginalimages_for_phone && LTUtility::$isPhone ){
                    return '<img class="lay-image-original" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-src="'.$full_src.'" data-ar="'.$ar.'" data-id="'.$attid.'" alt="'.$alt.'" '.$w_attr.' '.$h_attr.'/>';
                }
                return '<img class="lay-image-responsive setsizes" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw=="  data-srcset="'.$srcset.'" sizes="" data-ar="'.$ar.'" data-id="'.$attid.'" alt="'.$alt.'" '.$w_attr.' '.$h_attr.'/>';
            break;
            case 'lazy_load':
                if( $isGif ) {
                    return '<img class="lay-gif lazyload" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-src="'.$full_src.'" data-ar="'.$ar.'" data-id="'.$attid.'" alt="'.$alt.'" '.$w_attr.' '.$h_attr.'/>';
                }
                if( LayFrontend_Options::$misc_options_showoriginalimages && !LTUtility::$isPhone || LayFrontend_Options::$misc_options_showoriginalimages_for_phone && LTUtility::$isPhone ){
                    return '<img class="lay-image-original lazyload" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-src="'.$full_src.'" data-ar="'.$ar.'" data-id="'.$attid.'" alt="'.$alt.'" '.$w_attr.' '.$h_attr.'/>';
                }
                return '<img class="lay-image-responsive lazyload" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw=="  data-srcset="'.$srcset.'" data-ar="'.$ar.'" data-id="'.$attid.'"  alt="'.$alt.'" '.$w_attr.' '.$h_attr.'/>';
            break;
        }
    }

    public static function getMouseOverThumbImg($el) {
        $isGif = false;
				// Todo: Same here as in getLazyImg
        $mo_attid = array_key_exists('mo_attid', $el) ? $el['mo_attid'] : false;
        $alt = get_bloginfo('name');
        $full = '';
        $full_src = '';
        $srcset = '';
        $smallest_src = '';
        $ar = 0;

        if( $mo_attid != false ) {
            $alt = LTUtility::getAltTag($mo_attid);

            $full = wp_get_attachment_image_src( $mo_attid, 'full' );
            $full_src = '';
            if( $full ) {
                $full_src = $full[0];
                $ar = (int)$el['mo_h'] / (int)$el['mo_w'];
            }
            $smallest = wp_get_attachment_image_src( $mo_attid, '_265' );
            $smallest_src = '';
            if( $smallest ) {
                $smallest_src = $smallest[0];
            }
            $srcset = wp_get_attachment_image_srcset( $mo_attid );
        } else {
            // for backwards compatibility
            $sizes = $el['mo_sizes'];
            $full_src = LTUtility::getFullURL($el['mo_sizes']['full']);
            $sizesToBeFilled = ['_265', '_512', '_768', '_1024', '_1280', '_1920', '_2560', '_3200', '_3840', '_4096'];
            $smallest_src = $sizes['_265'];

            if((int)$el['mo_w'] != 0){
                $ar = (int)$el['mo_h'] / (int)$el['mo_w'];
            }

            foreach($sizes as $key => $value) {
                if( array_search($key, $sizesToBeFilled) !== false ){
                    $src = $value;
                    $src = LTUtility::getFullURL($src);
        
                    $srcset = $src.' '.substr($key, 1).'w, ' . $srcset;
                    $ix = array_search($key, $sizesToBeFilled);

                    if($ix !== false){
                        array_splice( $sizesToBeFilled, $ix, 1 );
                    }
                }
            }
            // fill rest of sizes with full image
            for($i=0; $i<count($sizesToBeFilled); $i++){
                $srcset .= $full_src.' '.substr($sizesToBeFilled[$i], 1).'w, ';
            }
            $srcset = substr($srcset, 0, -2);
        }
        $isGif = substr($full_src, -4) == '.gif' ? true : false;

        // same as in getLazyImg, but using class "mo_thumb"
        switch( LayFrontend_Options::$image_loading ) {
            case 'instant_load':
                if( $isGif ) {
                    return '<img class="mo_thumb lay-gif" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-src="'.$full_src.'" data-ar="'.$ar.'" alt="'.$alt.'" data-id="'.$mo_attid.'"/>';
                }
                if( LayFrontend_Options::$misc_options_showoriginalimages && !LTUtility::$isPhone || LayFrontend_Options::$misc_options_showoriginalimages_for_phone && LTUtility::$isPhone ){
                    return '<img class="mo_thumb lay-image-original" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-src="'.$full_src.'" data-ar="'.$ar.'" alt="'.$alt.'" data-id="'.$mo_attid.'"/>';
                }
                return '<img class="mo_thumb lay-image-responsive setsizes" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw=="  data-srcset="'.$srcset.'" sizes="" data-ar="'.$ar.'" alt="'.$alt.'" data-id="'.$mo_attid.'"/>';
            break;
            case 'lazy_load':
                if( $isGif ) {
                    return '<img class="mo_thumb lay-gif lazyload" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-src="'.$full_src.'" data-ar="'.$ar.'" alt="'.$alt.'" data-id="'.$mo_attid.'"/>';
                }
                if( LayFrontend_Options::$misc_options_showoriginalimages && !LTUtility::$isPhone || LayFrontend_Options::$misc_options_showoriginalimages_for_phone && LTUtility::$isPhone ){
                    return '<img class="mo_thumb lay-image-original lazyload" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-src="'.$full_src.'" data-ar="'.$ar.'" alt="'.$alt.'" data-id="'.$mo_attid.'"/>';
                }
                return '<img class="mo_thumb lay-image-responsive lazyload" src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw=="  data-srcset="'.$srcset.'" data-ar="'.$ar.'"  alt="'.$alt.'" data-id="'.$mo_attid.'"/>';
            break;
        }
    }

    public static function stringifyCatIds($catids){
        if( $catids == '' || $catids == null  ) {
            return '[]';
        }
        if( is_string($catids) ) {
            return $catids;
        }
        // is a number like 3
        if( is_scalar($catids) ) {
            return '['.$catids.']';
        }
        if( is_array($catids) ) {
            for( $i=0; $i<count($catids); $i++ ) {
                $catids[$i] = (int)$catids[$i];
            }
        }
        return json_encode($catids);
    }

    public static function getCaptionMarkup($el){
        if( array_key_exists( 'caption', $el ) && $el['caption'] != '' ) {
            return '<div class="caption lay-textformat-parent">'.$el['caption'].'</div>'; 
        }
        return '';
    }

}
new LayElFunctions();