<?php

class LayText{

    public $el;
    public $device;
		public $postid;

    public function __construct($el, $device = 'desktop', $postid = -1){
        $this->el = $el;
        $this->device = $device;
        $this->postid = $postid;
    }

    public function getMarkup(){
        $isscrolltotop = array_key_exists('isscrolltotop', $this->el) ? $this->el['isscrolltotop'] : false;
        if( $isscrolltotop == true ) {
            $isscrolltotop = 'scrolltotop';
        } else {
            $isscrolltotop = '';
        }

        $style = '';
        if( array_key_exists('pxwidth', $this->el) && $this->el['pxwidth'] != null ) {
            $style .= '<style>';
            $selector = '#grid';
            if( $this->device == 'phone' ) {
                $selector = '#custom-phone-grid';
            }
            if( $this->postid != -1 ) {
                $selector .= '.id-'.$this->postid;
            }
            if( array_key_exists('desktop', $this->el['pxwidth']) ){
                $style .= '@media (min-width: '.(LayFrontend_Options::$tablet_breakpoint + 1).'px) { '.$selector.' .text_'.$this->el['relid'].'{width:'.$this->el['pxwidth']['desktop']['val'].$this->el['pxwidth']['desktop']['mu'].';} }';
            }
            if( array_key_exists('tablet', $this->el['pxwidth']) ){
                $style .= '@media (min-width: '.(LayFrontend_Options::$breakpoint + 1).'px) and (max-width: '.LayFrontend_Options::$tablet_breakpoint.'px) { '.$selector.' .text_'.$this->el['relid'].'{width:'.$this->el['pxwidth']['tablet']['val'].$this->el['pxwidth']['tablet']['mu'].';} }';
            }
            if( array_key_exists('phone', $this->el['pxwidth']) ){
                $style .= '@media (max-width: '.(LayFrontend_Options::$breakpoint).'px) { '.$selector.' .text_'.$this->el['relid'].'{width:'.$this->el['pxwidth']['phone']['val'].$this->el['pxwidth']['phone']['mu'].';} }';
            }
            $style .= '</style>';
        }

        $markup = $style;
        $text_class = array_key_exists('relid', $this->el) ? 'text_'.$this->el['relid'] : ''; 

        // find text $tags$ in $this->el['cont'] and replace them with comma separated list of tags
        // does text contain $tags$ string?
        if( strpos($this->el['cont'], '$tags$') !== false ) {
            $tags = get_the_tags($this->postid);
            $tagArray = array();
            if ($tags) {
                usort($tags, function($a, $b) {
                    return $a->term_order - $b->term_order;
                });
                foreach($tags as $tag) {
                    $tagArray []= $tag->name;
                }

                $tagArray = '<span class="lay-tags-in-text"><span class="lay-tag-in-text">'.implode('</span><span class="lay-tag-in-text-delimiter">, </span><span class="lay-tag-in-text">', $tagArray).'</span></span>';
                $this->el['cont'] =  str_replace('$tags$', $tagArray, $this->el['cont']);
            } else {
                $this->el['cont'] = str_replace('$tags$', '', $this->el['cont']);
            }
        }

        // find text $categories$ in $this->el['cont'] and replace them with comma separated list of categories
        // does text contain $categories$ string?
        if( strpos($this->el['cont'], '$categories$') !== false ) {
            $categories = get_the_terms($this->postid, 'category');
            $categoryArray = array();
            if ($categories) {
                usort($categories, function($a, $b) {
                    return $a->term_order - $b->term_order;
                });
                foreach($categories as $category) {
                    $categoryArray []= $category->name;
                }

                $categoryArray = '<span class="lay-categories-in-text"><span class="lay-category-in-text">'.implode('</span><span class="lay-category-in-text-delimiter">, </span><span class="lay-category-in-text">', $categoryArray).'</span></span>';
                $this->el['cont'] = str_replace('$categories$', $categoryArray, $this->el['cont']);
            } else {
                $this->el['cont'] = str_replace('$categories$', '', $this->el['cont']);
            }
        }


        $markup .= '<div class="text lay-textformat-parent '.$text_class.' '.$isscrolltotop.'">'.$this->el['cont'].'</div>';
        return $markup;
    }

}