<?php
// todo: video thumbnail new
// todo: test mouseover image

class LayThumbnail{

    public $el;    
    // for elementgrid, sameheight
    public $height;
    public $title_only;

    // todo: remove title only
    public function __construct($el, $title_only = false, $height = false){
        $this->el = $el;
        $this->title_only = $title_only;
        $this->height = $height;
    }

    public function getMarkup($isInsideThumbnailGridWithFilter = false){
        if($isInsideThumbnailGridWithFilter == 1){
            $isInsideThumbnailGridWithFilter = true;
        }

        $pb = $this->el['ar'] * 100;
        $markup = '';
        
        $img = LayElFunctions::getLazyImg($this->el);

        $mo_thumb = array_key_exists('mo_sizes', $this->el) ? $this->el['mo_sizes'] : false;
        $mo_thumb_img = "";
        $has_mo_thumb_class = "";

        if( LayFrontend_Options::$misc_options_thumbnail_mouseover_image && is_array($mo_thumb) && !empty($mo_thumb) ){
            
            if ( LTUtility::$isTouchDevice  ) {
                switch(LayFrontend_Options::$fi_mo_touchdevice_behaviour) {
                    case 'mo_dont_show':
                        // 'Do not show mouseover state' means: dont show mouseover image
                        $has_mo_thumb_class = "";
                        $mo_thumb_img = "";
                    break;
                    case 'mo_on_tap_alt':
                        // 'When touching thumbnail, show mouseover state' means: show video, but show mouseover image on tap
                        $mo_thumb_img = LayElFunctions::getMouseOverThumbImg($this->el);
                        $has_mo_thumb_class = "has-mouseover-img";
                    break;
                    case 'mo_always':
                        // 'Always show mouseover state' means: always show mouseover image
                        $img = LayElFunctions::getMouseOverThumbImg($this->el);
                        $mo_thumb_img = "";
                        $has_mo_thumb_class = "";
                    break;
                    case 'mo_on_tap':
                        // 'Show mouseover state on touch or tap, tap again to enter project' means: show video, but show mouseover image on tap, tap again to enter project
                        $mo_thumb_img = LayElFunctions::getMouseOverThumbImg($this->el);
                        $has_mo_thumb_class = "has-mouseover-img";
                    break;
                }
            } else {
                $mo_thumb_img = LayElFunctions::getMouseOverThumbImg($this->el);
                $has_mo_thumb_class = "has-mouseover-img";
            }

        }

        $innerMarkup = $img.$mo_thumb_img;

        $postid = $this->el['postid'];

        if( LayFrontend_Options::$misc_options_thumbnail_video ) {
            $video_url = array_key_exists('video_url', $this->el) ? $this->el['video_url'] : false;

            $useExternalVideo = get_post_meta($postid, 'lay_useExternalVideo', false);
            $useExternalVideoOn = is_array($useExternalVideo) && count($useExternalVideo) > 0 && $useExternalVideo[0] == 'on' ? "on" : "";
            $externalVideoUrl = get_post_meta($postid, 'lay_externalVideoUrl', true);
            $reallyUsingExternalVideo = false;

            if($useExternalVideoOn == 'on' && $externalVideoUrl != "" && $externalVideoUrl != false) {
                $video_url = $externalVideoUrl;
                $reallyUsingExternalVideo = true;
            } 

            // if on touch device and we have "playsinline" support, then show video with playsinline attribute and autoplay
            // otherwise show image
            // playsinline is supported from iOS 10 WebKit and Chrome > 53
            if( $video_url != false && $video_url != "") {


                if( $reallyUsingExternalVideo ) {
                    $externalVideoW = get_post_meta($postid, 'lay_externalVideoW', true);
                    $externalVideoH = get_post_meta($postid, 'lay_externalVideoH', true);
                    $w = (int)$externalVideoW;
                    if( $w != 0 ) {
                        $pb = (int)$externalVideoH / $w * 100;
                    }
                } else {
                    $w = (int)$this->el['video_w'];
                    if( $w != 0 ) {
                        $pb = (int)$this->el['video_h'] / $w * 100;
                    }
                }

                // is touch device and has playsinline support
                if ( LTUtility::$isTouchDevice && LTUtility::$supportsPlaysInlineOnTouchDevice ) {

                    if($has_mo_thumb_class == "has-mouseover-img") {
                        // we have a mouseoverimage and a video thumbnail and are on touch device:

                        // 'mo_dont_show' => 'Do not show mouseover state',
                        // 'mo_on_tap_alt' => 'When touching thumbnail, show mouseover state',
                        // 'mo_always' => 'Always show mouseover state',
                        // 'mo_on_tap' => 'Show mouseover state on touch or tap, tap again to enter project'

                        $autoplay = false;
                        if( LayFrontend_Options::$fi_mo_touchdevice_behaviour == 'mo_dont_show' ){
                            $autoplay = true;
                        }
        
                        $model = array(
                            'autoplay' => $autoplay,
                            'loop' => true,
                            'mute' => true,
                            'mp4' => $video_url,
                            'inside_thumbnailgrid_with_filter' => $isInsideThumbnailGridWithFilter
                        );
        
                        $innerMarkup = LayElFunctions::getHTML5VideoMarkupSimple($model);

                        switch(LayFrontend_Options::$fi_mo_touchdevice_behaviour) {
                            case 'mo_dont_show':
                                // 'Do not show mouseover state' means: show video, but dont show mouseover image
                                $has_mo_thumb_class = "";
                            break;
                            case 'mo_on_tap_alt':
                                // 'When touching thumbnail, show mouseover state' means: show video, but show mouseover image on tap
                                $innerMarkup .= $mo_thumb_img;
                            break;
                            case 'mo_always':
                                // 'Always show mouseover state' means: always show mouseover image
                                $innerMarkup = $mo_thumb_img;
                                $has_mo_thumb_class = "";
                            break;
                            case 'mo_on_tap':
                                // 'Show mouseover state on touch or tap, tap again to enter project' means: show video, but show mouseover image on tap, tap again to enter project
                                $innerMarkup .= $mo_thumb_img;
                            break;
                        }

                    } else {
        
                        // we just have a video thumbnail and are on touch device. we dont have a mouseover image.
                        $model = array(
                            'autoplay' => true,
                            'loop' => true,
                            'mute' => true,
                            'mp4' => $video_url,
                            'inside_thumbnailgrid_with_filter' => $isInsideThumbnailGridWithFilter
                        );
        
                        $innerMarkup = LayElFunctions::getHTML5VideoMarkupSimple($model);
                        $has_mo_thumb_class = "";

                    }
                }
                // is not touch device
                if( !LTUtility::$isTouchDevice ) {
                    // when not touchdevice, use mouseover image
                    // when the video thumbnail mouseover behaviour is set to only "play_on_mouseover", then don't use a autoplay attribute!
                    $autoplay = true;
                    if( LayFrontend_Options::$video_thumbnail_mouseover_behaviour == 'play_on_mouseover' ){
                        $autoplay = false;
                    }
                    $model = array(
                        'autoplay' => $autoplay,
                        'loop' => true,
                        'mute' => true,
                        'mp4' => $video_url,
                        'inside_thumbnailgrid_with_filter' => $isInsideThumbnailGridWithFilter
                    );
                    // todo: test this
                    $innerMarkup = LayElFunctions::getHTML5VideoMarkupSimple($model).$mo_thumb_img;
                }
            }
        }
        // #video thumbnail new
       

        //project thumbnail
        
        $link = $this->el['link'];
        $link = get_permalink($this->el['postid']);
        
        $title = $this->el['title'];
        $postid = $this->el['postid'];
        $descr = array_key_exists('descr', $this->el) ? $this->el['descr'] : false;
        // sometimes there is an empty p at the start of descr, remove it
        // http://laythemeforum.com:4567/topic/5390/p-p-adds-in-project-description-for-thumbail-when-updating/2
        // <p></p>
        $substr = substr($descr, 0,7);
        if( $substr == '<p></p>' ) {
            $descr = substr($descr,7);
        }

        $tags = get_the_tags($this->el['postid']);
        $tagArray = array();
        if ($tags) {
            usort($tags, function($a, $b) {
                return $a->term_order - $b->term_order;
            });
            foreach($tags as $tag) {
                $tagArray []= $tag->name;
            }
        }
        // $tagText = implode(', ', $tagArray);
        $tagText = '';
        for($k=0; $k<count($tagArray); $k++){
            $tagText .= '<span>'.$tagArray[$k].'</span>';
            // if($k < count($tagArray)-1){
            // 	$tagText .= ', ';
            // }
        }
        $tagMarkup = '';
        if( $tagText != '' ) {
            $tagMarkup = '<span class="thumbnail-tags '.LayFrontend_Options::$ptags_textformat.'">'.$tagText.'</span>';
        }
        

        $cats_wp_terms_array = get_the_category($postid);
        $catids = array();

        for( $i = 0; $i<count($cats_wp_terms_array); $i++ ) {
            $cat = $cats_wp_terms_array[$i];
            $catids []= $cat->term_id;
        }

        $dataAttrs = 'data-id="'.$postid.'" data-catid="'.LayElFunctions::stringifyCatIds($catids).'" data-title="'.htmlspecialchars(__($title)).'" data-type="project"';

        $mo_always = "";
        if( LayFrontend_Options::$fi_mo_touchdevice_behaviour == "mo_always" && LTUtility::$isTouchDevice == true ){
            $mo_always = "hover";
        }

        // $mo_always .= ' touchdevice-behaviour-'.LayFrontend_Options::$fi_mo_touchdevice_behaviour;
        

        $showDescr = false;
        if( $descr != false && LayFrontend_Options::$activate_project_description && trim($descr) != ""){
            $showDescr = true;
        }

        $pt_position = LayFrontend_Options::$pt_position;
        $pd_position = LayFrontend_Options::$pd_position;

        $title_only_display = ""; // Hide image
        $title_only_inlineblock = ""; // Set thumb container to inline, so the imagehover trigger area ends with the text

        if ( $this->title_only == true ) {
            // Since we don't display an image there is no point to position the text
            $aboveImageTextExists = false;
            $pt_on_image = false;
            $onImageTextExists = false;
            $belowImageTextExists = true;

            $title_only_display = "display: none;";
            $title_only_inlineblock = "display: inline-block";
        } else {
            $aboveImageTextExists = $pt_position == "above-image" || ($pd_position == "above-image" && $showDescr) ? true : false;
            $pt_on_image = strpos($pt_position, 'on-image') === false ? false : true;
            $onImageTextExists = $pt_on_image || ($pd_position == "on-image" && $showDescr) ? true : false;
            $belowImageTextExists = $pt_position == "below-image" || ($pd_position == "below-image" && $showDescr) ? true : false;
        }

        $do_disable = false;
        $anchortag = 'a';
        $href = 'href="'.$link.'"';
        $disable_link_is_active = get_post_meta($postid, 'disable_link_is_active', false);
        if(is_array($disable_link_is_active) && array_key_exists(0, $disable_link_is_active) && $disable_link_is_active[0] == 'on'){
            $do_disable = true;
            $anchortag = 'div';
        }

        $orientation = $pb > 100 ? 'portrait' : 'landscape';

        $markup =
        '<'.$anchortag.' class="thumb '.$orientation.' '.$mo_always.' '.$has_mo_thumb_class.' '.($do_disable == true ? 'link-disabled' : '').'" '.$href.' style="'.$title_only_inlineblock.'" '.$dataAttrs.'>';
            if($aboveImageTextExists){
                $markup .= '<div class="lay-textformat-parent above-image">';
                if($pt_position == "above-image"){
                    $markup .= '<span class="title '.LayFrontend_Options::$pt_textformat.'">'.$title.'</span>'.$tagMarkup;
                }
                if($pd_position == "above-image" && $showDescr){
                    $markup .= '<span class="descr">'.$descr.'</span>';
                }
                $markup .= '</div>';
            }
        // open thumb-rel
        $markup .= '<div class="thumb-rel">';
        if( $onImageTextExists ){
            $markup .= '<div class="lay-textformat-parent titlewrap-on-image">';
            if( $pt_on_image ){
                $markup .= '<span class="title '.LayFrontend_Options::$pt_textformat.'">'.$title.'</span>'.$tagMarkup;
            }
            if( $pd_position == "on-image" && $showDescr){
                $markup .= '<span class="descr">'.$descr.'</span>';
            }
            $markup .= '</div>';
        }

        $pbstyle = 'style="padding-bottom:'.Lay_LayoutFunctions::replaceCommaWithDot($pb).'%;';
        if($this->height != false) {
            $pbstyle = '';
        }

        //empty span for bgcolor
        $markup .=
            '<div class="ph" '.$pbstyle.' '.$title_only_display.'">'
            .$innerMarkup
            .'<span></span>'
        .'</div>'
        .'</div>'; //close thumb rel
        if( $belowImageTextExists ) {
            $markup .=
            '<div class="lay-textformat-parent below-image">';
            if( $pt_position == "below-image" || $this->title_only ) {
                $markup .= '<span class="title '.LayFrontend_Options::$pt_textformat.'">'.$title.'</span>'.$tagMarkup;
            }
            if( ($pd_position == "below-image" || $this->title_only) && $showDescr ){
                $markup .= '<span class="descr">'.$descr.'</span>';
            }
            $markup .= '</div>';
        }
        $markup .= '</'.$anchortag.'>';
        $display_style = array_key_exists('display', $this->el) && $this->el['display'] == false ? 'style="display:none;"' : '';
        $filter_id_attr = array_key_exists('filter_id', $this->el) ? 'data-filterid="'.$this->el['filter_id'].'"' : '';

        $tagArray_ids = array();
        if ($tags) {
            usort($tags, function($a, $b) {
                return $a->term_order - $b->term_order;
            });
            foreach($tags as $tag) {
                $tagArray_ids []= $tag->term_id;
            }
        }

        $classes = array_key_exists('classes', $this->el) ? $this->el['classes'] : '';

        return '<div class="thumbnail-wrap '.$classes.'" data-tags="['.implode(',',$tagArray_ids).']" '.$display_style.' '.$filter_id_attr.'>'.$markup.'</div>';
    }
}