<?php

// todo: im on a page, i open an overlay. in this overlay, there is a link to another overlay. 
// when i click that link the page is not opened in a new overlay, but its just opened as a normal page.
// thats because the overlay markup of the second one is not present yet. because i only load overlays that are linked to in the original underlying page

// to fix this, im just loading in all overlays now.
// since i display none all overlays now before they are opened, this should not be a performance problem anymore!

// test:
// horizontal grid √
// place freely √
// custom row height √
// cover √
// fs slider √
// lightbox √
// carousel √
// test mobile √
// test 100svh on mobile √
// test multiple overlays √
// test expand row √

class Lay_Overlays{


    public function __construct(){
        // nope, not anymore, bc i cant just load all of them…
        // add_action('wp_footer', array($this, 'echo_overlay'));
    }



    public static function echo_overlay(){
        echo Lay_Overlays::getOverlays();
    }

    public static function getOverlays($layoutMarkup){
        $val = get_option('misc_options_activate_overlay_feature', '');
		if($val == "on" && !MiscOptions::$locked){
            // if someone has 20 overlays, if we load all of them, its going to crash the website when scrolling on safari ios :)
            // thats why we only load overlays that are currently linked to on the current page!

            // get all overlays from current markup and menus
            // $menuMarkup = LayMenuManager::get_mobile_menu();
            // $menuMarkup .= LayMenuManager::get_menu_markup();

            // $productMarkup = '';
            // if ( class_exists('WooCommerce') && is_product() ){
            //     global $post;
            //     $product = wc_get_product( $post->ID );
            //     $productMarkup .= $product->get_short_description();
            //     $productMarkup .= $product->get_description();
            // }

            // $customHTMLMarkups = '';
            // if( !LayFrontend_Options::$turn_off_custom_code ) {
            //     $customHTMLMarkups .= get_option( 'misc_options_custom_htmltop', '' );
            //     $customHTMLMarkups .= get_option( 'misc_options_custom_htmlbottom', '' );
            // }


            // $dom = new DomDocument();
            // https://stackoverflow.com/questions/1148928/disable-warnings-when-loading-non-well-formed-html-by-domdocument-php
            // libxml_use_internal_errors(true);
            // $dom->loadHTML( $layoutMarkup.$menuMarkup.$customHTMLMarkups.$productMarkup );
            // $errors = libxml_get_errors();
            // foreach ($errors as $error) {
            //     // handle the errors as you wish
            // }
            // $anchors = $dom->getElementsByTagName( "a" );
            // $ids = array();
            // foreach( $anchors as $anchor ){
            //     $type = $anchor->getAttribute('data-type');
            //     if($type == 'page') {
            //         $id = $anchor->getAttribute('data-id');
            //         array_push($ids, $id);
            //     }
            // }

            $args = array(
                'posts_per_page' => -1,
                'post_type' => 'page',
                'fields' => 'ids',
                'post_status' => 'publish',
            );
            
            $query = new WP_Query( $args );
            $overlay_markups = '';

            $breakpoint = get_option('lay_breakpoint', 600);
            $breakpoint = (int)$breakpoint;

            $sharedStyle = '';
            $desktopStyle = '';
            $mobileStyle = '';

            if ( $query->have_posts() ) {
                foreach ($query->posts as $post_id){
                    $array = get_post_meta($post_id, 'overlay_settings');

                    if( is_array($array) && array_key_exists(0, $array) ) {
                        $array = $array[0];
                        $use_as_overlay = array_key_exists('use_as_overlay', $array) ? $array['use_as_overlay'] : '';
                        
                        if($use_as_overlay == 'on') {
                            $overlay_burger = array_key_exists('overlay_burger', $array) ? $array['overlay_burger'] : '';
                            // get overlay if its linked in menu or in layout
                            // OR if we have "show burger icon" enabled for this page

                            // current id is not part of to be loaded page's id array
                            // and overlay burger is not turned on
                            // THIS IS THE IMPORTANT PART :D!
                            // if( !in_array( $post_id, $ids) && $overlay_burger != 'on' ) {
                            // if( $overlay_burger != 'on' ) {
                                // continue;
                            // }
                    
                            $layout = Lay_Layout::getLayout($post_id, 'page', '', false, true);
                            // $height = $array['overlay_set_height'] == 'on' ? 'height:'.$array['overlay_height'].$array['overlay_height_mu'].';' : '';
                            $height = '';
                            // data-settings='.json_encode($array).'

                            $close_markup = '';
                            $close = array_key_exists('close', $array) ? $array['close'] : '';
                            $close_color = array_key_exists('close_color', $array) ? $array['close_color'] : '#000000';
                            $close_size = array_key_exists('close_size', $array) ? $array['close_size'] : 40;
                            $close_size_mu = array_key_exists('close_size_mu', $array) ? $array['close_size_mu'] : 'px';

                            $close_padding = array_key_exists('close_padding', $array) ? $array['close_padding'] : 20;
                            $close_padding_mu = array_key_exists('close_padding_mu', $array) ? $array['close_padding_mu'] : 'px';

                            $close_position = array_key_exists('close_position', $array) ? $array['close_position'] : 'topright';

                            $close_size_phone = array_key_exists('close_size_phone', $array) ? $array['close_size_phone'] : 25;
                            $close_size_phone_mu = array_key_exists('close_size_phone_mu', $array) ? $array['close_size_phone_mu'] : 'px';

                            $close_padding_phone = array_key_exists('close_padding_phone', $array) ? $array['close_padding_phone'] : 15;
                            $close_padding_phone_mu = array_key_exists('close_padding_phone_mu', $array) ? $array['close_padding_phone_mu'] : 'px';

                            $use_custom_close_icon = array_key_exists('use_custom_close_icon', $array) ? $array['use_custom_close_icon'] : '';
                            $custom_close_icon_width = array_key_exists('custom_close_icon_width', $array) ? $array['custom_close_icon_width'] : 40;
                            $custom_close_icon_width_mu = array_key_exists('custom_close_icon_width_mu', $array) ? $array['custom_close_icon_width_mu'] : 'px';

                            $custom_close_phone_icon_width = array_key_exists('custom_close_phone_icon_width', $array) ? $array['custom_close_phone_icon_width'] : 30;
                            $custom_close_phone_icon_width_mu = array_key_exists('custom_close_phone_icon_width_mu', $array) ? $array['custom_close_phone_icon_width_mu'] : 'px';

                            $overlay_width = array_key_exists('overlay_width', $array) ? $array['overlay_width'] : 100;
                            $overlay_width_mu = array_key_exists('overlay_width_mu', $array) ? $array['overlay_width_mu'] : '%';

                            $overlay_phone_width = array_key_exists('overlay_phone_width', $array) ? $array['overlay_phone_width'] : 100;
                            $overlay_phone_width_mu = array_key_exists('overlay_phone_width_mu', $array) ? $array['overlay_phone_width_mu'] : '%';

                            $disable_scroll = array_key_exists('lay_disable_scroll', $array) ? $array['lay_disable_scroll'] : 'on';

                            if( $close == 'on' ) {

                                $custom_close_icon = array_key_exists('custom_close_icon', $array) ? $array['custom_close_icon'] : '';
                                $custom_close_icon_img_src = '';
                                if($custom_close_icon != ''){
                                    $custom_close_icon_img_src = wp_get_attachment_image_src( $custom_close_icon, 'full' );
                                    if(is_array($custom_close_icon_img_src)) {
                                        $custom_close_icon_img_src = $custom_close_icon_img_src[0];
                                    }
                                }

                                $use_custom_close_icon = array_key_exists('use_custom_close_icon', $array) ? $array['use_custom_close_icon'] : '';
                                $close_type = array_key_exists('close_type', $array) ? $array['close_type'] : '';
                                if($use_custom_close_icon == "on") {
                                    $close_type = 'custom';
                                }

                                switch($close_type) {
                                    case 'custom':
                                        $close_markup = '<div class="overlay-close custom-overlay-close-icon"><img src="'.$custom_close_icon_img_src.'" alt=""/></div>';
                                    break;
                                    case 'default':
                                        $close_markup = '<div class="overlay-close standard-overlay-close-icon"></div>';
                                    break;
                                    case 'text':
                                        $close_markup = '<div class="overlay-close text-overlay-close _'.$array['lay_overlay_close_textformat'].'_no_spaces">'.$array['lay_overlay_close_text'].'</div>';
                                    break;
                                }

                                $padding_css_desktop = '';
                                $padding_css_phone = '';


                                $mu_desktop = $close_padding_mu == 'px' ? $close_padding_mu : 'vw';
                                $mu_phone = $close_padding_phone_mu == 'px' ? $close_padding_phone_mu : 'vw';

                                $padding_desktop_w_mu = $close_padding.$mu_desktop;
                                $padding_phone_w_mu = $close_padding_phone.$mu_phone;

                                switch($close_position) {
                                    case 'topright':
                                        $padding_css_desktop = 'padding: '.$padding_desktop_w_mu.' '.$padding_desktop_w_mu.' 0 0;';
                                        $padding_css_phone = 'padding: '.$padding_phone_w_mu.' '.$padding_phone_w_mu.' 0 0;';
                                    break;
                                    case 'topleft':
                                        $padding_css_desktop = 'padding: '.$padding_desktop_w_mu.' 0 0 '.$padding_desktop_w_mu.';';
                                        $padding_css_phone = 'padding: '.$padding_phone_w_mu.' 0 0 '.$padding_phone_w_mu.';';
                                    break;
                                    case 'bottomright':
                                        $padding_css_desktop = 'padding: 0 '.$padding_desktop_w_mu.' '.$padding_desktop_w_mu.' 0;';
                                        $padding_css_phone = 'padding: 0 '.$padding_phone_w_mu.' '.$padding_phone_w_mu.' 0;';
                                    break;
                                    case 'bottomleft':
                                        $padding_css_desktop = 'padding: 0 0 '.$padding_desktop_w_mu.' '.$padding_desktop_w_mu.';';
                                        $padding_css_phone = 'padding: 0 0 '.$padding_phone_w_mu.' '.$padding_phone_w_mu.';';
                                    break;
                                }


                                $position_css = '';
                                switch($close_position) {
                                    case 'topright':
                                        $position_css = 'right:0;top:0;';
                                    break;
                                    case 'topleft':
                                        $position_css = 'left:0;top:0;';
                                    break;
                                    case 'bottomright':
                                        $position_css = 'right:0;bottom:0;';
                                    break;
                                    case 'bottomleft':
                                        $position_css = 'left:0;bottom:0;';
                                    break;
                                }

                                $sharedStyle .= '
                                    .overlay-id-'.$post_id.' .overlay-close{
                                        '.$position_css.'
                                    }
                                    .overlay-id-'.$post_id.' .standard-overlay-close-icon::before{
                                        color: '.$close_color.';
                                    }';
                        
                                $desktopStyle .= '
                                        .overlay-id-'.$post_id.' .standard-overlay-close-icon::before{
                                            font-size: '.$close_size.($close_size_mu == 'px' ? $close_size_mu : 'vw').';
                                        }
                                        .overlay-id-'.$post_id.' .overlay-close{
                                            '.$padding_css_desktop.'
                                        }
                                        .overlay-id-'.$post_id.' .custom-overlay-close-icon img{
                                            width: '.$custom_close_icon_width.($custom_close_icon_width_mu == 'px' ? $custom_close_icon_width_mu : 'vw').';
                                        }';
                                $mobileStyle .='
                                        .overlay-id-'.$post_id.' .standard-overlay-close-icon::before{
                                            font-size: '.$close_size_phone.($close_size_phone_mu == 'px' ? $close_size_phone_mu : 'vw').';
                                        }
                                        .overlay-id-'.$post_id.' .overlay-close{
                                            '.$padding_css_phone.'
                                        }
                                        .overlay-id-'.$post_id.' .custom-overlay-close-icon img{
                                            width: '.$custom_close_phone_icon_width.($custom_close_phone_icon_width_mu == 'px' ? $custom_close_phone_icon_width_mu : 'vw').';
                                        }';
                            } else {
                                $sharedStyle .= '
                                    .overlay-id-'.$post_id.' .overlay-close{
                                        display: none;
                                    }';
                            }

                            $desktopStyle .='
                                    .overlay-id-'.$post_id.'{
                                        width:'.$overlay_width.$overlay_width_mu.';
                                    }';
                                
                            $mobileStyle .= '
                                    .overlay-id-'.$post_id.'{
                                        width:'.$overlay_phone_width.$overlay_phone_width_mu.';
                                    }
                                ';
                            
                            // note: '<div>'.$close_markup.'</div>'
                            // wrapping $close_markup into another div, so position fixed inside position fixed works: https://codepen.io/andreasmb/pen/LpEmgj?css-preprocessor=less
                            $overlay_markups .= 
                            '<div class="lay-overlay lay-'.$array['overlay_animation'].' lay-phone-'.$array['overlay_phone_animation'].' overlay-id-'.$post_id.'" data-link="'.get_permalink($post_id).'" data-disable-scroll="'.$disable_scroll.'">'.$layout['markup']
                                .'<div>'.$close_markup.'</div>'
                            .'</div>';
                            
                            $style_active = array_key_exists('style_active', $array) ? $array['style_active'] : '';
                            if( $style_active == 'on' ) {

                                $active_color = array_key_exists('active_color', $array) ? $array['active_color'] : '#000000';
                                $active_opacity = array_key_exists('active_opacity', $array) ? $array['active_opacity'] : 100;                        

                                $sharedStyle .= '.overlay-id-'.$post_id.' a.current-link, .overlay-id-'.$post_id.' li.current-lang a {
                                        opacity: '.((int)$active_opacity/100).'!important;
                                        color: '.$active_color.'!important;
                                    }';
                            }

                            $background = array_key_exists('background', $array) ? $array['background'] : '';
                            $background_opacity = array_key_exists('background_opacity', $array) ? $array['background_opacity'] : 20;
                            $background_color = array_key_exists('background_color', $array) ? $array['background_color'] : '#ffffff';
                            
                            $rgb = CSS_Output::hex2rgb($background_color);
                            $alpha = (int)$background_opacity;
                            $alpha /= 100;
                            if($alpha < 0){ $alpha = 0; }
                            else if($alpha > 1){ $alpha = 1; }                    
                            $background_blur = array_key_exists('background_blur', $array) ? $array['background_blur'] : 0;
                            
                            $style = '';
                            if( $background == 'on' ) {
                                $style = 'background-color:rgba('.$rgb['red'].','.$rgb['green'].','.$rgb['blue'].','.$alpha.');';
                                if( $background_blur != 0 ) {
                                    $style .= 'backdrop-filter:blur('.$background_blur.'px);-webkit-backdrop-filter:blur('.$background_blur.'px);';
                                }
                            }
                            
                            if( $background == 'on' ) {
                                $overlay_markups .= '<div class="lay-overlay-bg overlay-bg-id-'.$post_id.'" style="'.$style.'" data-link="'.get_permalink($post_id).'"></div>';
                            }
                            
                            $burger_color = array_key_exists('burger_color', $array) ? $array['burger_color'] : '#000000';
                            $burger_size = array_key_exists('burger_size', $array) ? $array['burger_size'] : 26;
                            $burger_size_mu = array_key_exists('burger_size_mu', $array) ? $array['burger_size_mu'] : 'px';

                            $burger_padding = array_key_exists('burger_padding', $array) ? $array['burger_padding'] : 20;
                            $burger_padding_mu = array_key_exists('burger_padding_mu', $array) ? $array['burger_padding_mu'] : 'px';

                            $burger_position = array_key_exists('burger_position', $array) ? $array['burger_position'] : 'topright';
                            $hide_burger_on_phone = array_key_exists('hide_burger_on_phone', $array) ? $array['hide_burger_on_phone'] : '';
                            $burger_size_phone = array_key_exists('burger_size_phone', $array) ? $array['burger_size_phone'] : 20;
                            $burger_size_phone_mu = array_key_exists('burger_size_phone_mu', $array) ? $array['burger_size_phone_mu'] : 'px';

                            $burger_padding_phone = array_key_exists('burger_padding_phone', $array) ? $array['burger_padding_phone'] : 15;
                            $burger_padding_phone_mu = array_key_exists('burger_padding_phone_mu', $array) ? $array['burger_padding_phone_mu'] : 'px';

                            if( $overlay_burger == 'on' ) {
                                $use_custom_burger_icon = array_key_exists('use_custom_burger_icon', $array) ? $array['use_custom_burger_icon'] : '';
                                $custom_burger_icon_width = array_key_exists('custom_burger_icon_width', $array) ? $array['custom_burger_icon_width'] : 40;
                                $custom_burger_icon_width_mu = array_key_exists('custom_burger_icon_width_mu', $array) ? $array['custom_burger_icon_width_mu'] : 'px';

                                $custom_burger_phone_icon_width = array_key_exists('custom_burger_phone_icon_width', $array) ? $array['custom_burger_phone_icon_width'] : 30;
                                $custom_burger_phone_icon_width_mu = array_key_exists('custom_burger_phone_icon_width_mu', $array) ? $array['custom_burger_phone_icon_width_mu'] : 'px';

                                $custom_burger_icon = array_key_exists('custom_burger_icon', $array) ? $array['custom_burger_icon'] : '';
                                $custom_burger_icon_img_src = '';
                                if($custom_burger_icon != ''){
                                    $custom_burger_icon_img_src = wp_get_attachment_image_src( $custom_burger_icon, 'full' );
                                    if(is_array($custom_burger_icon_img_src)) {
                                        $custom_burger_icon_img_src = $custom_burger_icon_img_src[0];
                                    }
                                }

                                if( $use_custom_burger_icon == 'on' ) {
                                    $overlay_markups .= '<a rel="nofollow" class="overlay-burger custom-overlay-burger burger-overlay-id-'.$post_id.'" href="'.get_permalink($post_id).'" data-type="page" data-id="'.$post_id.'">
                                        <img src="'.$custom_burger_icon_img_src.'" alt="">
                                    </a>';
                                } else {
                                    $overlay_markups .= '<a rel="nofollow" class="overlay-burger standard-overlay-burger burger-overlay-id-'.$post_id.'" href="'.get_permalink($post_id).'" data-type="page" data-id="'.$post_id.'"></a>';
                                }


                                $sharedStyle .= '
                                    .burger-overlay-id-'.$post_id.'.overlay-burger{
                                        '.($burger_position == 'topright' ? 'right:0;' : 'left:0;').'
                                    }
                                    .burger-overlay-id-'.$post_id.'.standard-overlay-burger::before{
                                        color: '.$burger_color.';
                                    }';
                        
                                $desktopStyle .= '
                                        .burger-overlay-id-'.$post_id.'.standard-overlay-burger::before{
                                            font-size: '.$burger_size.($burger_size_mu == 'px' ? $burger_size_mu : 'vw').';
                                        }
                                        .burger-overlay-id-'.$post_id.'.custom-overlay-burger img{
                                            width: '.$custom_burger_icon_width.($custom_burger_icon_width_mu == 'px' ? $custom_burger_icon_width_mu : 'vw').';
                                        }
                                        .burger-overlay-id-'.$post_id.'.overlay-burger{
                                            padding: '.$burger_padding.($burger_padding_mu == 'px' ? $burger_padding_mu : 'vw').';
                                        }';
                                    
                                $mobileStyle .=     
                                        '.burger-overlay-id-'.$post_id.'.standard-overlay-burger::before{
                                            font-size: '.$burger_size_phone.($burger_size_phone_mu == 'px' ? $burger_size_phone_mu : 'vw').';
                                        }
                                        .burger-overlay-id-'.$post_id.'.custom-overlay-burger img{
                                            width: '.$custom_burger_phone_icon_width.($custom_burger_phone_icon_width_mu == 'px' ? $custom_burger_phone_icon_width_mu : 'vw').';
                                        }
                                        .burger-overlay-id-'.$post_id.'.overlay-burger{
                                            padding: '.$burger_padding_phone.($burger_padding_phone_mu == 'px' ? $burger_padding_phone_mu : 'vw').';
                                        }
                                        '.($hide_burger_on_phone == 'on' ? '.burger-overlay-id-'.$post_id.'.overlay-burger{display:none;}' : '').'
                                    ';
                            }

                        }

                    }
                }

                if( $overlay_markups != '') {
                    $overlay_markups .= '<style>
                        '.$sharedStyle.'
                    @media (min-width: '.($breakpoint+1).'px){
                        '.$desktopStyle.'
                    }
                    @media (max-width: '.($breakpoint).'px){
                        '.$mobileStyle.'
                    }
                </style>';
                }

                return $overlay_markups;
            }

        }
        return '';
    }

}

new Lay_Overlays();