<div class="wrap">
    <h2><?php _e('Gridder Defaults', 'lay') ?></h2>

    <?php if(isset( $_GET['settings-updated'])) {
        $gridder_apply = get_option('gridder_apply', '');
        if($gridder_apply == "gridder_apply_all"){
            GridderOptions::applyDesktopDefaultsToAllExistingGrids(true);
        }
        else if($gridder_apply == "gridder_apply_all_but_row"){
            GridderOptions::applyDesktopDefaultsToAllExistingGrids(false);
        }

        $phone_gridder_apply = get_option('phone_gridder_apply', '');
        if($phone_gridder_apply == "phone_gridder_apply_all"){
            GridderOptions::applyPhoneDefaultsToAllExistingGrids(true);
        }
        else if($phone_gridder_apply == "phone_gridder_apply_all_but_row"){
            GridderOptions::applyPhoneDefaultsToAllExistingGrids(false);
        }

        if($phone_gridder_apply != "on" && $gridder_apply != "on"){
            echo '<div class="updated"><p>Gridder Defaults saved.</p></div>';
        }
    } ?>
    
    <div class="lay-explanation <?php echo get_option('expand-how_to_use_gridder_defaults', 'expanded'); ?>" data-expand-status-option-name="expand-how_to_use_gridder_defaults">
        <header>
            <h3 class="title"><?php _e('How to use', 'lay') ?></h3>
            <button class="lay-explanation-handle"></button>
        </header>
        <div class="lay-explanation-inner">
        	<p><?php _e('The "Gridder" is the interface you see when you create layouts for Projects, Pages or Categories.', 'lay') ?></p>
        	<p><?php _e('If you check "Apply Desktop Gridder Defaults" and click', 'lay') ?> <span class="lay-label label-info"><?php _e('Save Changes', 'lay') ?></span> <?php _e('these defaults (except for Column Count) will be applied to all Grids of existing Projects, Pages and Categories.', 'lay') ?></p>
            <?php
                $misc_options_extra_gridder_for_phone = get_option('misc_options_extra_gridder_for_phone', 'on');
                if($misc_options_extra_gridder_for_phone == "on"){
                    ?>
                    <p><?php _e('The Custom Phone Layout Gridder Defaults only apply to custom phone layouts created with the', 'lay') ?> <span style="border-radius:2px;border: 1px solid #ccc;color:#333;background-color:#fff;display:inline;padding:4px 10px;"><span class="dashicons dashicons-smartphone"></span></span> <?php _e('phone button in the Gridder.', 'lay') ?> <?php _e('For automatically generated phone layouts please set the values in "Customize" &rarr; "Mobile" &rarr; "Mobile Spaces".', 'lay') ?></p>
                    <?php
                }
            ?>
        </div>
    </div>

	<form method="POST" action="options.php">

    <div class="lay-tabs">
        <div class="lay-tabs-tabs">
            <span class="lay-tab-active"><?php _e('Desktop Layout Gridder Defaults', 'lay') ?></span>
            <span><?php _e('Custom Phone Layout Gridder Defaults', 'lay') ?></span>
            <span><?php _e('Spaces and Offsets', 'lay') ?></span>
            <span><?php _e('Horizontal Grid Defaults', 'lay') ?></span>
            <span><?php _e('Sticky Top Default', 'lay') ?></span>
        </div>
        <div class="lay-tabs-content-wrap">
            <div class="lay-tab-content lay-tab-content-active">
                <div class="lay-modal-input-row">
                    <p style="text-align: left;"><?php _e('These are default values for the Layout Tool "Gridder":', 'lay') ?></p>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Column Count', 'lay') ?></div>
                    <select name="layui_gridder_defaults_columncount" id="layui_gridder_defaults_columncount">
                        <?php
                        for($i = 1; $i <= 31; $i++){
                            echo '<option value="'.$i.'">'.$i.'</option>';
                        }
                        ?>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Column Gutter', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_gridder_defaults_column_gutter" id="layui_gridder_defaults_column_gutter"/>
                    <select name="layui_gridder_defaults_column_gutter_mu" id="layui_gridder_defaults_column_gutter_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Row Gutter', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_gridder_defaults_row_gutter" id="layui_gridder_defaults_row_gutter"/>
                    <select name="layui_gridder_defaults_rowgutter_mu" id="layui_gridder_defaults_rowgutter_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>         
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Frame Top', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_gridder_defaults_topframe" id="layui_gridder_defaults_topframe"/>
                    <select name="layui_gridder_defaults_topframe_mu" id="layui_gridder_defaults_topframe_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Frame Left', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_gridder_defaults_frame_left" id="layui_gridder_defaults_frame_left"/>
                    <select name="layui_gridder_defaults_frame_mu" id="layui_gridder_defaults_frame_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Frame Right', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_gridder_defaults_frame_right" id="layui_gridder_defaults_frame_right"/>
                    <select name="layui_gridder_defaults_frame_mu" id="layui_gridder_defaults_frame_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Frame Bottom', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_gridder_defaults_bottomframe" id="layui_gridder_defaults_bottomframe"/>
                    <select name="layui_gridder_defaults_bottomframe_mu" id="layui_gridder_defaults_bottomframe_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
            </div>
            <div class="lay-tab-content">
                <p style="text-align:left;">
                    <?php _e('These are default values for the', 'lay') ?> <a href="https://laytheme.com/documentation/custom-phone-layouts.html" target="_blank"><?php _e('Custom Phone Layout Gridder', 'lay') ?>:</a>
                </p>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Column Count', 'lay') ?></div>
                    <select name="layui_phone_gridder_defaults_columncount" id="layui_phone_gridder_defaults_columncount">
                        <?php
                        for($i = 1; $i <= 31; $i++){
                            echo '<option value="'.$i.'">'.$i.'</option>';
                        }
                        ?>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Column Gutter', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_phone_gridder_defaults_column_gutter" id="layui_phone_gridder_defaults_column_gutter"/>
                    <select name="layui_phone_gridder_defaults_column_gutter_mu" id="layui_phone_gridder_defaults_column_gutter_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Row Gutter', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_phone_gridder_defaults_row_gutter" id="layui_phone_gridder_defaults_row_gutter"/>
                    <select name="layui_phone_gridder_defaults_rowgutter_mu" id="layui_phone_gridder_defaults_rowgutter_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>         
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Frame Top', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_phone_gridder_defaults_topframe" id="layui_phone_gridder_defaults_topframe"/>
                    <select name="layui_phone_gridder_defaults_topframe_mu" id="layui_phone_gridder_defaults_topframe_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Frame Left', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_phone_gridder_defaults_frame_left" id="layui_phone_gridder_defaults_frame_left"/>
                    <select name="layui_phone_gridder_defaults_frame_mu" id="layui_phone_gridder_defaults_frame_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Frame Right', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_phone_gridder_defaults_frame_right" id="layui_phone_gridder_defaults_frame_right"/>
                    <select name="layui_phone_gridder_defaults_frame_mu" id="layui_phone_gridder_defaults_frame_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Frame Bottom', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_phone_gridder_defaults_bottomframe" id="layui_phone_gridder_defaults_bottomframe"/>
                    <select name="layui_phone_gridder_defaults_bottomframe_mu" id="layui_phone_gridder_defaults_bottomframe_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
            </div>
            <div class="lay-tab-content">
                <div class="lay-modal-input-row">
                    <p style="text-align: left;"><?php _e('In the Gridder, when you right click an element you can change it\'s offset and space top/bottom.', 'lay') ?><br/><?php _e('These are the defaults for these settings:', 'lay') ?></p>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Spaces in', 'lay') ?></div>
                    <select name="layui_gridder_spaces_mu" id="layui_gridder_spaces_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Offsets in', 'lay') ?></div>
                    <select name="layui_gridder_offsets_mu" id="layui_gridder_offsets_mu">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
            </div>
            <div class="lay-tab-content">
                <div class="lay-modal-input-row">
                    <p style="text-align: left;"><?php _e('In the Gridder, when you click "Horizontal Grid" in the top bar you activate <a href="https://laytheme.com/documentation/horizontal-grid.html" target="_blank">this certain layout mode</a>.', 'lay') ?><br/><?php _e('This is a setting for that mode:', 'lay') ?></p>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Space', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_gridder_horizontalgrid_space_default" id="layui_gridder_horizontalgrid_space_default"/>
                    <select name="layui_gridder_horizontalgrid_space_in_default" id="layui_gridder_horizontalgrid_space_in_default">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
            </div>
            <div class="lay-tab-content">
                <div class="lay-modal-input-row">
                    <p style="text-align: left;"><?php _e('Default value for when you right click an element and choose "Make Sticky" in the Gridder:', 'lay') ?></p>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title"><?php _e('Space', 'lay') ?></div>
                    <input type="number" min="0" max="" step="0.1" name="layui_gridder_stickytop_default" id="layui_gridder_stickytop_default"/> px
                </div>
            </div>
        </div>
    </div>


	<?php settings_fields( 'manage-gridderdefaults' );	//pass slug name of page, also referred
	                                        //to in Settings API as option group name
	do_settings_sections( 'manage-gridderdefaults' ); 	//pass slug name of page
    ?>

    <?php  
    submit_button();
	?>

<script>
        // get ids
        var inputIds = []
        var selectIds = []
        // set initial values
        jQuery('.lay-modal-input-row input').each(function(){
            var id = jQuery(this).attr('id');
            inputIds.push('#'+id)
            id = id.replace('layui_', '');
            var val = jQuery('input#'+id).val();
            jQuery(this).val(val);
        })
        jQuery('.lay-modal-input-row select').each(function(){
            var id = jQuery(this).attr('id');
            selectIds.push('#'+id)
            id = id.replace('layui_', '');
            var val = jQuery('select#'+id).val();
            jQuery(this).val(val);
        })
        // update values
        jQuery(selectIds.join(', ')).each(function(){
            jQuery(this).on('change', function(){
                var id = jQuery(this).attr('id')
                jQuery('#'+id.replace('layui_', '')).val(this.value)

                // make sure frameleft and frameright MU are always the same
                if(id == 'layui_gridder_defaults_frame_mu'){
                    jQuery('select[name="layui_gridder_defaults_frame_mu"').val(this.value)
                }
                else if(id == 'layui_phone_gridder_defaults_frame_mu'){
                    jQuery('select[name="layui_phone_gridder_defaults_frame_mu"').val(this.value)
                }
            })
        })
        jQuery(inputIds.join(', ')).each(function(){
            jQuery(this).on('input', function(){
                var id = jQuery(this).attr('id')
                jQuery('#'+id.replace('layui_', '')).val(this.value)
            })
        })


        // tabs
        jQuery('.lay-tabs').each(function(){
            var $tabswrap = jQuery(this);
            jQuery(this).find('.lay-tabs-tabs span').click(function(){
                var ix = jQuery(this).index()
                $tabswrap.find('.lay-tabs-tabs span.lay-tab-active').removeClass('lay-tab-active')
                $tabswrap.find('.lay-tabs-tabs span').eq(ix).addClass('lay-tab-active')
                $tabswrap.find('.lay-tab-content.lay-tab-content-active').removeClass('lay-tab-content-active')
                $tabswrap.find('.lay-tab-content').eq(ix).addClass('lay-tab-content-active')
            })
        })

          
    </script>

	</form>
</div>