<?php
class OverlayMetabox{

	public function __construct(){

		$val = get_option('misc_options_activate_overlay_feature', '');
		if($val == "on" && !MiscOptions::$locked){	
            add_action( 'add_meta_boxes_page', array($this, 'add_metabox_to_pages') );
            add_action( 'save_post', array( $this, 'save_page' ) );

            add_filter('manage_pages_columns', array($this, 'add_custom_meta_column'), 10, 1);
            add_action('manage_pages_custom_column',array($this, 'show_custom_meta_column'), 10, 2);
		}
		
	}

    public function add_custom_meta_column($columns) {
        foreach ($columns as $key => $value) {
            $new_columns[$key] = $value;
    
            if ($key === 'title') {
                // Insert our custom column after the Title column
                $new_columns['page_overlay_info'] = __('Is Page Overlay', 'lay');
            }
        }

        return $new_columns;
    }
    public function show_custom_meta_column($column_name, $post_id) {
        if ($column_name == 'page_overlay_info') {

            $array = get_post_meta($post_id, 'overlay_settings');
            if( is_array($array) && array_key_exists(0, $array) ) {
                $array = $array[0];
            }
            $use_as_overlay = array_key_exists('use_as_overlay', $array) ? $array['use_as_overlay'] : '';
            if($use_as_overlay == 'on'){
                echo '<span class="dashicons dashicons-yes"></span>';
            }
        }
    }

	public function add_metabox_to_pages() {
		add_meta_box( 'overlay_settings', 'Overlay', array($this, 'render_meta_box'), 'page', 'side', 'core', array('metabox_location'=>'page') );
	}

	public function render_meta_box( $post, $metabox ) {
		// Add a nonce field so we can check for it later.
		wp_nonce_field( 'overlay', 'overlay_nonce' );


        $array = get_post_meta($post->ID, 'overlay_settings');
        if( is_array($array) && array_key_exists(0, $array) ) {
            $array = $array[0];
        }

        $use_as_overlay = array_key_exists('use_as_overlay', $array) ? $array['use_as_overlay'] : '';
        $overlay_animation = array_key_exists('overlay_animation', $array) ? $array['overlay_animation'] : 'slide-from-top';
        $overlay_phone_animation = array_key_exists('overlay_phone_animation', $array) ? $array['overlay_phone_animation'] : 'slide-from-top';

        $overlay_width = array_key_exists('overlay_width', $array) ? $array['overlay_width'] : '100';
        $overlay_width_mu = array_key_exists('overlay_width_mu', $array) ? $array['overlay_width_mu'] : '%';
        
        $overlay_phone_width = array_key_exists('overlay_phone_width', $array) ? $array['overlay_phone_width'] : '100';
        $overlay_phone_width_mu = array_key_exists('overlay_phone_width_mu', $array) ? $array['overlay_phone_width_mu'] : '%';

        $overlay_set_height = array_key_exists('overlay_set_height', $array) ? $array['overlay_set_height'] : '';
        $overlay_height = array_key_exists('overlay_height', $array) ? $array['overlay_height'] : '100';
        $overlay_height_mu = array_key_exists('overlay_height_mu', $array) ? $array['overlay_height_mu'] : '%';

        $background = array_key_exists('background', $array) ? $array['background'] : '';
        $background_opacity = array_key_exists('background_opacity', $array) ? $array['background_opacity'] : 20;
        $background_color = array_key_exists('background_color', $array) ? $array['background_color'] : '#ffffff';
        $background_blur = array_key_exists('background_blur', $array) ? $array['background_blur'] : 0;
        
        $close = array_key_exists('close', $array) ? $array['close'] : '';
        $close_position = array_key_exists('close_position', $array) ? $array['close_position'] : 'topright';
        $close_color = array_key_exists('close_color', $array) ? $array['close_color'] : '#000000';
        
        $close_padding = array_key_exists('close_padding', $array) ? $array['close_padding'] : 20;
        $close_padding_mu = array_key_exists('close_padding_mu', $array) ? $array['close_padding_mu'] : 'px';

        $close_size = array_key_exists('close_size', $array) ? $array['close_size'] : 40;
        $close_size_mu = array_key_exists('close_size_mu', $array) ? $array['close_size_mu'] : 'px';

        $close_padding_phone = array_key_exists('close_padding_phone', $array) ? $array['close_padding_phone'] : 15;
        $close_padding_phone_mu = array_key_exists('close_padding_phone_mu', $array) ? $array['close_padding_phone_mu'] : 'px';

        $close_size_phone = array_key_exists('close_size_phone', $array) ? $array['close_size_phone'] : 25;
        $close_size_phone_mu = array_key_exists('close_size_phone_mu', $array) ? $array['close_size_phone_mu'] : 'px';

        $overlay_burger = array_key_exists('overlay_burger', $array) ? $array['overlay_burger'] : '';
        $burger_position = array_key_exists('burger_position', $array) ? $array['burger_position'] : 'topright';
        $hide_burger_on_phone = array_key_exists('hide_burger_on_phone', $array) ? $array['hide_burger_on_phone'] : '';
        $burger_color = array_key_exists('burger_color', $array) ? $array['burger_color'] : '#000000';

        $burger_padding = array_key_exists('burger_padding', $array) ? $array['burger_padding'] : 20;
        $burger_padding_mu = array_key_exists('burger_padding_mu', $array) ? $array['burger_padding_mu'] : 'px';

        $burger_size = array_key_exists('burger_size', $array) ? $array['burger_size'] : 26;
        $burger_size_mu = array_key_exists('burger_size_mu', $array) ? $array['burger_size_mu'] : 'px';

        $burger_padding_phone = array_key_exists('burger_padding_phone', $array) ? $array['burger_padding_phone'] : 15;
        $burger_padding_phone_mu = array_key_exists('burger_padding_phone_mu', $array) ? $array['burger_padding_phone_mu'] : 'px';

        $burger_size_phone = array_key_exists('burger_size_phone', $array) ? $array['burger_size_phone'] : 20;
        $burger_size_phone_mu = array_key_exists('burger_size_phone_mu', $array) ? $array['burger_size_phone_mu'] : 'px';

        $style_active = array_key_exists('style_active', $array) ? $array['style_active'] : '';
        $active_color = array_key_exists('active_color', $array) ? $array['active_color'] : '#000000';
        $active_opacity = array_key_exists('active_opacity', $array) ? $array['active_opacity'] : 100;


        // https://gist.github.com/hlashbrooke/9267467#file-class-php-L324
        $custom_burger_icon = array_key_exists('custom_burger_icon', $array) ? $array['custom_burger_icon'] : '';
        $custom_burger_icon_img_src = Setup::$uri.'/options/assets/img/nofile_small.svg';
        $noimage_image = $custom_burger_icon_img_src;
        $hideCustomBurgerIconRemoveButtonCSS = '';
        if($custom_burger_icon != ''){
            $custom_burger_icon_img_src = wp_get_attachment_image_src( $custom_burger_icon, 'full' );
            if(is_array($custom_burger_icon_img_src)) {
                $custom_burger_icon_img_src = $custom_burger_icon_img_src[0];
            }
        }
        else{
            $hideCustomBurgerIconRemoveButtonCSS = 'style="display:none;"';
        }
        $custom_burger_icon_setting_name = 'custom_burger_icon';

        $use_custom_burger_icon = array_key_exists('use_custom_burger_icon', $array) ? $array['use_custom_burger_icon'] : '';
        $custom_burger_icon_width = array_key_exists('custom_burger_icon_width', $array) ? $array['custom_burger_icon_width'] : 40;
        $custom_burger_icon_width_mu = array_key_exists('custom_burger_icon_width_mu', $array) ? $array['custom_burger_icon_width_mu'] : 'px';

        $custom_burger_phone_icon_width = array_key_exists('custom_burger_phone_icon_width', $array) ? $array['custom_burger_phone_icon_width'] : 30;
        $custom_burger_phone_icon_width_mu = array_key_exists('custom_burger_phone_icon_width_mu', $array) ? $array['custom_burger_phone_icon_width_mu'] : 'px';

        // https://gist.github.com/hlashbrooke/9267467#file-class-php-L324
        $custom_close_icon = array_key_exists('custom_close_icon', $array) ? $array['custom_close_icon'] : '';
        $custom_close_icon_img_src = Setup::$uri.'/options/assets/img/nofile_small.svg';
        $noimage_image = $custom_close_icon_img_src;
        $hideCustomCloseIconRemoveButtonCSS = '';
        if($custom_close_icon != ''){
            $custom_close_icon_img_src = wp_get_attachment_image_src( $custom_close_icon, 'full' );
            if(is_array($custom_close_icon_img_src)){
                $custom_close_icon_img_src = $custom_close_icon_img_src[0];
            }
        }
        else{
            $hideCustomCloseIconRemoveButtonCSS = 'style="display:none;"';
        }
        $custom_close_icon_setting_name = 'custom_close_icon';

        $use_custom_close_icon = array_key_exists('use_custom_close_icon', $array) ? $array['use_custom_close_icon'] : '';
        $close_type = array_key_exists('close_type', $array) ? $array['close_type'] : '';
        if($use_custom_close_icon == "on") {
            $close_type = 'custom';
        }

        $lay_overlay_close_text = array_key_exists('lay_overlay_close_text', $array) ? $array['lay_overlay_close_text'] : 'close';

        $custom_close_icon_width = array_key_exists('custom_close_icon_width', $array) ? $array['custom_close_icon_width'] : 40;
        $custom_close_icon_width_mu = array_key_exists('custom_close_icon_width_mu', $array) ? $array['custom_close_icon_width_mu'] : 'px';

        $custom_close_phone_icon_width = array_key_exists('custom_close_phone_icon_width', $array) ? $array['custom_close_phone_icon_width'] : 30;
        $custom_close_phone_icon_width_mu = array_key_exists('custom_close_phone_icon_width_mu', $array) ? $array['custom_close_phone_icon_width_mu'] : 'px';
        
        $lay_overlay_close_textformat = array_key_exists('lay_overlay_close_textformat', $array) ? $array['lay_overlay_close_textformat'] : 'Default';
        $lay_overlay_close_formats_options = '';
        foreach (Customizer::$textformatsSelect as $format) {
            $selected = ($lay_overlay_close_textformat == $format) ? 'selected' : '';
            $lay_overlay_close_formats_options .= '<option value="'.$format.'" '.$selected.'>'.$format.'</option>';
        }

        $lay_disable_scroll = array_key_exists('lay_disable_scroll', $array) ? $array['lay_disable_scroll'] : 'on';

        $bg_color_palette = get_option( 'misc_options_colorpalette', '#000, #fff, #f00, #0f0, #00f, #ff0, #0ff, #f0f' );
        $bg_color_palette = Setup::turnTo6DigitHexString($bg_color_palette);
        // turn to array
        $bg_color_palette = explode( ',', $bg_color_palette );

        $color_palette_str = '[';
        foreach ( $bg_color_palette as $key => $value ) {
            $color_palette_str .= '"'.trim( $value ).'",';
        }
        $color_palette_str = rtrim( $color_palette_str, ',' );
        $color_palette_str .= ']';

        // Display the form, using the current value.
		echo '<style>
            #overlay_settings .accordion-title{
                cursor: default;
                padding: 10px 10px 10px 10px;
                position: relative;
            }
            #overlay_settings .accordion-title:hover{
                background: #f2f2f2;
            }
            #overlay_settings .accordion-title:hover::after{
                opacity: 1;
            }
            #overlay_settings .accordion-title::after{
                font: 400 20px/0 dashicons;
                content: "\f140";
                speak: none;
                display: inline;
                top: 5px;
                transform: rotateZ(180deg);
                right: 0;
                position: relative;
                -webkit-font-smoothing: antialiased;
                -moz-osx-font-smoothing: grayscale;
                text-decoration: none !important;
                opacity: 0.5;
            }
            #overlay_settings .accordion-box{
                display: grid;
                grid-template-rows: 0fr;
                transition: grid-template-rows 300ms;
            }
            #overlay_settings .accordion-box>div{
                overflow: hidden;
            }
            #overlay_settings .accordion-box>div>div{
                border-top: 1px solid #e5e5e5;
                padding: 10px;
            }
            #overlay_settings .accordion-show.accordion-box{
                grid-template-rows: 1fr;
            }
            #overlay_settings .accordion-title-active.accordion-title{
                background: #f2f2f2;
            }
            #overlay_settings .accordion-title-active.accordion-title::after{
                content: "\f142";
            }
            #overlay_settings input, 
            #overlay_settings select{
                margin: 0;
            }
            #overlay_settings input[type="checkbox"]{
                margin-right: 3px;
            }
            #overlay_settings .inside{
                padding: 0;
                margin-top: 10px;
            }
            #use_as_overlay:checked~.lay-overlay-settings{
                display: block;
            }
            .lay-overlay-settings{
                display: none;
            }
            #style_active:checked~.lay_overlay_active_settings{
                display: block;
            }
            .lay_overlay_active_settings{
                display: none;
            }
            .lay-overlay-settings>div{
                /* padding-left: 10px; */
                /* padding-right: 10px; */
            }
            .lay-overlay-settings input:not([type="checkbox"]),
            .lay-overlay-settings select{
                border-radius: 0;
                border-color: rgb(204, 204, 204);
            }
            #overlay_set_height:checked~.lay-overlay-height-setting{
                display: block;
            }
            .lay-overlay-height-setting{
                display: none;
            }
            #background:checked~.lay_overlay_background_settings{
                display: block;
            }
            .lay_overlay_background_settings{
                display: none;
            }
            #close:checked~.lay_overlay_close_settings{
                display: block;
            }
            .lay_overlay_close_settings{
                display: none;
            }
            #overlay_burger:checked~.lay_overlay_burger_settings{
                display: block;
            }
            .lay_overlay_burger_settings{
                display: none;
            }
            #use_custom_burger_icon:checked~.lay-custom-burger-icon-settings{
                display: block;
            }
            #use_custom_burger_icon:checked~.lay-standard-burger-icon-settings{
                display: none;
            }
            .lay-standard-burger-icon-settings{
                display: block;
            }
            .lay-custom-burger-icon-settings{
                display: none;
            }
            .lay-custom-close-icon-settings{
                display: none;
            }
            .lay-standard-close-icon-settings{
                display: block;
            }
            .color-rectangle {
                width: 30px;
                height: 30px;
                border: 1px solid rgb(204, 204, 204);
                display: inline-block;
                margin-right: 0;
                cursor: pointer;
                border-right: none;
                box-sizing: border-box;
            }
            .lay-overlay-one-line{
                display: flex;
                align-items: center;
            }
            #lay_overlay_background_color, #lay_overlay_close_color, #lay_overlay_active_color{
                padding: 0 5px;
                margin-left: 0;
            }
            #overlay_settings input:focus{
                outline: none!important;
                box-shadow: none!important;
            }
            .lay-overlay-settings input[type="number"]{
                -moz-appearance: textfield;
            }
            input::-webkit-outer-spin-button,
            input::-webkit-inner-spin-button{
                -webkit-appearance: none;
                margin: 0;
            }
            #overlay_settings .lay-rows-title{
                font-weight: 600 !important;
                padding-top: 15px;
                padding-bottom: 15px;
                display: none;
            }
            #overlay_settings label{
                display: block;
                margin-bottom: 1px;
            }
        </style>
        <input style="margin-left:10px;margin-bottom:10px;" type="checkbox" id="use_as_overlay" name="use_as_overlay" '.($use_as_overlay == 'on' ? 'checked' : '').'><label style="display:inline-block;margin-bottom:10px;" for="use_as_overlay">Use as Overlay</label>
        <div style="border-top:1px solid #e5e5e5;" class="lay-overlay-settings">
            <div class="accordion-title">Animation & Width</div>
            <div class="accordion-box">
                <div><div>
                    <label for="overlay_animation">Animation</label>
                    <select name="overlay_animation" style="width:165px;">
                        <option '.($overlay_animation == 'none' ? 'selected' : '').' value="none">No Animation</option>
                        <option '.($overlay_animation == 'fade' ? 'selected' : '').' value="fade">Fade</option>
                        <option '.($overlay_animation == 'slide-from-top' ? 'selected' : '').' value="slide-from-top">Slide in from top</option>
                        <option '.($overlay_animation == 'slide-from-left' ? 'selected' : '').' value="slide-from-left">Slide in from left</option>
                        <option '.($overlay_animation == 'slide-from-right' ? 'selected' : '').' value="slide-from-right">Slide in from right</option>
                        <option '.($overlay_animation == 'slide-from-bottom' ? 'selected' : '').' value="slide-from-bottom">Slide in from bottom</option>
                    </select>
                    <label for="overlay_phone_animation" style="margin-top:8px;">Phone Animation</label>
                    <select name="overlay_phone_animation" style="width:165px;">
                        <option '.($overlay_phone_animation == 'none' ? 'selected' : '').' value="none">No Animation</option>
                        <option '.($overlay_phone_animation == 'fade' ? 'selected' : '').' value="fade">Fade</option>
                        <option '.($overlay_phone_animation == 'slide-from-top' ? 'selected' : '').' value="slide-from-top">Slide in from top</option>
                        <option '.($overlay_phone_animation == 'slide-from-left' ? 'selected' : '').' value="slide-from-left">Slide in from left</option>
                        <option '.($overlay_phone_animation == 'slide-from-right' ? 'selected' : '').' value="slide-from-right">Slide in from right</option>
                        <option '.($overlay_phone_animation == 'slide-from-bottom' ? 'selected' : '').' value="slide-from-bottom">Slide in from bottom</option>
                    </select>
                    <div style="margin-top:8px;">
                        <label for="overlay_width">Width</label>
                        <input name="overlay_width" id="overlay_width" value="'.$overlay_width.'" style="width:110px;margin-right:3px;" type="number" min="0">
                        <select name="overlay_width_mu">
                            <option '.($overlay_width_mu == '%' ? 'selected' : '').' value="%">%</option>
                            <option '.($overlay_width_mu == 'px' ? 'selected' : '').' value="px">px</option>
                        </select>
                    </div>
                    <div style="margin-top:8px;">
                        <label for="overlay_phone_width">Phone Width</label>
                        <input name="overlay_phone_width" id="overlay_phone_width" value="'.$overlay_phone_width.'" style="width:110px;margin-right:3px;" type="number" min="0">
                        <select name="overlay_phone_width_mu">
                            <option '.($overlay_phone_width_mu == '%' ? 'selected' : '').' value="%">%</option>
                            <option '.($overlay_phone_width_mu == 'px' ? 'selected' : '').' value="px">px</option>
                        </select>
                    </div>
                    <!-- <input type="checkbox" id="overlay_set_height" name="overlay_set_height" '.($overlay_set_height == 'on' ? 'checked' : '').'><label for="overlay_set_height">Set Height</label>
                    <div style="margin-top:8px;" class="lay-overlay-height-setting">
                        <input name="overlay_height" id="overlay_height" value="'.$overlay_height.'" style="width:110px;margin-right:3px;" type="number" min="0">
                        <label for="overlay_height">Height</label>
                        <select name="overlay_height_mu">
                            <option '.($overlay_height_mu == '%' ? 'selected' : '').' value="%">%</option>
                            <option '.($overlay_height_mu == 'px' ? 'selected' : '').' value="px">px</option>
                        </select>
                    </div> -->
                </div></div>
            </div>
            <div style="border-top:1px solid #e5e5e5;">
                <div class="accordion-title">Burger Icon</div>
                <div class="accordion-box">
                    <div><div>
                        <input type="checkbox" id="overlay_burger" name="overlay_burger" '.($overlay_burger == 'on' ? 'checked' : '').'><label style="display:inline;" for="overlay_burger">Show Burger-Icon</label>
                        <div class="lay_overlay_burger_settings" style="margin-top:8px;">
                            <input type="checkbox" id="hide_burger_on_phone" name="hide_burger_on_phone" '.($hide_burger_on_phone == 'on' ? 'checked' : '').'><label for="hide_burger_on_phone" style="display:inline;">Hide on Phone</label>
                            <br/><i>You may want to hide your standard Mobile Menu in "Customize" &rarr; "Mobile (Smartphone)" &rarr; "Mobile Menu"</i>
                            <label for="burger_position" style="margin-top:8px;">Position</label>
                            <select name="burger_position" style="width:165px;margin-bottom:8px;">
                                <option '.($burger_position == 'topleft' ? 'selected' : '').' value="topleft">Top Left</option>
                                <option '.($burger_position == 'topright' ? 'selected' : '').' value="topright">Top Right</option>
                            </select><br/>
                            <input type="checkbox" id="use_custom_burger_icon" name="use_custom_burger_icon" '.($use_custom_burger_icon == 'on' ? 'checked' : '').'><label for="use_custom_burger_icon" style="display:inline;">Use Custom Burger Icon</label>
                            <div style="margin-top:8px;" class="lay-custom-burger-icon-settings">
                                <img id="'.$custom_burger_icon_setting_name.'_preview" style="max-width:50px;display:block;margin-bottom: 5px;" class="image_preview" data-noimagesrc="'.$noimage_image.'" src="'.$custom_burger_icon_img_src.'">
                                <input id="'.$custom_burger_icon_setting_name.'_button" style="margin-bottom: 5px;" type="button" class="image_upload_button button" value="Set image" />
                                <input id="'.$custom_burger_icon_setting_name.'_delete" '.$hideCustomBurgerIconRemoveButtonCSS.' type="button" class="image_delete_button button" value="Remove image" />
                                <input id="'.$custom_burger_icon_setting_name.'" class="image_data_field" type="hidden" name="'.$custom_burger_icon_setting_name.'" value="'.$custom_burger_icon.'"/>
                                <div style="margin-top: 3px;">
                                    <label for="custom_burger_icon_width">Icon Width</label>
                                    <input step="0.1" name="custom_burger_icon_width" id="custom_burger_icon_width" value="'.$custom_burger_icon_width.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                    <select name="custom_burger_icon_width_mu" id="custom_burger_icon_width_mu" value="'.$custom_burger_icon_width_mu.'" >
                                        <option value="px" '.($custom_burger_icon_width_mu == 'px' ? 'selected' : '').'>px</option>
                                        <option value="%" '.($custom_burger_icon_width_mu == '%' ? 'selected' : '').'>%</option>
                                    </select>
                                </div>
                                <div style="margin-top: 8px;">
                                    <label for="custom_burger_phone_icon_width">Phone Icon Width</label>
                                    <input step="0.1" name="custom_burger_phone_icon_width" id="custom_burger_phone_icon_width" value="'.$custom_burger_phone_icon_width.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                    <select name="custom_burger_phone_icon_width_mu" id="custom_burger_phone_icon_width_mu" value="'.$custom_burger_phone_icon_width_mu.'" >
                                        <option value="px" '.($custom_burger_phone_icon_width_mu == 'px' ? 'selected' : '').'>px</option>
                                        <option value="%" '.($custom_burger_phone_icon_width_mu == '%' ? 'selected' : '').'>%</option>
                                    </select>
                                </div>
                            </div>
                            <div class="lay-standard-burger-icon-settings">
                                <label for="lay_overlay_burger_color" style="margin-top:8px;">Icon Color</label>
                                <div class="lay-overlay-one-line">
                                    <div class="js-color-rectangle color-rectangle" style="background-color:'.$burger_color.';"></div><input name="burger_color" value="'.$burger_color.'" id="lay_overlay_burger_color" style="width:80px;margin-right:3px;" type="text">
                                </div>
                                <div style="margin-top:8px;" class="lay_overlay_burger_color_wrap"></div>
                                <div style="margin-top:8px;">
                                    <label for="burger_size">Icon Size</label>
                                    <input step="0.1" name="burger_size" id="burger_size" value="'.$burger_size.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                    <select name="burger_size_mu" id="burger_size_mu" value="'.$burger_size_mu.'" >
                                        <option value="px" '.($burger_size_mu == 'px' ? 'selected' : '').'>px</option>
                                        <option value="%" '.($burger_size_mu == '%' ? 'selected' : '').'>%</option>
                                    </select>
                                </div>
                                <div style="margin-top:8px;">
                                    <label for="burger_size_phone">Phone Icon Size</label>
                                    <input step="0.1" name="burger_size_phone" id="burger_size_phone" value="'.$burger_size_phone.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                    <select name="burger_size_phone_mu" id="burger_size_phone_mu" value="'.$burger_size_phone_mu.'" >
                                        <option value="px" '.($burger_size_phone_mu == 'px' ? 'selected' : '').'>px</option>
                                        <option value="%" '.($burger_size_phone_mu == '%' ? 'selected' : '').'>%</option>
                                    </select>
                                </div>
                            </div>
                            <div style="margin-top:8px;">
                                <label for="burger_padding">Space Around</label>
                                <input step="0.1" name="burger_padding" id="burger_padding" value="'.$burger_padding.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                <select name="burger_padding_mu" id="burger_padding_mu" value="'.$burger_padding_mu.'" >
                                    <option value="px" '.($burger_padding_mu == 'px' ? 'selected' : '').'>px</option>
                                    <option value="%" '.($burger_padding_mu == '%' ? 'selected' : '').'>%</option>
                                </select> 
                            </div>
                            <div style="margin-top:8px;">
                                <label for="burger_padding_phone">Phone Space Around</label>
                                <input step="0.1" name="burger_padding_phone" id="burger_padding_phone" value="'.$burger_padding_phone.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                <select name="burger_padding_phone_mu" id="burger_padding_phone_mu" value="'.$burger_padding_phone_mu.'" >
                                    <option value="px" '.($burger_padding_phone_mu == 'px' ? 'selected' : '').'>px</option>
                                    <option value="%" '.($burger_padding_phone_mu == '%' ? 'selected' : '').'>%</option>
                                </select> 
                            </div>
                        </div>
                    </div></div>
                </div>
            </div>
            <div style="border-top:1px solid #e5e5e5;">
                <div class="accordion-title">"X" Close Icon</div>
                <div class="accordion-box">
                    <div><div>
                        <input type="checkbox" id="close" name="close" '.($close == 'on' ? 'checked' : '').'><label style="display:inline;" for="close">Show "X" Close-Icon</label>
                        <div class="lay_overlay_close_settings" style="margin-top:8px;">
                            <label for="close_position" style="margin-top:8px;">Position</label>
                            <select name="close_position" style="width:165px;margin-bottom:8px;">
                                <option '.($close_position == 'topleft' ? 'selected' : '').' value="topleft">Top Left</option>
                                <option '.($close_position == 'topright' ? 'selected' : '').' value="topright">Top Right</option>
																<option '.($close_position == 'bottomleft' ? 'selected' : '').' value="bottomleft">Bottom Left</option>
                                <option '.($close_position == 'bottomright' ? 'selected' : '').' value="bottomright">Bottom Right</option>
                            </select>
                            <label for="close_type">Icon Type</label>
                            <select name="close_type" id="close_type" style="width:165px;">
                                <option '.($close_type == 'default' ? 'selected' : '').' value="default">Default Icon</option>
                                <option '.($close_type == 'custom' ? 'selected' : '').' value="custom">Custom Icon</option>
                                <option '.($close_type == 'text' ? 'selected' : '').' value="text">Text</option>
                            </select>
                            <div style="margin-top:8px;" class="lay-text-close-settings">
                                <label for="lay_overlay_close_text">Close Text</label>
                                <input style="width:165px;" id="lay_overlay_close_text" type="text" name="lay_overlay_close_text" value="'.$lay_overlay_close_text.'"/>
                                <label style="margin-top: 8px;" for="lay_overlay_close_textformat">Close Textformat</label>
                                <select style="width:165px;" id="lay_overlay_close_textformat" name="lay_overlay_close_textformat" value="'.$lay_overlay_close_textformat.'">'
                                    .$lay_overlay_close_formats_options.
                                '</select>
                            </div>
                            <div style="margin-top:8px;" class="lay-custom-close-icon-settings">
                                <img id="'.$custom_close_icon_setting_name.'_preview" style="max-width:50px;display:block;margin-bottom: 5px;" class="image_preview" data-noimagesrc="'.$noimage_image.'" src="'.$custom_close_icon_img_src.'">
                                <input id="'.$custom_close_icon_setting_name.'_button" style="margin-bottom: 5px;" type="button" class="image_upload_button button" value="Set image" />
                                <input id="'.$custom_close_icon_setting_name.'_delete" '.$hideCustomCloseIconRemoveButtonCSS.' type="button" class="image_delete_button button" value="Remove image" />
                                <input id="'.$custom_close_icon_setting_name.'" class="image_data_field" type="hidden" name="'.$custom_close_icon_setting_name.'" value="'.$custom_close_icon.'"/>
                                <div style="margin-top: 3px;">
                                    <label for="custom_close_icon_width">Icon Width</label>
                                    <input name="custom_close_icon_width" id="custom_close_icon_width" value="'.$custom_close_icon_width.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                    <select name="custom_close_icon_width_mu" id="custom_close_icon_width_mu" value="'.$custom_close_icon_width_mu.'" >
                                        <option value="px" '.($custom_close_icon_width_mu == 'px' ? 'selected' : '').'>px</option>
                                        <option value="%" '.($custom_close_icon_width_mu == '%' ? 'selected' : '').'>%</option>
                                    </select>
                                </div>
                                <div style="margin-top: 8px;">
                                    <label for="custom_close_phone_icon_width">Phone Icon Width</label>
                                    <input name="custom_close_phone_icon_width" id="custom_close_phone_icon_width" value="'.$custom_close_phone_icon_width.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                    <select name="custom_close_phone_icon_width_mu" id="custom_close_phone_icon_width_mu" value="'.$custom_close_phone_icon_width_mu.'" >
                                        <option value="px" '.($custom_close_phone_icon_width_mu == 'px' ? 'selected' : '').'>px</option>
                                        <option value="%" '.($custom_close_phone_icon_width_mu == '%' ? 'selected' : '').'>%</option>
                                    </select>
                                </div>
                            </div>
                            <div class="lay-standard-close-icon-settings">
                                <label for="lay_overlay_close_color" style="margin-top:8px;"> Icon Color</label>
                                <div class="lay-overlay-one-line">
                                    <div class="js-color-rectangle color-rectangle" style="background-color:'.$close_color.';"></div><input name="close_color" value="'.$close_color.'" id="lay_overlay_close_color" style="width:80px;margin-right:3px;" type="text">
                                </div>
                                <div style="margin-top:8px;" class="lay_overlay_close_color_wrap"></div>
                                <div style="margin-top:8px;">
                                    <label for="close_size">Icon Size</label>
                                    <input step="0.1" name="close_size" id="close_size" value="'.$close_size.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                    <select name="close_size_mu" id="close_size_mu" value="'.$close_size_mu.'" >
                                        <option value="px" '.($close_size_mu == 'px' ? 'selected' : '').'>px</option>
                                        <option value="%" '.($close_size_mu == '%' ? 'selected' : '').'>%</option>
                                    </select>
                                </div>
                                <div style="margin-top:8px;">
                                    <label for="close_size_phone">Phone Icon Size</label>
                                    <input step="0.1" name="close_size_phone" id="close_size_phone" value="'.$close_size_phone.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                    <select name="close_size_phone_mu" id="close_size_phone_mu" value="'.$close_size_phone_mu.'" >
                                        <option value="px" '.($close_size_phone_mu == 'px' ? 'selected' : '').'>px</option>
                                        <option value="%" '.($close_size_phone_mu == '%' ? 'selected' : '').'>%</option>
                                    </select>
                                </div>
                            </div>
                            <div style="margin-top:8px;">
                                <label for="close_padding">Space Around</label>
                                <input step="0.1" name="close_padding" id="close_padding" value="'.$close_padding.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                <select name="close_padding_mu" id="close_padding_mu" value="'.$close_padding_mu.'" >
                                    <option value="px" '.($close_padding_mu == 'px' ? 'selected' : '').'>px</option>
                                    <option value="%" '.($close_padding_mu == '%' ? 'selected' : '').'>%</option>
                                </select>
                            </div>
                            <div style="margin-top:8px;">
                                <label for="close_padding_phone">Phone Space Around</label>
                                <input step="0.1" name="close_padding_phone" id="close_padding_phone" value="'.$close_padding_phone.'" style="width:110px;margin-right:3px;" type="number" min="0">
                                <select name="close_padding_phone_mu" id="close_padding_phone_mu" value="'.$close_padding_phone_mu.'" >
                                    <option value="px" '.($close_padding_phone_mu == 'px' ? 'selected' : '').'>px</option>
                                    <option value="%" '.($close_padding_phone_mu == '%' ? 'selected' : '').'>%</option>
                                </select> 
                            </div>
                        </div>
                    </div></div>
                </div>
            </div>
            <div style="border-top:1px solid #e5e5e5;">
                <div class="accordion-title">Style Active Links in Overlay</div>
                <div class="accordion-box">
                    <div><div>
                        <input type="checkbox" id="style_active" name="style_active" '.($style_active == 'on' ? 'checked' : '').'><label for="style_active" style="display:inline;">Style Active Links in Overlay</label>
                        <div class="lay_overlay_active_settings" style="margin-top:8px;">
                            <label for="lay_overlay_active_color" style="margin-top:8px;">Active Color</label>    
                            <div class="lay-overlay-one-line">
                                <div class="js-color-rectangle color-rectangle" style="background-color:'.$active_color.';"></div><input name="active_color" value="'.$active_color.'" id="lay_overlay_active_color" style="width:80px;margin-right:3px;" type="text"> 
                            </div>
                            <div style="margin-top:8px;" class="lay_overlay_active_color_wrap"></div>
                            <div style="margin-top:8px;">
                                <label for="active_opacity">Active Opacity</label>
                                <input name="active_opacity" id="active_opacity" value="'.$active_opacity.'" style="width:110px;margin-right:3px;" type="number" min="0" max="100">% 
                            </div>
                            <div style="margin-top:8px;">For custom styling use CSS Selector:</div>
                            <pre style="margin: 8px 0 0 0;"><code style="font-size:12px;">.overlay-id-'.$post->ID.' a.current-link{}</code></pre>
                        </div>
                    </div></div>
                </div>
            </div>
            <div style="border-top:1px solid #e5e5e5;">
                <div class="accordion-title">Background next to Overlay</div>
                <div class="accordion-box">
                    <div><div>
                        <input type="checkbox" id="background" name="background" '.($background == 'on' ? 'checked' : '').'><label style="display:inline;" for="background">Show Background</label>
                        <div style="color:gray;margin-top:8px;"><i>This is for the background next to the overlay, if your overlay doesn\'t have a width of 100%</i></div>
                        <div class="lay_overlay_background_settings" style="margin-top:8px;">
                            <label for="background_opacity">Background Opacity</label>
                            <input name="background_opacity" id="background_opacity" value="'.$background_opacity.'" style="width:110px;margin-right:3px;" type="number" min="0" max="100">%
                            <label for="lay_overlay_background_color" style="margin-top:8px;"> Background Color</label>
                            <div class="lay-overlay-one-line">
                                <div class="js-color-rectangle color-rectangle" style="background-color:'.$background_color.';"></div><input name="background_color" value="'.$background_color.'" id="lay_overlay_background_color" style="width:80px;margin-right:3px;" type="text">
                            </div>
                            <div style="margin-top:8px;" class="lay_overlay_background_color_wrap"></div>
                            <div style="margin-top:8px;">
                                <label for="background_blur">Background Blur</label>
                                <input name="background_blur" id="background_blur" value="'.$background_blur.'" style="width:110px;margin-right:3px;" type="number" min="0" max="100">px 
                            </div>
                        </div>
                    </div></div>
                </div>
            </div>
            <div style="border-top:1px solid #e5e5e5;">
                <div class="accordion-title">Other</div>
                <div class="accordion-box">
                    <div><div>
                        <input type="checkbox" id="lay_disable_scroll" name="lay_disable_scroll" '.($lay_disable_scroll == 'on' ? 'checked' : '').'><label for="lay_disable_scroll" style="display:inline;">Disable scrolling of website when overlay is opened (recommended)</label>
                    </div></div>
                </div>
            </div>
            <script>
                var onCloseTypeChange = function() {
                    var $option = jQuery("select#close_type").find("option:selected");
                    var value = $option.val();
                    switch(value) {
                        case "default":
                            jQuery(".lay-standard-close-icon-settings").show();
                            jQuery(".lay-custom-close-icon-settings").hide();
                            jQuery(".lay-text-close-settings").hide();
                        break;
                        case "custom":
                            jQuery(".lay-custom-close-icon-settings").show();
                            jQuery(".lay-standard-close-icon-settings").hide();
                            jQuery(".lay-text-close-settings").hide();
                        break;
                        case "text":
                            jQuery(".lay-custom-close-icon-settings").hide();
                            jQuery(".lay-standard-close-icon-settings").hide();
                            jQuery(".lay-text-close-settings").show();
                        break;
                    }
                }
                jQuery("select#close_type").on("change", onCloseTypeChange);
                onCloseTypeChange();
                // bg color
                jQuery("#lay_overlay_background_color").iris({
                    width: 200,
                    palettes: '.$color_palette_str.',
                    target: ".lay_overlay_background_color_wrap",
                    change: function(event, ui) {
                        jQuery(".lay_overlay_background_settings .js-color-rectangle").css("background-color", ui.color.toString());
                    }
                })
                jQuery("#lay_overlay_background_color").on("focus", function(){
                    jQuery("#lay_overlay_background_color").iris("show");
                })
                jQuery(".lay_overlay_background_settings .js-color-rectangle").on("click", function(){
                    jQuery("#lay_overlay_background_color").iris("show");
                })
                jQuery(document).on("mousedown", function (e) {
                    if ( !jQuery(e.target).is("#lay_overlay_background_color, .js-color-rectangle") && jQuery(e.target).closest(".iris-picker").length == 0 ) {
                        jQuery("#lay_overlay_background_color").iris("hide");
                    }
                });

                // icon color
                jQuery("#lay_overlay_close_color").iris({
                    width: 200,
                    palettes: '.$color_palette_str.',
                    target: ".lay_overlay_close_color_wrap",
                    change: function(event, ui) {
                        jQuery(".lay_overlay_close_settings .js-color-rectangle").css("background-color", ui.color.toString());
                    }
                })
                jQuery("#lay_overlay_close_color").on("focus", function(){
                    jQuery("#lay_overlay_close_color").iris("show");
                })
                jQuery(".lay_overlay_close_settings .js-color-rectangle").on("click", function(){
                    jQuery("#lay_overlay_close_color").iris("show");
                })
                jQuery(document).on("mousedown", function (e) {
                    if ( !jQuery(e.target).is("#lay_overlay_close_color, .js-color-rectangle") && jQuery(e.target).closest(".iris-picker").length == 0 ) {
                        jQuery("#lay_overlay_close_color").iris("hide");
                    }
                });

                // accordion
                jQuery("#overlay_settings .accordion-title").on("click", function(){

                    if( jQuery(this).hasClass("accordion-title-active") ){
                        jQuery("#overlay_settings .accordion-title-active").removeClass("accordion-title-active")
                        jQuery("#overlay_settings .accordion-show").removeClass("accordion-show")
                    } else {
                        jQuery("#overlay_settings .accordion-title-active").removeClass("accordion-title-active")
                        jQuery("#overlay_settings .accordion-show").removeClass("accordion-show")
    
                        jQuery(this).toggleClass("accordion-title-active")
                        jQuery(this).next().toggleClass("accordion-show")
                    }

                })
                // active link color
                jQuery("#lay_overlay_active_color").iris({
                    width: 200,
                    palettes: '.$color_palette_str.',
                    target: ".lay_overlay_active_color_wrap",
                    change: function(event, ui) {
                        jQuery(".lay_overlay_active_settings .js-color-rectangle").css("background-color", ui.color.toString());
                    }
                })
                jQuery("#lay_overlay_active_color").on("focus", function(){
                    jQuery("#lay_overlay_active_color").iris("show");
                })
                jQuery(".lay_overlay_active_settings .js-color-rectangle").on("click", function(){
                    jQuery("#lay_overlay_active_color").iris("show");
                })
                jQuery(document).on("mousedown", function (e) {
                    if ( !jQuery(e.target).is("#lay_overlay_active_color, .js-color-rectangle") && jQuery(e.target).closest(".iris-picker").length == 0 ) {
                        jQuery("#lay_overlay_active_color").iris("hide");
                    }
                });

                // active burger color
                jQuery("#lay_overlay_burger_color").iris({
                    width: 200,
                    palettes: '.$color_palette_str.',
                    target: ".lay_overlay_burger_color_wrap",
                    change: function(event, ui) {
                        jQuery(".lay_overlay_burger_settings .js-color-rectangle").css("background-color", ui.color.toString());
                    }
                })
                jQuery("#lay_overlay_burger_color").on("focus", function(){
                    jQuery("#lay_overlay_burger_color").iris("show");
                })
                jQuery(".lay_overlay_burger_settings .js-color-rectangle").on("click", function(){
                    jQuery("#lay_overlay_burger_color").iris("show");
                })
                jQuery(document).on("mousedown", function (e) {
                    if ( !jQuery(e.target).is("#lay_overlay_burger_color, .js-color-rectangle") && jQuery(e.target).closest(".iris-picker").length == 0 ) {
                        jQuery("#lay_overlay_burger_color").iris("hide");
                    }
                });

                // select input content when clicking on input
                var focusedElement
                jQuery(\'body\')
                    .on(\'mouseup\', \'#overlay_settings input[type="text"], #overlay_settings input[type="number"]\', function (e) {
                        if (focusedElement === this) return
                        // already focused, return so user can now place cursor at specific point in input.
                        focusedElement = this
                        setTimeout(function () {
                            if (window.getSelection().toString() === \'\') {
                                focusedElement.select()
                            }
                        }, 50)
                        // select all text in any field on focus for easy re-entry. Delay sightly to allow focus to "stick" before selecting.
                    })
                    .on(\'blur\', \'#overlay_settings input[type="text"], #overlay_settings input[type="number"]\', function () {
                        focusedElement = null
                    })

                // file uploads
                // https://gist.github.com/hlashbrooke/9267467#file-settings-js
                    jQuery(document).ready(function() {

                    /***** Uploading images *****/

                    var file_frame;

                    jQuery.fn.uploadMediaFile = function( button, preview_media ) {
                        var button_id = button.attr(\'id\');
                        console.log("button_id", button_id)
                        var field_id = button_id.replace( \'_button\', \'\' );
                        console.log("field_id", field_id)
                        var preview_id = button_id.replace( \'_button\', \'_preview\' );
                        console.log("preview_id", preview_id)
                        
                        // Create the media frame.
                        file_frame = wp.media.frames.file_frame = wp.media({
                            title: \'Select an image\',
                            multiple: false
                        });

                        // When an image is selected, run a callback.
                        file_frame.on( \'select\', function() {
                            attachment = file_frame.state().get(\'selection\').first().toJSON();
                            jQuery("#"+field_id).val(attachment.id);
                            if( preview_media ) {
                            jQuery("#"+preview_id).attr(\'src\', attachment.url);
                            }
                            jQuery(\'#\'+field_id+\'_delete\').css(\'display\', \'block\');
                        });

                        // Finally, open the modal
                        file_frame.open();
                    }

                    jQuery(\'.image_upload_button\').click(function() {
                        jQuery.fn.uploadMediaFile( jQuery(this), true );
                    });

                    jQuery(\'.image_delete_button\').click(function() {
                        var id = jQuery(this).attr(\'id\').replace( \'_delete\', \'\' );
                        jQuery(this.parentNode).find( \'.image_data_field#\'+id ).val( \'\' );
                        var noimagesrc = jQuery( \'#\'+id+\'_preview\' ).attr(\'data-noimagesrc\');
                        jQuery( \'#\'+id+\'_preview\' ).attr(\'src\', noimagesrc);
                        jQuery(this).css(\'display\', \'none\');
                        return false;
                    });

                    });
                 
            </script>
        </div>';
	}

	public function save_page( $post_id ) {
		$post_id = (int)$post_id;
		/*
		 * We need to verify this came from the our screen and with proper authorization,
		 * because save_post can be triggered at other times.
		 */

		// Check if our nonce is set.
		if ( ! isset( $_POST['overlay_nonce'] ) )
			return $post_id;

		$nonce = $_POST['overlay_nonce'];

		// Verify that the nonce is valid.
		if ( ! wp_verify_nonce( $nonce, 'overlay' ) )
			return $post_id;

		// If this is an autosave, our form has not been submitted,
                //     so we don't want to do anything.
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
			return $post_id;

		// Check the user's permissions.
		if ( 'page' == $_POST['post_type'] ) {

			if ( ! current_user_can( 'edit_page', $post_id ) )
				return $post_id;
	
		}

		/* OK, its safe for us to save the data now. */

		// Sanitize the user input.

		$use_as_overlay = isset($_POST['use_as_overlay']) ? $_POST['use_as_overlay'] : '';
        $overlay_animation = isset($_POST['overlay_animation']) ? $_POST['overlay_animation'] : 'slide-from-top';
        $overlay_phone_animation = isset($_POST['overlay_phone_animation']) ? $_POST['overlay_phone_animation'] : 'slide-from-top';

        $overlay_width = isset($_POST['overlay_width']) ? $_POST['overlay_width'] : '100';
        $overlay_width_mu = isset($_POST['overlay_width_mu']) ? $_POST['overlay_width_mu'] : '%';
        $overlay_phone_width = isset($_POST['overlay_phone_width']) ? $_POST['overlay_phone_width'] : '100';
        $overlay_phone_width_mu = isset($_POST['overlay_phone_width_mu']) ? $_POST['overlay_phone_width_mu'] : '%';

        $overlay_set_height = isset($_POST['overlay_set_height']) ? $_POST['overlay_set_height'] : '';
        $overlay_height = isset($_POST['overlay_height']) ? $_POST['overlay_height'] : '100';
        $overlay_height_mu = isset($_POST['overlay_height_mu']) ? $_POST['overlay_height_mu'] : '%';
        
        $background = isset($_POST['background']) ? $_POST['background'] : '';
        $background_opacity = isset($_POST['background_opacity']) ? $_POST['background_opacity'] : 20;
        $background_color = isset($_POST['background_color']) ? $_POST['background_color'] : '#ffffff';
        $background_blur = isset($_POST['background_blur']) ? $_POST['background_blur'] : 0;

        $close = isset($_POST['close']) ? $_POST['close'] : '';
        $close_position = isset($_POST['close_position']) ? $_POST['close_position'] : 'topright';
        $close_color = isset($_POST['close_color']) ? $_POST['close_color'] : '#000000';
        $close_padding = isset($_POST['close_padding']) ? $_POST['close_padding'] : 20;
        $close_padding_mu = isset($_POST['close_padding_mu']) ? $_POST['close_padding_mu'] : 'px';

        $close_size = isset($_POST['close_size']) ? $_POST['close_size'] : 40;
        $close_size_mu = isset($_POST['close_size_mu']) ? $_POST['close_size_mu'] : 'px';

        $close_padding_phone = isset($_POST['close_padding_phone']) ? $_POST['close_padding_phone'] : 15;
        $close_padding_phone_mu = isset($_POST['close_padding_phone_mu']) ? $_POST['close_padding_phone_mu'] : 'px';

        $close_size_phone = isset($_POST['close_size_phone']) ? $_POST['close_size_phone'] : 25;
        $close_size_phone_mu = isset($_POST['close_size_phone_mu']) ? $_POST['close_size_phone_mu'] : 'px';

        $custom_close_icon = isset($_POST['custom_close_icon']) ? $_POST['custom_close_icon'] : '';

        $custom_close_phone_icon_width = isset($_POST['custom_close_phone_icon_width']) ? $_POST['custom_close_phone_icon_width'] : 30;
        $custom_close_phone_icon_width_mu = isset($_POST['custom_close_phone_icon_width_mu']) ? $_POST['custom_close_phone_icon_width_mu'] : 'px';

        $custom_close_icon_width = isset($_POST['custom_close_icon_width']) ? $_POST['custom_close_icon_width'] : 40;
        $custom_close_icon_width_mu = isset($_POST['custom_close_icon_width_mu']) ? $_POST['custom_close_icon_width_mu'] : 'px';

        $overlay_burger = isset($_POST['overlay_burger']) ? $_POST['overlay_burger'] : '';
        $burger_position = isset($_POST['burger_position']) ? $_POST['burger_position'] : 'topright';
        $burger_color = isset($_POST['burger_color']) ? $_POST['burger_color'] : '#000000';
        $burger_padding = isset($_POST['burger_padding']) ? $_POST['burger_padding'] : 20;
        $burger_padding_mu = isset($_POST['burger_padding_mu']) ? $_POST['burger_padding_mu'] : 'px';

        $burger_size = isset($_POST['burger_size']) ? $_POST['burger_size'] : 26;
        $burger_size_mu = isset($_POST['burger_size_mu']) ? $_POST['burger_size_mu'] : 'px';

        $burger_padding_phone = isset($_POST['burger_padding_phone']) ? $_POST['burger_padding_phone'] : 15;
        $burger_padding_phone_mu = isset($_POST['burger_padding_phone_mu']) ? $_POST['burger_padding_phone_mu'] : 'px';

        $burger_size_phone = isset($_POST['burger_size_phone']) ? $_POST['burger_size_phone'] : 20;
        $burger_size_phone_mu = isset($_POST['burger_size_phone_mu']) ? $_POST['burger_size_phone_mu'] : 'px';

        $hide_burger_on_phone = isset($_POST['hide_burger_on_phone']) ? $_POST['hide_burger_on_phone'] : '';

        $active_color = isset($_POST['active_color']) ? $_POST['active_color'] : '#000000';
        $style_active = isset($_POST['style_active']) ? $_POST['style_active'] : '';
        $active_opacity = isset($_POST['active_opacity']) ? $_POST['active_opacity'] : 100;

        $custom_burger_icon = isset($_POST['custom_burger_icon']) ? $_POST['custom_burger_icon'] : '';
        $use_custom_burger_icon = isset($_POST['use_custom_burger_icon']) ? $_POST['use_custom_burger_icon'] : '';

        $custom_burger_phone_icon_width = isset($_POST['custom_burger_phone_icon_width']) ? $_POST['custom_burger_phone_icon_width'] : 30;
        $custom_burger_phone_icon_width_mu = isset($_POST['custom_burger_phone_icon_width_mu']) ? $_POST['custom_burger_phone_icon_width_mu'] : 'px';

        $custom_burger_icon_width = isset($_POST['custom_burger_icon_width']) ? $_POST['custom_burger_icon_width'] : 40;
        $custom_burger_icon_width_mu = isset($_POST['custom_burger_icon_width_mu']) ? $_POST['custom_burger_icon_width_mu'] : 'px';

        $lay_overlay_close_text = isset($_POST['lay_overlay_close_text']) ? $_POST['lay_overlay_close_text'] : '';
        $close_type = isset($_POST['close_type']) ? $_POST['close_type'] : '';
        $use_custom_close_icon = '';

        $lay_overlay_close_textformat = isset($_POST['lay_overlay_close_textformat']) ? $_POST['lay_overlay_close_textformat'] : 'Default';

        // when lay_disable_scroll is unchecked, it will just not be part of $_POST, so i have to do this, instead of : 'on';
        $lay_disable_scroll = isset($_POST['lay_disable_scroll']) ? $_POST['lay_disable_scroll'] : '';

        $overlay_settings = array(
            'use_as_overlay' => $use_as_overlay,
            'overlay_animation' => $overlay_animation,
            'overlay_phone_animation' => $overlay_phone_animation,
            'overlay_width' => $overlay_width,
            'overlay_width_mu' => $overlay_width_mu,
            'overlay_phone_width' => $overlay_phone_width,
            'overlay_phone_width_mu' => $overlay_phone_width_mu,
            'overlay_set_height' => $overlay_set_height,
            'overlay_height' => $overlay_height,
            'overlay_height_mu' => $overlay_height_mu,
            'background' => $background,
            'background_opacity' => $background_opacity,
            'background_color' => $background_color,
            'background_blur' => $background_blur,
            'close' => $close,
            'close_position' => $close_position,
            'close_color' => $close_color,
            'close_padding' => $close_padding,
            'close_padding_mu' => $close_padding_mu,
            'close_size' => $close_size,
            'close_size_mu' => $close_size_mu,
            'close_padding_phone' => $close_padding_phone,
            'close_padding_phone_mu' => $close_padding_phone_mu,
            'close_size_phone' => $close_size_phone,
            'close_size_phone_mu' => $close_size_phone_mu,
            'active_color' => $active_color,
            'style_active' => $style_active,
            'active_opacity' => $active_opacity,
            'overlay_burger' => $overlay_burger,
            'burger_color' => $burger_color,
            'burger_position' => $burger_position,
            'burger_padding' => $burger_padding,
            'burger_padding_mu' => $burger_padding_mu,
            'burger_size' => $burger_size,
            'burger_size_mu' => $burger_size_mu,
            'burger_padding_phone' => $burger_padding_phone,
            'burger_padding_phone_mu' => $burger_padding_phone_mu,
            'burger_size_phone' => $burger_size_phone,
            'burger_size_phone_mu' => $burger_size_phone_mu,
            'hide_burger_on_phone' => $hide_burger_on_phone,
            'custom_burger_icon' => $custom_burger_icon,
            'lay_overlay_close_text' => $lay_overlay_close_text,
            'use_custom_burger_icon' => $use_custom_burger_icon,
            'custom_burger_icon_width' => $custom_burger_icon_width,
            'custom_burger_icon_width_mu' => $custom_burger_icon_width_mu,
            'custom_burger_phone_icon_width' => $custom_burger_phone_icon_width,
            'custom_burger_phone_icon_width_mu' => $custom_burger_phone_icon_width_mu,
            'custom_close_icon' => $custom_close_icon,
            'custom_close_icon_width' => $custom_close_icon_width,
            'custom_close_icon_width_mu' => $custom_close_icon_width_mu,
            'custom_close_phone_icon_width' => $custom_close_phone_icon_width,
            'custom_close_phone_icon_width_mu' => $custom_close_phone_icon_width_mu,
            'close_type' => $close_type,
            'use_custom_close_icon' => $use_custom_close_icon,
            'lay_overlay_close_textformat' => $lay_overlay_close_textformat,
            'lay_disable_scroll' => $lay_disable_scroll
        );
        // update meta
        update_post_meta($post_id, 'overlay_settings', $overlay_settings);

	}
}
new OverlayMetabox();