<div class="wrap">
    <h2>Projects Overlays Options</h2>

    <?php if(isset( $_GET['settings-updated'])) { ?>
    <div class="updated">
        <p>Projects Overlays Options updated.</p>
    </div>
    <?php } ?>

    
    <div class="lay-explanation">
        <div class="lay-explanation-inner">
        	<p>Will not work for a project that contains a shortcode. Will not work either if you use WooCommerce or if you enabled "Disable Ajax / Compatibility Mode".</p>
        </div>
    </div>

	<form method="POST" action="options.php">
	<?php settings_fields( 'manage-projectsoverlaysoptions' );	//pass slug name of page, also referred
	                                        //to in Settings API as option group name
	do_settings_sections( 'manage-projectsoverlaysoptions' ); 	//pass slug name of page
    ?>
    <div class="lay-tabs">
        <!-- <div style="text-align:left;font-size: 14px;line-height:1.3;vertical-align: top;
        text-align: left;
        padding: 20px 10px 0 0;
        line-height: 1.3;color: #1d2327;">Position Settings for all "Show Image on" options:</div> -->
        <div class="lay-tabs-tabs">
            <span class="lay-tab-active">Desktop: Close Icon Position and Size</span>
            <span>Phone: Close Icon Position and Size</span>
        </div>
        <div class="lay-tabs-content-wrap">
            <div class="lay-tab-content lay-tab-content-active">
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title">Desktop Close-Icon Position</div>
                    <select name="layui_po_close_icon_position_desktop" id="layui_po_close_icon_position_desktop">
                        <option value="topright">Top Right</option>
                        <option value="topleft">Top Left</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title">Desktop Close-Icon Size</div>
                    <input type="number" min="0" max="" step="1" name="layui_po_close_icon_size_desktop" id="layui_po_close_icon_size_desktop"/>
                    <select name="layui_po_close_icon_size_desktop_in" id="layui_po_close_icon_size_desktop_in">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title">Desktop Close-Icon Top</div>
                    <input type="number" min="0" max="" step="1" name="layui_po_close_icon_spacetop_desktop" id="layui_po_close_icon_spacetop_desktop"/>
                    <select name="layui_po_close_icon_spacetop_desktop_in" id="layui_po_close_icon_spacetop_desktop_in">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title">Desktop Close-Icon Left/Right</div>
                    <input type="number" min="0" max="" step="1" name="layui_po_close_icon_spaceright_desktop" id="layui_po_close_icon_spaceright_desktop"/>
                    <select name="layui_po_close_icon_spaceright_desktop_in" id="layui_po_close_icon_spaceright_desktop_in">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>         
            </div>
            <div class="lay-tab-content">
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title">Phone Close-Icon Position</div>
                    <select name="layui_po_close_icon_position_phone" id="layui_po_close_icon_position_phone">
                        <option value="topright">Top Right</option>
                        <option value="topleft">Top Left</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title">Phone Close-Icon Size</div>
                    <input type="number" min="0" max="" step="1" name="layui_po_close_icon_size_phone" id="layui_po_close_icon_size_phone"/>
                    <select name="layui_po_close_icon_size_phone_in" id="layui_po_close_icon_size_phone_in">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title">Phone Close-Icon Top</div>
                    <input type="number" min="0" max="" step="1" name="layui_po_close_icon_spacetop_phone" id="layui_po_close_icon_spacetop_phone"/>
                    <select name="layui_po_close_icon_spacetop_phone_in" id="layui_po_close_icon_spacetop_phone_in">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>
                <div class="lay-modal-input-row">
                    <div class="lay-rows-title">Phone Close-Icon Left/Right</div>
                    <input type="number" min="0" max="" step="1" name="layui_po_close_icon_spaceright_phone" id="layui_po_close_icon_spaceright_phone"/>
                    <select name="layui_po_close_icon_spaceright_phone_in" id="layui_po_close_icon_spaceright_phone_in">
                        <option value="px">px</option>
                        <option value="%">%</option>
                    </select>
                </div>           
            </div>
        </div>
        <?php
	submit_button('Save');
	?>
    </div>


    <script>
        // get ids
        var inputIds = []
        var selectIds = []
        // set initial values
        jQuery('.lay-modal-input-row input').each(function(){
            var id = jQuery(this).attr('id');
            inputIds.push('#'+id)
            id = id.replace('layui_', '');
            var val = jQuery('input#'+id).val();
            jQuery(this).val(val);
        })
        jQuery('.lay-modal-input-row select').each(function(){
            var id = jQuery(this).attr('id');
            selectIds.push('#'+id)
            id = id.replace('layui_', '');
            var val = jQuery('select#'+id).val();
            jQuery(this).val(val);
        })
        // update values
        jQuery(selectIds.join(', ')).each(function(){
            jQuery(this).on('change', function(){
                var id = jQuery(this).attr('id')
                jQuery('#'+id.replace('layui_', '')).val(this.value)
            })
        })
        jQuery(inputIds.join(', ')).each(function(){
            jQuery(this).on('input', function(){
                var id = jQuery(this).attr('id')
                jQuery('#'+id.replace('layui_', '')).val(this.value)
            })
        })


        // tabs
        jQuery('.lay-tabs').each(function(){
            var $tabswrap = jQuery(this);
            jQuery(this).find('.lay-tabs-tabs span').click(function(){
                var ix = jQuery(this).index()
                $tabswrap.find('.lay-tabs-tabs span.lay-tab-active').removeClass('lay-tab-active')
                $tabswrap.find('.lay-tabs-tabs span').eq(ix).addClass('lay-tab-active')
                $tabswrap.find('.lay-tab-content.lay-tab-content-active').removeClass('lay-tab-content-active')
                $tabswrap.find('.lay-tab-content').eq(ix).addClass('lay-tab-content-active')

                jQuery('#imagehover_widths_and_height_selected_tab').val(ix)
            })
        })

        // set which tab to show first
        var tab = jQuery('#imagehover_widths_and_height_selected_tab').val();
        jQuery('.lay-tabs-tabs span').eq(tab).click();            
    </script>

	</form>
</div>