<?php
// using filters to overwrite this didn't work for me so I'm just using function overrides

function woocommerce_output_content_wrapper() {
    ?>
    <div id="lay-woocommerce">
    <?php
}

function woocommerce_output_content_wrapper_end() {
    ?>
    </div>
    <?php
}

function woocommerce_get_product_thumbnail( $size = 'woocommerce_thumbnail', $attr = array(), $placeholder = true ) {
    global $product;

    if ( ! ( $product instanceof WC_Product ) ) {
        return '';
    }

    if ( ! is_array( $attr ) ) {
        $attr = array();
    }

    if ( ! is_bool( $placeholder ) ) {
        $placeholder = true;
    }

    $image_size = apply_filters( 'single_product_archive_thumbnail_size', $size );

    // all i changed here, is i added this attribute:
    $attr['lay_for'] = 'product_thumbnail';

    return $product->get_image( $image_size, $attr, $placeholder );
}

function woocommerce_template_loop_product_title() {
    global $product;

    $texts = Lay_WooCommerce::get_texts_on_image($product);
    $title = $texts['title'];
    $price = $texts['price'];
    $out_of_stock = $texts['out_of_stock'];
    $descr_wrap = $texts['descr_wrap'];
    $brands = $texts['brands'];

    $add_to_cart_button = '';
    if( LayFrontend_Options::$lay_woocommerce_pt_show_add_to_cart_button ) {
        $add_to_cart_button = do_shortcode( '[add_to_cart id="'.$product->get_id().'"]' );
    }

    $woo_prth_below = LayFrontend_Options::$woo_prth_below;

    if(count($woo_prth_below) > 0){
        $inner = '';
        foreach($woo_prth_below as $key){
            if(strpos($key, 'pt_title_position') !== false){
                $inner .= $title;
            }
            if(strpos($key, 'pt_shortdescr_position') !== false){
                $inner .= $descr_wrap;
            }
            if(strpos($key, 'pt_brands_position') !== false && LayFrontend_Options::$lay_woocommerce_pt_show_brands){
                $inner .= $brands;
            }
            if(strpos($key, 'pt_price_position') !== false){
                $inner .= $price;
            }
            if(strpos($key, 'pt_outofstock_position') !== false){
                $inner .= $out_of_stock;
            }
            if(strpos($key, 'pt_addtocart_position') !== false && LayFrontend_Options::$lay_woocommerce_pt_show_add_to_cart_button){
                $inner .= $add_to_cart_button;
            }
        }
        if($inner != '') {
            echo 
            '<div class="below-image lay_woocommerce_product_thumbnail_text_wrap">'.$inner.'</div>';
        }
    }
    // if(count($below) > 0){
    //     echo 
    //     '<div class="below-image lay_woocommerce_product_thumbnail_text_wrap">
    //         <div class="lay_woocommerce_product_thumbnail_title_left">
                
    //             '.$descr_wrap.'
    //             '.$out_of_stock.'
    //         </div>
    //         <div class="lay_woocommerce_product_thumbnail_title_right">
    //             '.$add_to_cart_button.'
    //         </div>
    //     </div>';
    // }
}

/**
 * Adds a demo store banner to the site if enabled.
 */
function woocommerce_demo_store() {
    if ( ! is_store_notice_showing() ) {
        return;
    }

    $notice = get_option( 'woocommerce_demo_store_notice' );

    if ( empty( $notice ) ) {
        $notice = __( 'This is a demo store for testing purposes &mdash; no orders shall be fulfilled.', 'woocommerce' );
    }

    $notice_id = md5( $notice );
    // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
    echo apply_filters( 'woocommerce_demo_store', '<p class="woocommerce-store-notice demo_store" data-notice-id="' . esc_attr( $notice_id ) . '" style="display:none;">' . wp_kses_post( $notice ) . ' <a href="#" class="woocommerce-store-notice__dismiss-link"></a></p>', $notice );
}

function wc_dropdown_variation_attribute_options( $args = array() ) {

    $args = wp_parse_args(
        apply_filters( 'woocommerce_dropdown_variation_attribute_options_args', $args ),
        array(
            'options'          => false,
            'attribute'        => false,
            'product'          => false,
            'selected'         => false,
            'name'             => '',
            'id'               => '',
            'class'            => '',
            'show_option_none' => __( 'Choose an option', 'woocommerce' ),
        )
    );

    // Get selected value.
    if ( false === $args['selected'] && $args['attribute'] && $args['product'] instanceof WC_Product ) {
        $selected_key = 'attribute_' . sanitize_title( $args['attribute'] );
        // phpcs:disable WordPress.Security.NonceVerification.Recommended
        $args['selected'] = isset( $_REQUEST[ $selected_key ] ) ? wc_clean( wp_unslash( $_REQUEST[ $selected_key ] ) ) : $args['product']->get_variation_default_attribute( $args['attribute'] );
        // phpcs:enable WordPress.Security.NonceVerification.Recommended
    }

    $options               = $args['options'];
    $product               = $args['product'];
    $attribute             = $args['attribute'];
    $name                  = $args['name'] ? $args['name'] : 'attribute_' . sanitize_title( $attribute );
    $id                    = $args['id'] ? $args['id'] : sanitize_title( $attribute );
    $class                 = $args['class'];
    $show_option_none      = (bool) $args['show_option_none'];
    $show_option_none_text = $args['show_option_none'] ? $args['show_option_none'] : __( 'Choose an option', 'woocommerce' ); // We'll do our best to hide the placeholder, but we'll need to show something when resetting options.

    if ( empty( $options ) && ! empty( $product ) && ! empty( $attribute ) ) {
        $attributes = $product->get_variation_attributes();
        $options    = $attributes[ $attribute ];
    }

    $html  = '<select id="' . esc_attr( $id ) . '" class="' . esc_attr( $class ) . '" name="' . esc_attr( $name ) . '" placeholder="'.esc_attr( wc_attribute_label( $attribute ) ).'" data-attribute_name="attribute_' . esc_attr( sanitize_title( $attribute ) ) . '" data-show_option_none="' . ( $show_option_none ? 'yes' : 'no' ) . '">';
    $html .= '<option value="">' . esc_html( $show_option_none_text ) . '</option>';


    // im adding this to see if the stock is available, so i can style unavailable options differently
    // this is all my own custom code:
    $attribute_smallcaps = strtolower($attribute);
    $product_variations = $product->get_available_variations();

    $options_with_availability = array();
    foreach($options as $option){
        $options_with_availability[$option] = 0;
    }

    foreach($product_variations as $variation){
        $attributes_ = $variation['attributes'];
        foreach($attributes_ as $key => $value){
            $newkey = strtolower(str_replace('attribute_', '', $key));
            if($newkey == $attribute_smallcaps){
                $is_in_stock = $variation['is_in_stock'];
                $is_purchasable = $variation['is_purchasable'];
                if($is_in_stock == 1 && $is_purchasable == 1){
                    $options_with_availability[$value] = 1;
                }
            }
        }
    }
    // end of my custom code

    if ( ! empty( $options ) ) {
        if ( $product && taxonomy_exists( $attribute ) ) {
            // Get terms if this is a taxonomy - ordered. We need the names too.
            $terms = wc_get_product_terms(
                $product->get_id(),
                $attribute,
                array(
                    'fields' => 'all',
                )
            );
            foreach ( $terms as $term ) {
                if ( in_array( $term->slug, $options, true ) ) {
                    $availability = array_key_exists($term->slug, $options_with_availability) ? 'data-available="'.$options_with_availability[$term->slug].'"' : '';
                    $html .= '<option value="' . esc_attr( $term->slug ) . '" '.$availability.' ' . selected( sanitize_title( $args['selected'] ), $term->slug, false ) . '>' . esc_html( apply_filters( 'woocommerce_variation_option_name', $term->name, $term, $attribute, $product ) ) . '</option>';
                }
            }
        } else {
            foreach ( $options as $option ) {
                // This handles < 2.4.0 bw compatibility where text attributes were not sanitized.
                $selected = sanitize_title( $args['selected'] ) === $args['selected'] ? selected( $args['selected'], sanitize_title( $option ), false ) : selected( $args['selected'], $option, false );
                // my custom code:
                $availability = array_key_exists($option, $options_with_availability) ? 'data-available="'.$options_with_availability[$option].'"' : '';
                $html    .= '<option value="' . esc_attr( $option ) . '" '.$availability.' ' . $selected . '>' . esc_html( apply_filters( 'woocommerce_variation_option_name', $option, null, $attribute, $product ) ) . '</option>';
            }
        }
    }

    $html .= '</select>';

    // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
    echo apply_filters( 'woocommerce_dropdown_variation_attribute_options_html', $html, $args );
}


function woocommerce_template_loop_product_link_open() {
    global $product;

    if ( ! ( $product instanceof WC_Product ) ) {
        return;
    }

    $link = apply_filters( 'woocommerce_loop_product_link', get_the_permalink(), $product );

    $category_ids = wp_get_post_terms($product->get_id(), 'product_cat', array('fields' => 'ids'));
    $tag_ids = wp_get_post_terms($product->get_id(), 'product_tag', array('fields' => 'ids'));

    echo '<a href="' . esc_url( $link ) . '" data-catid="'.json_encode($category_ids).'" data-tags="'.json_encode($tag_ids).'" class="woocommerce-LoopProduct-link woocommerce-loop-product__link">';
}