<?php

// todo: when editing carousel I can set "slides" → "center slides". does that interefere with the setting lay options → carousel addon → horizontal alignment of slides  ?

// todo: see if for example calling LayElFunctions::getHTML5VideoMarkup will break the website if that function doesn't exist
// todo: show original image only if desktop size? 

class LayCarouselPluginFrontend {

    public static $config;

    public function __construct(){

        LayCarouselPluginFrontend::$config = array(
            'numbersPosition' => '',
            'captionsPosition' => '',
            'showCaptions' => '',
            'showNumbers' => '',
        );


        LayCarouselPluginFrontend::$config['showCaptions'] = LayCarouselPluginOptions::$showCaptions;
        LayCarouselPluginFrontend::$config['showNumbers'] = LayCarouselPluginOptions::$showNumbers;

        if( LayCarouselPluginOptions::$showNumbers ) {
            LayCarouselPluginFrontend::$config['numbersPosition'] = 'numbers-'.LayCarouselPluginOptions::$numbersPosition;
        }
        if( LayCarouselPluginOptions::$showCaptions ) {
            LayCarouselPluginFrontend::$config['captionsPosition'] = 'captions-'.LayCarouselPluginOptions::$captionsPosition;
        }

        // if( LayCarouselPluginOptions::$showCircles ) {
        //     LayCarouselPluginFrontend::$config['showCaptions'] = false;
        //     LayCarouselPluginFrontend::$config['showNumbers'] = false;
        // }
    }

    /*
        caveat for captionsUnderSlides option:
        When using the setting "captions under slides" when show multiple slides is active,
        the slides (.slide-inner) themselves need a fixed-height and all of the parent containers cant have a fixed height.
        this way the carousels height will be determined by the height of the slide + the height of the captions under the slides

        for other settings we default back to the old way of positioning and setting height,
        meaning: set height on the outer container and position inner container with position: absolute;
    */

    public static function getMarkup($el){
        $captions = array();
        $i;
        $carousel = $el['carousel'];
        $options = array_key_exists('carousel_options', $el) ? $el['carousel_options'] : false;   
        $slidesWidth = '';
        $transition = LayCarouselPluginOptions::$transition;
        $classesWrap = '';
        $classesCarousel = '';
        $classesCarousel .= 'content-alignment-'.LayCarouselPluginOptions::$contentAlignment;     
        $autoplaySpeed = LayCarouselPluginOptions::$autoplaySpeed;
        $transitionSpeed = LayCarouselPluginOptions::$transitionSpeed;
        $autoplayDelay = LayCarouselPluginOptions::$autoplayDelay;
        $spacebetween = 0;
        $caption_of_carousel = array_key_exists('caption', $el) ? $el['caption'] : false;

        // if( LayCarouselPluginOptions::$sinkPosition == 'above' ) {
        //     $markup = $sink.$markup;
        // } else {
            // $markup .= $sink;
        // }

        // captions in sink or caption under slides. the difference here is: a caption is underneath each slide when showing multiple slides at once
        // instead of just a caption in the sink that is updated when the index of the carousel changes
        $captionsUnderSlides = false;
        if( array_key_exists('captionsUnderSlides', $options) && $options['captionsUnderSlides'] && LayCarouselPluginFrontend::$config['showCaptions'] ) {
            $captionsUnderSlides = true;
        }
        if( LayCarouselPluginOptions::$buttonsOutside ) {
            $classesWrap .= ' place-buttons-outside';
        } else {
            $classesWrap .= ' dont-place-buttons-outside';
        }

        // captions and numbers
        $captionsAndNumbersSamePosition = false;
        if( LayCarouselPluginOptions::$showNumbers && LayCarouselPluginOptions::$showCaptions ) {
            if ( LayCarouselPluginOptions::$numbersPosition == LayCarouselPluginOptions::$captionsPosition ) {
                $captionsAndNumbersSamePosition = true;
            }
        }
        if( $captionsAndNumbersSamePosition ) {
            $classesWrap .= " captions-and-numbers-same-position";
        } else {
            $classesWrap .= " captions-and-numbers-not-same-position";
        }

        if( $options ) {

            // turn off almost everything if transition is horizontal scroll
            if ( array_key_exists('transition', $options) && $options['transition'] == 'scroll'){
                $captionsUnderSlides = false;
                $options['loop']= false;
                $options['autoplay'] = false;
                $options['slidesWidth'] = '';
                $options['showMultipleSlides'] = false;
                $options['disableClick'] = false;
                $captionsUnderSlides = false;
                $options['freeScroll'] = false;
                $options['mousewheelScroll'] = false;
                $options['centeredSlides'] = false;
            }


            if( array_key_exists('transitionSpeed', $options ) ){
                $transitionSpeed = $options['transitionSpeed'];
            }
            if( array_key_exists('autoplaySpeed', $options ) ){
                $autoplaySpeed = $options['autoplaySpeed'];
            }
            if( array_key_exists('autoplayDelay', $options ) ){
                $autoplayDelay = $options['autoplayDelay'];
            }
            if( array_key_exists('spaceBetween', $options ) ){
                $spacebetween = $options['spaceBetween'];
            }
            if( array_key_exists('slidesWidth', $options) ){
                if( $options['slidesWidth'] != '' ) {
                    $slidesWidth = 'width:calc('.$options['slidesWidth'].');';
                }
            }
            if( array_key_exists('random', $options ) && $options['random'] ){
                shuffle($carousel);
            }
            if( $options['autoplay'] == true ){
                $autoplay = true;
                $classesCarousel .= ' autoplay';
            } else {
                $classesCarousel .= ' no-autoplay';
            }
            if ( array_key_exists('showMultipleSlides', $options) && $options['showMultipleSlides'] ) {
                $showMultipleSlides = true;
            } else {
                $captionsUnderSlides = false;
            }
            if ( array_key_exists('transition', $options) ){
                $transition = $options['transition'];
            }

            $loop = LayCarouselPluginOptions::$loop;
            if( array_key_exists('loop', $options ) ){
                $loop = $options['loop'];
            }
            // need to disable loop for touch devices, because it makes ios safari crash since like late 2023 :)
            // https://discussions.apple.com/thread/254843801?sortBy=best
            if( $transition == 'sliding' && class_exists('LTUtility') ) {
                // LayCarouselPluginOptions::$laycarousel_loop_touchdevice can be either 'on' or ''
                $loop = LTUtility::$isTouchDevice && LayCarouselPluginOptions::$laycarousel_loop_touchdevice == '' ? false : $loop;
            }
            $classesWrap .= $loop == true ? ' loop-slides' : ' dont-loop-slides hide-previous-related-ui';

            if($transition == 'scroll'){
                $classesWrap .= ' show-multiple-slides';
            } else {
                if ( array_key_exists('showMultipleSlides', $options) && $options['showMultipleSlides'] ) {
                    $classesWrap .= $options['showMultipleSlides'] == true ? ' show-multiple-slides' : ' dont-show-multiple-slides';
                } else {
                    $classesWrap .= ' dont-show-multiple-slides';
                }
            }

            $enableClickAndDrag = true;
            if ( array_key_exists('disableClick', $options) && $options['disableClick'] && $options['autoplay'] == true ) {
                $classesCarousel .= ' disable-click-and-drag';
                $classesWrap .= ' disable-click-and-drag';
                $enableClickAndDrag = false;
            } else {
                $classesCarousel .= ' enable-click-and-drag';
                $classesWrap .= ' enable-click-and-drag';
                $enableClickAndDrag = true;
            }
            if ( array_key_exists('freeScroll', $options) && $options['freeScroll'] && $enableClickAndDrag) {
                $classesCarousel .= ' free-scroll';
            } else {
                $classesCarousel .= ' no-free-scroll';
            }
            if ( array_key_exists('mousewheelScroll', $options) && $options['mousewheelScroll'] ){
                $classesCarousel .= ' mousewheel-scroll';
            }
            if ( $captionsUnderSlides ){
                $classesCarousel .= ' captions-under-slides';
            } else {
                $classesCarousel .= ' no-captions-under-slides';
            }
            if ( array_key_exists('size', $options) ){
                $classesWrap .= ' '.$options['size'];
            }
            if ( array_key_exists('fillSlides', $options) ){
                $classesWrap .= $options['fillSlides'] == true ? ' fill-slides' : ' dont-fill-slides';
            } else {
                $classesWrap .= ' dont-fill-slides';
            }
            if ( array_key_exists('slidesWidth', $options) ){
                if ( $options['slidesWidth'] == '' ||  $options['slidesWidth'] == "null" || $options['slidesWidth'] == null){
                    $classesWrap .= ' no-fixed-slides-width';
                } else {
                    $classesWrap .= ' fixed-slides-width';
                }
            } else {
                $classesWrap .= ' no-fixed-slides-width';
            }
            if ( array_key_exists('fixedHeight', $options) ){
                if ( $options['fixedHeight'] == 'auto' ) {
                    $classesCarousel .= ' fixed-height-auto';
                }else{
                    $classesCarousel .= ' no-fixed-height-auto';
                }
                if( $options['fixedHeight'] == '' ) {
                    $classesWrap .= ' no-fixed-height';
                }
            }
            else{
                $classesCarousel .= ' no-fixed-height-auto';
                $classesWrap .= ' no-fixed-height';
            }
            if( array_key_exists( 'centeredSlides', $options ) && $options['centeredSlides'] ) {
                $classesCarousel .= ' centered-slides';
            }
        }
    
        $classesCarousel .= ' transition-'.$transition;

        if( LayCarouselPluginOptions::$showCircles ) {
            $classesWrap .= ' show-circles';
        } else {
            $classesWrap .= ' no-circles';
        }
        if( $transition != 'sliding' ) {
            $classesWrap .= ' no-swiper';
        }

        if( $transition == 'fading' || $transition == 'immediate' ) {
            $classesWrap .= ' use-fade-transition';
        }

        $classesWrap .= ' wrap-transition-'.$transition;

        $classesWrap .= ' sink-'.LayCarouselPluginOptions::$sinkPosition;
        if( LayCarouselPluginOptions::$pauseAutoplayOnHover ){
            $classesWrap .= ' pause-autoplay-on-hover';
        }

        $firstAr = 9/16;
        $pb = 9/16 * 100;

        if( $carousel[0]['type'] != "text" ) {
            $firstAr = $carousel[0]['ar'];
            $pb = $carousel[0]['ar'] * 100;
        }

        $fixedHeight = null;
        if ( array_key_exists('customAspectRatio', $options) == false  ) {
            if( $options['size'] == 'aspectRatioOfFirstElement' ) {
                if( $carousel[0]['type'] != "text" ) {
                    $firstAr = $carousel[0]['ar'];
                    $pb = $carousel[0]['ar'] * 100;
                }
                $showMultipleSlides = false;
            } else if ( $options['size'] == 'useCustomAspectRatio') {
                $firstAr = $options['customAspectRatioH'] / $options['customAspectRatioW'];
                $pb = $firstAr * 100;
            } else if ( $options['size'] == 'fixedHeight') {
                $fixedHeight = $options['fixedHeight'];
            }
        } else if( $options['customAspectRatio'] == true ){
            $firstAr = $options['customAspectRatioH'] / $options['customAspectRatioW'];
            $pb = $firstAr * 100;
            $showMultipleSlides = false;
        }
        if( $fixedHeight == '100vh' ){
            $classesCarousel .= ' _100vh';
            $classesWrap .= ' contains_100vh-carousel';
        }

        if ( array_key_exists('fixedHeight', $options) ){
            if ($options['fixedHeight'] == 'auto'){
                $classesCarousel .= ' fixed-height-auto';
            } else {
                $classesCarousel .= ' fixed-height-not-auto';
            }
        }else{
            $classesCarousel .= ' fixed-height-not-auto';
        }
        $classesCarousel .= ' text-alignment-'.LayCarouselPluginOptions::$textalignment;

        $autoplayData = 'data-autoplayspeed="'.$autoplaySpeed.'" data-autoplaydelay="'.$autoplayDelay.'"';
    
        // SINK START!
        for( $i=0; $i<count($carousel); $i++ ) {
            $caption = array_key_exists('caption', $carousel[$i]) ? $carousel[$i]['caption'] : '';
            $captions []= $caption;
        }

        $captionMarkup = '';

        // captions and numbers
        if( LayCarouselPluginFrontend::$config['showCaptions'] ){
            $allEmpty = true;
            if( $caption_of_carousel != '' ) {
                $allEmpty = false;
            }
            for ($i = 0; $i < count($captions); $i++) {
                $current_caption = '';
                if( trim($captions[$i]) != "" ) { 
                    $current_caption = $captions[$i];
                    $allEmpty = false;
                } else {
                    $current_caption = $caption_of_carousel;
                }
                // if numbers and caption are both for example "center", this will put the numbers inside of the caption, next to it, to the left
                // instead of overlapping it
                $numberMarkupInCaption = '';
                if( $captionsAndNumbersSamePosition ) {
                    $numberMarkupInCaption = '<span class="numbers _'.LayCarouselPluginOptions::$numberTextformat.'_no_spaces"></span>';
                }
                $caption_active_class = '';
                if( $i == 0 ) {
                    $caption_active_class = 'caption-active';
                }

                if ( $captionsAndNumbersSamePosition && LayCarouselPluginOptions::$numbersPosition == 'right' && LayCarouselPluginOptions::$captionsPosition == 'right' ) {
                    // if both right, number should be on right side! just my opinion :)
                    $inner = '<div class="sink-caption">'.$current_caption.'</div>'.$numberMarkupInCaption;
                } else {
                    $inner = $numberMarkupInCaption.'<div class="sink-caption">'.$current_caption.'</div>';
                }

                $captionMarkup .= 
                '<div class="single-caption ix-'.$i.' '.$caption_active_class.'"><div class="single-caption-inner _'.LayCarouselPluginOptions::$captionTextformat.'_no_spaces">'
                    .$inner
                .'</div></div>';
            };

            if(LayCarouselPluginFrontend::$config['showNumbers'] && $captionsAndNumbersSamePosition) {
                $allEmpty = false;
            }

            if($allEmpty){
                $captionMarkup = '';
            }else{
                $captionMarkup = '<div class="captions-wrap"><div class="captions-inner"><div class="captions-slider">'.$captionMarkup.'</div></div></div>';
            }
        }

        $sinkClass = LayCarouselPluginFrontend::$config['numbersPosition'].' '.LayCarouselPluginFrontend::$config['captionsPosition'];
        if( LayCarouselPluginFrontend::$config['showNumbers'] && LayCarouselPluginFrontend::$config['showCaptions'] ){
            if($captionMarkup == ''){
                $sinkClass .= " sink-only-numbers";
            }else{
                $sinkClass .= " sink-with-numbers-and-captions";
            }
        }
        else if( LayCarouselPluginFrontend::$config['showNumbers'] ){
            $sinkClass .= " sink-only-numbers";
        }
        else if( LayCarouselPluginFrontend::$config['showCaptions'] ){
            $sinkClass .= " sink-only-captions";
        }


        $numberMarkup = '<span class="numbers _'.LayCarouselPluginOptions::$numberTextformat.'_no_spaces"></span>';
        if( $captionsAndNumbersSamePosition && LayCarouselPluginFrontend::$config['showNumbers'] && LayCarouselPluginFrontend::$config['showCaptions']  ) {
            $numberMarkup = '';
        }

        $sink = '';

        // dont show sink when caption is under slides. the difference here is: a caption is underneath each slide when showing multiple slides at once
        // instead of just a caption in the sink that is updated when the index of the carousel changes
        if( ( LayCarouselPluginFrontend::$config['showNumbers'] || LayCarouselPluginFrontend::$config['showCaptions'] ) && !$captionsUnderSlides ) {
            $sink = 
            '<div class="lay-carousel-sink-parent">'
                .'<div class="lay-carousel-sink '.$sinkClass.'">'
                    .$captionMarkup
                    .$numberMarkup
                .'</div>'
            .'</div>';
        }

        // dots for fadecarousel, only for transition: none, scroll, fade!
        if( LayCarouselPluginOptions::$showCircles && $transition != "sliding" && $enableClickAndDrag){
            $sink .= '<div class="laycarousel-bullets swiper-pagination-bullets">';
            for( $j=0; $j<count($carousel); $j++){
                $sink .= '<li class="swiper-pagination-bullet"></li>';
            }
            $sink .= '</div>';
        }

        $sinkAbove = LayCarouselPluginOptions::$sinkPosition == 'above' ? $sink : '';
        $sinkBelow = '';
        if( LayCarouselPluginOptions::$sinkPosition != 'above' ) {
            $sinkBelow = $sink;
        }
        // # END SINK!


        $relid = array_key_exists('relid', $el) ? $el['relid'] : '';

        $classesWrap .= ' horizontal-alignment-'.LayCarouselPluginOptions::$horizontalAlignment;
        if( array_key_exists('extraclass', $options) ) {
            $classesWrap .= ' '.$options['extraclass'];
        }

        $markup = '<div class="lay-carousel-wrap '.$classesWrap.'">
        '.$sinkAbove.'
        <div class="lay-carousel '.$classesCarousel.'" data-relid="'.$relid.'" '.$autoplayData.' data-transitionspeed="'.$transitionSpeed.'" data-spacebetween="'.$spacebetween.'" ';

        if ( $fixedHeight && $fixedHeight != '100vh' && $captionsUnderSlides == false ) {
            $markup .= 'style="height: calc(' . $fixedHeight . ')"';
        }
        if ( $fixedHeight == null ) {
            $markup .= 'style="padding-bottom:'.$pb.'%;" data-carouselAr="'.$firstAr.'"';
        }
        $markup .= '>';
        $slidesHeight = '';
        if ( $fixedHeight && $captionsUnderSlides ) {
            $slidesHeight = 'height: calc(' . $fixedHeight . ')';
        }
        if( $transition == 'sliding' || $transition == 'immediate' ) {
            $markup .= '<div class="swiper-container swiper"><div class="swiper-wrapper">';
        }
        if( $transition == 'scroll' ) {
            $markup .= '<div class="lay-carousel-scroller"><div class="lay-carousel-scroller-inner">';
        }
        $slideClass = '';
        if( $transition == 'sliding' ) {
            $slideClass = 'swiper-slide';
        }
        $captions = array();
        for( $i=0; $i<count($carousel); $i++ ) {
            $link = '';
            // dont create links for html5 videos because the function that gets the html5 video already creates a link
            if ( array_key_exists('imagelink', $carousel[$i]) && $carousel[$i]['type'] != 'html5video' ) {
                $linkTarget = $carousel[$i]['imagelink']['newtab'] ? ' target="_blank"' : '';
                $url = '';
                if( method_exists( 'LTUtility', 'getFullURL' ) ){
                    $url = LTUtility::getFullURL($carousel[$i]['imagelink']['url']);
                }
                $data_id = '';
                if( array_key_exists('id', $carousel[$i]['imagelink']) && $carousel[$i]['imagelink']['id'] != '' ) {
                    $data_id = 'data-id="'.$carousel[$i]['imagelink']['id'].'"';
                }
                $data_type = '';
                if( array_key_exists('type', $carousel[$i]['imagelink']) && $carousel[$i]['imagelink']['type'] != '' ) {
                    $data_type = 'data-type="'.$carousel[$i]['imagelink']['type'].'"';
                }
                $data_title = '';
                if( array_key_exists('title', $carousel[$i]['imagelink']) && $carousel[$i]['imagelink']['title'] != '' ) {
                    $data_title = 'data-title="'.__($carousel[$i]['imagelink']['title']).'"';
                }
                
                $data_title = '';
                $link = '<a '.$data_id.' '.$data_type.' '.$data_title.' href="'.$url.'" '.$linkTarget.'>';
                if($url== '' || $url == 'null' || $url == null){
                    $link = '';
                }
            }
            // no use in using alt buttons when $enableClickAndDrag is false, bc i dont show any buttons when $enableClickAndDrag is false
            $use_alt_buttons = '';
            if(  array_key_exists('useAltButtons', $carousel[$i]) && $carousel[$i]['useAltButtons'] && $enableClickAndDrag ) {
                $use_alt_buttons = 'lay-use-alt-buttons';
            }
            // todo: add orientation class
            $orientation = '';
            if( array_key_exists('ar', $carousel[$i]) ) {
                $orientation = $carousel[$i]['ar'] < 1 ? 'orientation-landscape' : 'orientation-portrait';
            }

            $markup .= '<div class="lay-carousel-slide '.$orientation.' '.$slideClass.' '.$use_alt_buttons.' lay-carousel-slide-'.$carousel[$i]['type'].'" data-slide-type="'.$carousel[$i]['type'].'" style="'.$slidesWidth.'">';
            $markup .= $link;
            $markup .= '<div class="slide-inner" style="'.$slidesHeight.'">';

            $caption = array_key_exists('caption', $carousel[$i]) ? $carousel[$i]['caption'] : '';
            $captions []= $caption;


            switch( $carousel[$i]['type'] ){
                case 'text':
                    $markup .= LayCarouselPluginFrontend::addText($carousel[$i]);
                break;
                case 'video':
                    $markup .= LayCarouselPluginFrontend::addYouTubeVimeoVideo($carousel[$i]);
                    // need placeholder div for for example: slidesWidth: 400px;, carouselHeight/fixedHeight: auto
                    $markup .= '<div class="ph" style="padding-bottom:'.($carousel[$i]['ar']*100).'%;"></div>';
                break;
                case 'html5video':
                    $markup .= LayCarouselPluginFrontend::addHtml5Video($carousel[$i]);
                    // need placeholder div for for example: slidesWidth: 400px;, carouselHeight/fixedHeight: auto
                    $markup .= '<div class="ph" style="padding-bottom:'.($carousel[$i]['ar']*100).'%;"></div>';
                break;
                case 'img':
                case 'project':
                case 'postThumbnail':
                    $fillSlides = false;
                    if( array_key_exists('fillSlides', $options) && $options['fillSlides'] == true ) {
                        $fillSlides = true;
                    }
                    $markup .= LayCarouselPluginFrontend::addImage($carousel[$i], $fillSlides);
                    // need placeholder div for for example: slidesWidth: 400px;, carouselHeight/fixedHeight: auto
                    $markup .= '<div class="ph" style="padding-bottom:'.($carousel[$i]['ar'] * 100).'%;"></div>';
                break;
            }
            // closing .lay-carousel-slide & link & .slide-inner
            $markup .= '</div>';
            // caption under slide instead of under carousel wrap:
            // just put number inside of here too xD??
            if ( $captionsUnderSlides ) {
                $markup .= 
                '<div class="lay-carousel-caption-under-slide '.LayCarouselPluginFrontend::$config['captionsPosition'].' '.LayCarouselPluginFrontend::$config['numbersPosition'].'">';
                if(LayCarouselPluginFrontend::$config['showNumbers']){
                    $markup .= '<span class="lay-carousel-caption-under-slide-number _'.LayCarouselPluginOptions::$numberTextformat.'_no_spaces">'.($i+1).'/'.count($carousel).'</span>';
                }
                $markup .= 
                    '<div class="lay-carousel-caption-under-slide-caption _'.LayCarouselPluginOptions::$captionTextformat.'_no_spaces">'.$caption.'</div>
                </div>';
            }
            if ($link != '') {
                $markup .= '</a>';
            }
            $markup .= '</div>';
        }
        // closing .lay-carousel
        $markup .= '</div>';

        if( $transition == 'sliding' || $transition == 'immediate' ) {
            // closing swiper container
            $markup .= '</div>';
            // closing swiper wrapper
            $markup .= '</div>';
        }

        if( $transition == 'scroll' ) {
            // closing lay-carousel-scroller and lay-carousel-scroller-inner
            $markup .= '</div></div>';
        }

        $markup .= $sinkBelow;

        // closing .lay-carousel-wrap
        $markup .=
        '</div>';

        // not slide captions but normal caption like a caption for a video/image

        // if show slide captions is false, just show the carousel caption underneath it
        // otherwise im showing the carousel caption just like a slide caption!
        if( array_key_exists('caption', $el) && trim($el['caption'] != '') && LayCarouselPluginFrontend::$config['showCaptions'] == false ) {
            $markup .=
            '<div class="caption lay-textformat-parent">'
                .$el['caption']
            .'</div>';
        }

        if ( $transition == 'fading' ) {
            $markup .= '<style>.lay-carousel.transition-fading[data-relid="'.$relid.'"] .lay-carousel-slide.transition{ 
                -webkit-transition: opacity '.$transitionSpeed.'ms ease-out;
                -o-transition: opacity '.$transitionSpeed.'ms ease-out;
                transition: opacity '.$transitionSpeed.'ms ease-out; }</style>';
        }
        return $markup;
    }
    
    public static function addHtml5Video( $slide ) {

        // not setting autoplay to true because then also html5videos that are not in-view would autoplay
        // function "playPauseHtml5Videos" is autoplaying only in-view videos anyway, so we don't need the autoplay attribute
        // model.set('loop', true);
        // mute is always true, so autoplay can work
        $slide['mute'] = true;
        $slide['playpauseonclick'] = false;
        // how can a user have a video and unmute it?
        // 1: the slider should not go to the next image/video if you click it. only if you swipe it or click on the next/prev buttons
        // 2: the video must not autoplay and the user must click to play it
        // 2: alternative: the video can autoplay but there must be a unmute button
        $slide['autoplay'] = false;
        $slide['controls'] = false;
        $slide['playicon'] = false;
        $showPlaceHolderImage = false;

        // not sure why but firefox doesnt let me lazyload html5videos in carousels when entering the page not by refresh but by coming from a different page on the same lay theme website
        // thats why I do 'noLazyLoad' => true

        // why do i have playpauseonclick here AND in 'model'/$slide ?

        $nolazyload = false;
        if( property_exists('Setup', 'is_firefox') && Setup::$is_firefox == true ) {
            if( property_exists('LayFrontend_Options', 'enable_video_lazyloading_for_firefox') ) {
                if( LayFrontend_Options::$enable_video_lazyloading_for_firefox == false ) {
                    $nolazyload = true;
                }
            } else {
                $nolazyload = true;
            }
        }
        // we ran into issues with safari not lazyloading videos either :/
        if( property_exists('Setup', 'is_safari') && Setup::$is_safari == true ) {
            if( property_exists('LayFrontend_Options', 'enable_video_lazyloading_for_safari') ) {
                if( LayFrontend_Options::$enable_video_lazyloading_for_safari == false ) {
                    $nolazyload = true;
                }
            } else {
                $nolazyload = true;
            }
        }

        $videoConfig = [
            'model' => $slide,
            'captionMarkup' => '',
            'showPlaceholderImage' => $showPlaceHolderImage,
            'usePaddingPlaceholder' => false,
            'playpauseonclick' => false,
            'useWrap' => false,
            'noLazyLoad' => $nolazyload
        ];

        $markup = '';

        if( method_exists( 'LayElFunctions', 'getHTML5VideoMarkup') ) {
            $markup = '<div class="video-slide" data-ar="'.$slide['ar'].'">'.LayElFunctions::getHTML5VideoMarkup($videoConfig).'</div>';
        }

        return $markup;
    }

    public static function addYouTubeVimeoVideo( $slide ){
        return '<div class="youtube-vimeo-video-slide" data-w="'.$slide['w'].'" data-h="'.$slide['h'].'" data-ar="'.$slide['ar'].'">'.$slide['iframe'].'</div>';
    }

    public static function addText( $slide ){
        return '<div class="slide-text lay-textformat-parent">'.$slide['cont'].'</div>';
    }
    
    // adds image or project thumbnail
    public static function addImage( $slide, $fillSlides ){
        $markup = '';
        $srcset = '';
        $sizesToBeFilled = ['_265', '_512', '_768', '_1024', '_1280', '_1920', '_2560', '_3200', '_3840', '_4096'];
        $alt = '';
        $sizes = $slide['sizes'];
        $small = '';
        if( array_key_exists('_265', $sizes ) ){
            $small = $sizes['_265'];
        }else{
            $small = $sizes['full'];
        }
        
        if( method_exists( 'LTUtility', 'getFullURL' ) ) {
            $small = LTUtility::getFullURL($small);
        }
        $fullSrc = $sizes['full'];
        $lastFour = substr($fullSrc, -4);
        if( method_exists( 'LTUtility', 'getFullURL' ) ) {
            $fullSrc = LTUtility::getFullURL($sizes['full']);
        }
        $showOriginal = false;
        if( $lastFour == '.gif' ) {
            $showOriginal = true;
        }
        if( LayFrontend_Options::$misc_options_showoriginalimages && !LTUtility::$isPhone || property_exists('LayFrontend_Options', 'misc_options_showoriginalimages_for_phone') && LayFrontend_Options::$misc_options_showoriginalimages_for_phone && LTUtility::$isPhone ){
            $showOriginal = true;
        }

        // note to myself: i disabled this for now, because it seems like different srcset is set here compared to the img element
        // if( array_key_exists('attid', $slide) ) {
        //     $alt = get_post_meta( $slide['attid'], '_wp_attachment_image_alt', true );
        //     $srcset = wp_get_attachment_image_srcset( $slide['attid'] );
        // }

        // so instead, just this method of creating a srcset is used:

        // there is another freak bug where wp_get_attachment_image_srcset would not use my custom image sizes, but only some 150 and 768 square sizes http://leitform.ch/moschti, so I check if srcset contains _265, and if not create the custom srcset ( strpos($srcset, '265w') === false )
        // there was some freak bug with some website (http://a184.uk/), where wp_get_attachment_image_srcset would always return '' and i could not figure out why, so i do this instead of just else{
        if( $srcset == '' || $srcset == false || !array_key_exists('attid', $slide) || strpos($srcset, '265w') === false ) {
            // $srcset might be set already, because im doing strpos($srcset, '265w') === false, so reset it
            $srcset = '';
            if( array_key_exists('alt', $slide) ) {
                $alt = $slide['alt'];
            }
            foreach($sizes as $key => $value) {
                $key = (string)$key;

                if( array_search($key, $sizesToBeFilled) !== false ) {
                    $src = $value;
                    if( method_exists( 'LTUtility', 'getFullURL' ) ) {
                        $src = LTUtility::getFullURL($src);
                    }
        
                    $srcset = $src.' '.substr($key, 1).'w, ' . $srcset;
                    $ix = array_search($key, $sizesToBeFilled);

                    if($ix !== false){
                        array_splice( $sizesToBeFilled, $ix, 1 );
                    }
                }
            }
            // fill rest of sizes with full image
            for($i=0; $i<count($sizesToBeFilled); $i++){
                $srcset .= $fullSrc.' '.substr($sizesToBeFilled[$i], 1).'w, ';
            }
            $srcset = substr($srcset, 0, -2);
        }

        if( class_exists('MiscOptions') && property_exists('MiscOptions', 'image_alt_tag') ) {
            $alt = $alt.' '.MiscOptions::$image_alt_tag;
        }

        $hasLink = ( $slide['type'] == "project" || $slide['type'] == "postThumbnail" ) ? true : false;
        if( $hasLink ){
            $slideLink = '';
            if( method_exists( 'LTUtility', 'filterURL' ) ) {
                $slideLink = LTUtility::filterURL($slide['link']);
            }
            if( array_key_exists('postid', $slide) ) {
                $slideLink = get_permalink( $slide['postid'] );
            }
            if($slideLink == 'null' || $slideLink == '' || $slideLink == null){
                $hasLink = false;
            } else {
                $markup .= '<a href="'.$slideLink.'" data-title="'.__($slide['title']).'" data-id="'.$slide['postid'].'" data-type="project">';
            }
        }
        // data-aspectratio needed for https://github.com/aFarkas/lazysizes/tree/gh-pages/plugins/parent-fit
        $data_width_data_height_data_ar = '';
        if( array_key_exists('w', $slide) && array_key_exists('h', $slide) && $slide['w'] != 0 && $slide['h'] != 0 ){
            $data_width_data_height_data_ar = 'data-w="'.$slide['w'].'" data-h="'.$slide['h'].'" data-aspectratio="'.( $slide['w'] / $slide['h'] ).'"';
        }else if( array_key_exists('attid', $slide) ){
            // when carousel element is a project thumbnail "w" does not exist, so get w and h differently
            $full = wp_get_attachment_image_src( $slide['attid'], 'full' );
            if( $full != false && $full[1] != 0 && $full[2] != 0 ) {
                $data_width_data_height_data_ar = 'data-w="'.$full[1].'" data-h="'.$full[2].'" data-aspectratio="'.( $full[1] / $full[2] ).'"';
            }
        }
        
        $object_fit_data = $fillSlides ? 'data-parent-fit="cover"' : '';
        $loading_class = 'carousel-instant-img';
        if( LayCarouselPluginOptions::$lazyload == 'on' ) {
            $loading_class = 'carousel-lazy-img';
        }
        // need to do data-lay-src and data-lay-srcset because otherwise lazysizes will load this image if it is cached, even if i dont use a "lazyload" html class
        if( $showOriginal ) {
            $markup .= '<img class="carousel-img '.$loading_class.' carousel-original-img" '.$object_fit_data.' src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-lay-src="'.$fullSrc.'" data-ar="'.$slide['ar'].'" '.$data_width_data_height_data_ar.' alt="'.$alt.'"/>';
        }
        else{
            $markup .= '<img class="carousel-img '.$loading_class.' carousel-responsive-img" '.$object_fit_data.' src="data:image/png;base64,R0lGODlhFAAUAIAAAP///wAAACH5BAEAAAAALAAAAAAUABQAAAIRhI+py+0Po5y02ouz3rz7rxUAOw==" data-lay-src="'.$small.'" data-lay-srcset="'.$srcset.'" data-ar="'.$slide['ar'].'" '.$data_width_data_height_data_ar.' alt="'.$alt.'"/>';
        }
        if( $hasLink ){
            $markup .= '</a>';
        }

        return $markup;
    }

}
new LayCarouselPluginFrontend();